// Licensed to the .NET Foundation under one or more agreements.
// The .NET Foundation licenses this file to you under the MIT license.

/******************************************************************

DO NOT MODIFY. AUTOGENERATED FILE.
This file is generated using the logic from <root>/src/scripts/genEventPipe.py

******************************************************************/

#include <eventpipe/ep-rt-config.h>
#ifdef ENABLE_PERFTRACING
#include <eventpipe/ep.h>
#include <eventpipe/ep-event.h>
#include "clreventpipewriteevents.h"

#ifndef W
#define W(str) L##str
#endif
#ifndef SL
#define SL(str) str
#endif
#ifndef ERROR_SUCCESS
#define ERROR_SUCCESS 0L
#endif
#ifndef ERROR_WRITE_FAULT
#define ERROR_WRITE_FAULT 29L
#endif

/*
 * Forward declares of functions.
 */

bool
resize_buffer (
    uint8_t **buffer,
    size_t *size,
    size_t current_size,
    size_t new_size,
    bool *fixed_buffer);

bool
write_buffer (
    const uint8_t *value,
    size_t value_size,
    uint8_t **buffer,
    size_t *offset,
    size_t *size,
    bool *fixed_buffer);

bool
write_buffer_string_utf8_t (
    const ep_char8_t *value,
    size_t value_len,
    uint8_t **buffer,
    size_t *offset,
    size_t *size,
    bool *fixed_buffer);

bool
write_buffer_string_utf8_to_utf16_t (
    const ep_char8_t *value,
    size_t value_len,
    uint8_t **buffer,
    size_t *offset,
    size_t *size,
    bool *fixed_buffer);

static
inline
bool
write_buffer_guid_t (
    const uint8_t *value,
    uint8_t **buffer,
    size_t *offset,
    size_t *size,
    bool *fixed_buffer)
{
    return write_buffer (value, EP_GUID_SIZE, buffer, offset, size, fixed_buffer);
}

static
inline
bool
write_buffer_uint8_t (
    uint8_t value,
    uint8_t **buffer,
    size_t *offset,
    size_t *size,
    bool *fixed_buffer)
{
    return write_buffer ((const uint8_t *)&value, sizeof (uint8_t), buffer, offset, size, fixed_buffer);
}

static
inline
bool
write_buffer_uint16_t (
    uint16_t value,
    uint8_t **buffer,
    size_t *offset,
    size_t *size,
    bool *fixed_buffer)
{
    value = ep_rt_val_uint16_t (value);
    return write_buffer ((const uint8_t *)&value, sizeof (uint16_t), buffer, offset, size, fixed_buffer);
}

static
inline
bool
write_buffer_uint32_t (
    uint32_t value,
    uint8_t **buffer,
    size_t *offset,
    size_t *size,
    bool *fixed_buffer)
{
    value = ep_rt_val_uint32_t (value);
    return write_buffer ((const uint8_t *)&value, sizeof (uint32_t), buffer, offset, size, fixed_buffer);
}

static
inline
bool
write_buffer_int32_t (
    int32_t value,
    uint8_t **buffer,
    size_t *offset,
    size_t *size,
    bool *fixed_buffer)
{
    value = ep_rt_val_int32_t (value);
    return write_buffer ((const uint8_t *)&value, sizeof (int32_t), buffer, offset, size, fixed_buffer);
}

static
inline
bool
write_buffer_uint64_t (
    uint64_t value,
    uint8_t **buffer,
    size_t *offset,
    size_t *size,
    bool *fixed_buffer)
{
    value = ep_rt_val_uint64_t (value);
    return write_buffer ((const uint8_t *)&value, sizeof (uint64_t), buffer, offset, size, fixed_buffer);
}

static
inline
bool
write_buffer_int64_t (
    int64_t value,
    uint8_t **buffer,
    size_t *offset,
    size_t *size,
    bool *fixed_buffer)
{
    value = ep_rt_val_int64_t (value);
    return write_buffer ((const uint8_t *)&value, sizeof (int64_t), buffer, offset, size, fixed_buffer);
}

static
inline
bool
write_buffer_double_t (
    double value,
    uint8_t **buffer,
    size_t *offset,
    size_t *size,
    bool *fixed_buffer)
{
#if BIGENDIAN
    uint64_t value_as_uint64_t;
    memcpy (&value_as_uint64_t, &value, sizeof (uint64_t));
    value_as_uint64_t = ep_rt_val_uint64_t (value_as_uint64_t);
    memcpy (&value, &value_as_uint64_t, sizeof (uint64_t));
#endif
    return write_buffer ((const uint8_t *)&value, sizeof (double), buffer, offset, size, fixed_buffer);
}

static
inline
bool
write_buffer_bool_t (
    bool value,
    uint8_t **buffer,
    size_t *offset,
    size_t *size,
    bool *fixed_buffer)
{
    return write_buffer_int32_t (value, buffer, offset, size, fixed_buffer);
}

static
inline
bool
write_buffer_uintptr_t (
    uintptr_t value,
    uint8_t **buffer,
    size_t *offset,
    size_t *size,
    bool *fixed_buffer)
{
    value = ep_rt_val_uintptr_t (value);
    return write_buffer ((const uint8_t *)&value, sizeof (uintptr_t), buffer, offset, size, fixed_buffer);
}

static
inline
EventPipeEvent *
provider_add_event (
    EventPipeProvider *provider,
    uint32_t event_id,
    uint64_t keywords,
    uint32_t event_version,
    EventPipeEventLevel level,
    bool need_stack)
{
    return ep_provider_add_event (provider, event_id, keywords, event_version, level, need_stack, NULL, 0);
}

static
inline
EventPipeProvider *
create_provider (
    const wchar_t *provider_name,
    EventPipeCallback callback_func)
{
    ep_char8_t *provider_name_utf8 = NULL;

#if WCHAR_MAX == 0xFFFF
    provider_name_utf8 = g_utf16_to_utf8 ((const gunichar2 *)provider_name, -1, NULL, NULL, NULL);
#else
    provider_name_utf8 = g_ucs4_to_utf8 ((const gunichar *)provider_name, -1, NULL, NULL, NULL);
#endif

    ep_return_null_if_nok (provider_name_utf8 != NULL);

    EventPipeProvider *provider = ep_create_provider (provider_name_utf8, callback_func, NULL);

    g_free (provider_name_utf8);
    return provider;
}

const wchar_t* DotNETRuntimeRundownName = W("Microsoft-Windows-DotNETRuntimeRundown");
EventPipeProvider *EventPipeProviderDotNETRuntimeRundown = NULL;
EventPipeEvent *EventPipeEventMethodDCEnd_V1 = NULL;
EventPipeEvent *EventPipeEventMethodDCEndVerbose_V1 = NULL;
EventPipeEvent *EventPipeEventDCEndComplete_V1 = NULL;
EventPipeEvent *EventPipeEventDCEndInit_V1 = NULL;
EventPipeEvent *EventPipeEventMethodDCEndILToNativeMap = NULL;
EventPipeEvent *EventPipeEventDomainModuleDCEnd_V1 = NULL;
EventPipeEvent *EventPipeEventModuleDCEnd_V2 = NULL;
EventPipeEvent *EventPipeEventAssemblyDCEnd_V1 = NULL;
EventPipeEvent *EventPipeEventAppDomainDCEnd_V1 = NULL;
EventPipeEvent *EventPipeEventRuntimeInformationDCStart = NULL;
EventPipeEvent *EventPipeEventExecutionCheckpointDCEnd = NULL;

bool EventPipeEventEnabledMethodDCEnd_V1(void)
{
    return ep_event_is_enabled(EventPipeEventMethodDCEnd_V1);
}

uint32_t EventPipeWriteEventMethodDCEnd_V1(
    const uint64_t MethodID,
    const uint64_t ModuleID,
    const uint64_t MethodStartAddress,
    const uint32_t MethodSize,
    const uint32_t MethodToken,
    const uint32_t MethodFlags,
    const uint16_t ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId)
{
    if (!EventPipeEventEnabledMethodDCEnd_V1())
        return ERROR_SUCCESS;

    size_t size = 38;
    uint8_t stackBuffer[38];
    uint8_t *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= write_buffer_uint64_t(MethodID, &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_uint64_t(ModuleID, &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_uint64_t(MethodStartAddress, &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_uint32_t(MethodSize, &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_uint32_t(MethodToken, &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_uint32_t(MethodFlags, &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_uint16_t(ClrInstanceID, &buffer, &offset, &size, &fixedBuffer);

    ep_raise_error_if_nok (success);

    ep_write_event (EventPipeEventMethodDCEnd_V1, (uint8_t *)buffer, (uint32_t)offset, ActivityId, RelatedActivityId);

ep_on_exit:
    if (!fixedBuffer)
        ep_rt_byte_array_free (buffer);
    return success ? ERROR_SUCCESS : ERROR_WRITE_FAULT;

ep_on_error:
    EP_ASSERT (!success);
    ep_exit_error_handler ();
}

bool EventPipeEventEnabledMethodDCEndVerbose_V1(void)
{
    return ep_event_is_enabled(EventPipeEventMethodDCEndVerbose_V1);
}

uint32_t EventPipeWriteEventMethodDCEndVerbose_V1(
    const uint64_t MethodID,
    const uint64_t ModuleID,
    const uint64_t MethodStartAddress,
    const uint32_t MethodSize,
    const uint32_t MethodToken,
    const uint32_t MethodFlags,
    const ep_char8_t* MethodNamespace,
    const ep_char8_t* MethodName,
    const ep_char8_t* MethodSignature,
    const uint16_t ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId)
{
    if (!EventPipeEventEnabledMethodDCEndVerbose_V1())
        return ERROR_SUCCESS;

    size_t size = 230;
    uint8_t stackBuffer[230];
    uint8_t *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    if (!MethodNamespace) { MethodNamespace = (const ep_char8_t *)"NULL"; }
    if (!MethodName) { MethodName = (const ep_char8_t *)"NULL"; }
    if (!MethodSignature) { MethodSignature = (const ep_char8_t *)"NULL"; }
    success &= write_buffer_uint64_t(MethodID, &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_uint64_t(ModuleID, &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_uint64_t(MethodStartAddress, &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_uint32_t(MethodSize, &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_uint32_t(MethodToken, &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_uint32_t(MethodFlags, &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_string_utf8_to_utf16_t(MethodNamespace, strlen((const char *)MethodNamespace), &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_string_utf8_to_utf16_t(MethodName, strlen((const char *)MethodName), &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_string_utf8_to_utf16_t(MethodSignature, strlen((const char *)MethodSignature), &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_uint16_t(ClrInstanceID, &buffer, &offset, &size, &fixedBuffer);

    ep_raise_error_if_nok (success);

    ep_write_event (EventPipeEventMethodDCEndVerbose_V1, (uint8_t *)buffer, (uint32_t)offset, ActivityId, RelatedActivityId);

ep_on_exit:
    if (!fixedBuffer)
        ep_rt_byte_array_free (buffer);
    return success ? ERROR_SUCCESS : ERROR_WRITE_FAULT;

ep_on_error:
    EP_ASSERT (!success);
    ep_exit_error_handler ();
}

bool EventPipeEventEnabledDCEndComplete_V1(void)
{
    return ep_event_is_enabled(EventPipeEventDCEndComplete_V1);
}

uint32_t EventPipeWriteEventDCEndComplete_V1(
    const uint16_t ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId)
{
    if (!EventPipeEventEnabledDCEndComplete_V1())
        return ERROR_SUCCESS;

    size_t size = 32;
    uint8_t stackBuffer[32];
    uint8_t *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= write_buffer_uint16_t(ClrInstanceID, &buffer, &offset, &size, &fixedBuffer);

    ep_raise_error_if_nok (success);

    ep_write_event (EventPipeEventDCEndComplete_V1, (uint8_t *)buffer, (uint32_t)offset, ActivityId, RelatedActivityId);

ep_on_exit:
    if (!fixedBuffer)
        ep_rt_byte_array_free (buffer);
    return success ? ERROR_SUCCESS : ERROR_WRITE_FAULT;

ep_on_error:
    EP_ASSERT (!success);
    ep_exit_error_handler ();
}

bool EventPipeEventEnabledDCEndInit_V1(void)
{
    return ep_event_is_enabled(EventPipeEventDCEndInit_V1);
}

uint32_t EventPipeWriteEventDCEndInit_V1(
    const uint16_t ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId)
{
    if (!EventPipeEventEnabledDCEndInit_V1())
        return ERROR_SUCCESS;

    size_t size = 32;
    uint8_t stackBuffer[32];
    uint8_t *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= write_buffer_uint16_t(ClrInstanceID, &buffer, &offset, &size, &fixedBuffer);

    ep_raise_error_if_nok (success);

    ep_write_event (EventPipeEventDCEndInit_V1, (uint8_t *)buffer, (uint32_t)offset, ActivityId, RelatedActivityId);

ep_on_exit:
    if (!fixedBuffer)
        ep_rt_byte_array_free (buffer);
    return success ? ERROR_SUCCESS : ERROR_WRITE_FAULT;

ep_on_error:
    EP_ASSERT (!success);
    ep_exit_error_handler ();
}

bool EventPipeEventEnabledMethodDCEndILToNativeMap(void)
{
    return ep_event_is_enabled(EventPipeEventMethodDCEndILToNativeMap);
}

uint32_t EventPipeWriteEventMethodDCEndILToNativeMap(
    const uint64_t MethodID,
    const uint64_t ReJITID,
    const uint8_t MethodExtent,
    const uint16_t CountOfMapEntries,
    const uint32_t* ILOffsets,
    const uint32_t* NativeOffsets,
    const uint16_t ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId)
{
    if (!EventPipeEventEnabledMethodDCEndILToNativeMap())
        return ERROR_SUCCESS;

    size_t size = 32;
    uint8_t stackBuffer[32];
    uint8_t *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= write_buffer_uint64_t(MethodID, &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_uint64_t(ReJITID, &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_uint8_t(MethodExtent, &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_uint16_t(CountOfMapEntries, &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer((const uint8_t *)ILOffsets, sizeof(const uint32_t) * (int)CountOfMapEntries, &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer((const uint8_t *)NativeOffsets, sizeof(const uint32_t) * (int)CountOfMapEntries, &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_uint16_t(ClrInstanceID, &buffer, &offset, &size, &fixedBuffer);

    ep_raise_error_if_nok (success);

    ep_write_event (EventPipeEventMethodDCEndILToNativeMap, (uint8_t *)buffer, (uint32_t)offset, ActivityId, RelatedActivityId);

ep_on_exit:
    if (!fixedBuffer)
        ep_rt_byte_array_free (buffer);
    return success ? ERROR_SUCCESS : ERROR_WRITE_FAULT;

ep_on_error:
    EP_ASSERT (!success);
    ep_exit_error_handler ();
}

bool EventPipeEventEnabledDomainModuleDCEnd_V1(void)
{
    return ep_event_is_enabled(EventPipeEventDomainModuleDCEnd_V1);
}

uint32_t EventPipeWriteEventDomainModuleDCEnd_V1(
    const uint64_t ModuleID,
    const uint64_t AssemblyID,
    const uint64_t AppDomainID,
    const uint32_t ModuleFlags,
    const uint32_t Reserved1,
    const ep_char8_t* ModuleILPath,
    const ep_char8_t* ModuleNativePath,
    const uint16_t ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId)
{
    if (!EventPipeEventEnabledDomainModuleDCEnd_V1())
        return ERROR_SUCCESS;

    size_t size = 162;
    uint8_t stackBuffer[162];
    uint8_t *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    if (!ModuleILPath) { ModuleILPath = (const ep_char8_t *)"NULL"; }
    if (!ModuleNativePath) { ModuleNativePath = (const ep_char8_t *)"NULL"; }
    success &= write_buffer_uint64_t(ModuleID, &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_uint64_t(AssemblyID, &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_uint64_t(AppDomainID, &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_uint32_t(ModuleFlags, &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_uint32_t(Reserved1, &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_string_utf8_to_utf16_t(ModuleILPath, strlen((const char *)ModuleILPath), &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_string_utf8_to_utf16_t(ModuleNativePath, strlen((const char *)ModuleNativePath), &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_uint16_t(ClrInstanceID, &buffer, &offset, &size, &fixedBuffer);

    ep_raise_error_if_nok (success);

    ep_write_event (EventPipeEventDomainModuleDCEnd_V1, (uint8_t *)buffer, (uint32_t)offset, ActivityId, RelatedActivityId);

ep_on_exit:
    if (!fixedBuffer)
        ep_rt_byte_array_free (buffer);
    return success ? ERROR_SUCCESS : ERROR_WRITE_FAULT;

ep_on_error:
    EP_ASSERT (!success);
    ep_exit_error_handler ();
}

bool EventPipeEventEnabledModuleDCEnd_V2(void)
{
    return ep_event_is_enabled(EventPipeEventModuleDCEnd_V2);
}

uint32_t EventPipeWriteEventModuleDCEnd_V2(
    const uint64_t ModuleID,
    const uint64_t AssemblyID,
    const uint32_t ModuleFlags,
    const uint32_t Reserved1,
    const ep_char8_t* ModuleILPath,
    const ep_char8_t* ModuleNativePath,
    const uint16_t ClrInstanceID,
    const uint8_t* ManagedPdbSignature,
    const uint32_t ManagedPdbAge,
    const ep_char8_t* ManagedPdbBuildPath,
    const uint8_t* NativePdbSignature,
    const uint32_t NativePdbAge,
    const ep_char8_t* NativePdbBuildPath,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId)
{
    if (!EventPipeEventEnabledModuleDCEnd_V2())
        return ERROR_SUCCESS;

    size_t size = 290;
    uint8_t stackBuffer[290];
    uint8_t *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    if (!ModuleILPath) { ModuleILPath = (const ep_char8_t *)"NULL"; }
    if (!ModuleNativePath) { ModuleNativePath = (const ep_char8_t *)"NULL"; }
    if (!ManagedPdbBuildPath) { ManagedPdbBuildPath = (const ep_char8_t *)"NULL"; }
    if (!NativePdbBuildPath) { NativePdbBuildPath = (const ep_char8_t *)"NULL"; }
    success &= write_buffer_uint64_t(ModuleID, &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_uint64_t(AssemblyID, &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_uint32_t(ModuleFlags, &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_uint32_t(Reserved1, &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_string_utf8_to_utf16_t(ModuleILPath, strlen((const char *)ModuleILPath), &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_string_utf8_to_utf16_t(ModuleNativePath, strlen((const char *)ModuleNativePath), &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_uint16_t(ClrInstanceID, &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_guid_t(ManagedPdbSignature, &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_uint32_t(ManagedPdbAge, &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_string_utf8_to_utf16_t(ManagedPdbBuildPath, strlen((const char *)ManagedPdbBuildPath), &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_guid_t(NativePdbSignature, &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_uint32_t(NativePdbAge, &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_string_utf8_to_utf16_t(NativePdbBuildPath, strlen((const char *)NativePdbBuildPath), &buffer, &offset, &size, &fixedBuffer);

    ep_raise_error_if_nok (success);

    ep_write_event (EventPipeEventModuleDCEnd_V2, (uint8_t *)buffer, (uint32_t)offset, ActivityId, RelatedActivityId);

ep_on_exit:
    if (!fixedBuffer)
        ep_rt_byte_array_free (buffer);
    return success ? ERROR_SUCCESS : ERROR_WRITE_FAULT;

ep_on_error:
    EP_ASSERT (!success);
    ep_exit_error_handler ();
}

bool EventPipeEventEnabledAssemblyDCEnd_V1(void)
{
    return ep_event_is_enabled(EventPipeEventAssemblyDCEnd_V1);
}

uint32_t EventPipeWriteEventAssemblyDCEnd_V1(
    const uint64_t AssemblyID,
    const uint64_t AppDomainID,
    const uint64_t BindingID,
    const uint32_t AssemblyFlags,
    const ep_char8_t* FullyQualifiedAssemblyName,
    const uint16_t ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId)
{
    if (!EventPipeEventEnabledAssemblyDCEnd_V1())
        return ERROR_SUCCESS;

    size_t size = 94;
    uint8_t stackBuffer[94];
    uint8_t *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    if (!FullyQualifiedAssemblyName) { FullyQualifiedAssemblyName = (const ep_char8_t *)"NULL"; }
    success &= write_buffer_uint64_t(AssemblyID, &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_uint64_t(AppDomainID, &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_uint64_t(BindingID, &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_uint32_t(AssemblyFlags, &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_string_utf8_to_utf16_t(FullyQualifiedAssemblyName, strlen((const char *)FullyQualifiedAssemblyName), &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_uint16_t(ClrInstanceID, &buffer, &offset, &size, &fixedBuffer);

    ep_raise_error_if_nok (success);

    ep_write_event (EventPipeEventAssemblyDCEnd_V1, (uint8_t *)buffer, (uint32_t)offset, ActivityId, RelatedActivityId);

ep_on_exit:
    if (!fixedBuffer)
        ep_rt_byte_array_free (buffer);
    return success ? ERROR_SUCCESS : ERROR_WRITE_FAULT;

ep_on_error:
    EP_ASSERT (!success);
    ep_exit_error_handler ();
}

bool EventPipeEventEnabledAppDomainDCEnd_V1(void)
{
    return ep_event_is_enabled(EventPipeEventAppDomainDCEnd_V1);
}

uint32_t EventPipeWriteEventAppDomainDCEnd_V1(
    const uint64_t AppDomainID,
    const uint32_t AppDomainFlags,
    const ep_char8_t* AppDomainName,
    const uint32_t AppDomainIndex,
    const uint16_t ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId)
{
    if (!EventPipeEventEnabledAppDomainDCEnd_V1())
        return ERROR_SUCCESS;

    size_t size = 82;
    uint8_t stackBuffer[82];
    uint8_t *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    if (!AppDomainName) { AppDomainName = (const ep_char8_t *)"NULL"; }
    success &= write_buffer_uint64_t(AppDomainID, &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_uint32_t(AppDomainFlags, &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_string_utf8_to_utf16_t(AppDomainName, strlen((const char *)AppDomainName), &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_uint32_t(AppDomainIndex, &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_uint16_t(ClrInstanceID, &buffer, &offset, &size, &fixedBuffer);

    ep_raise_error_if_nok (success);

    ep_write_event (EventPipeEventAppDomainDCEnd_V1, (uint8_t *)buffer, (uint32_t)offset, ActivityId, RelatedActivityId);

ep_on_exit:
    if (!fixedBuffer)
        ep_rt_byte_array_free (buffer);
    return success ? ERROR_SUCCESS : ERROR_WRITE_FAULT;

ep_on_error:
    EP_ASSERT (!success);
    ep_exit_error_handler ();
}

bool EventPipeEventEnabledRuntimeInformationDCStart(void)
{
    return ep_event_is_enabled(EventPipeEventRuntimeInformationDCStart);
}

uint32_t EventPipeWriteEventRuntimeInformationDCStart(
    const uint16_t ClrInstanceID,
    const uint16_t Sku,
    const uint16_t BclMajorVersion,
    const uint16_t BclMinorVersion,
    const uint16_t BclBuildNumber,
    const uint16_t BclQfeNumber,
    const uint16_t VMMajorVersion,
    const uint16_t VMMinorVersion,
    const uint16_t VMBuildNumber,
    const uint16_t VMQfeNumber,
    const uint32_t StartupFlags,
    const uint8_t StartupMode,
    const ep_char8_t* CommandLine,
    const uint8_t* ComObjectGuid,
    const ep_char8_t* RuntimeDllPath,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId)
{
    if (!EventPipeEventEnabledRuntimeInformationDCStart())
        return ERROR_SUCCESS;

    size_t size = 153;
    uint8_t stackBuffer[153];
    uint8_t *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    if (!CommandLine) { CommandLine = (const ep_char8_t *)"NULL"; }
    if (!RuntimeDllPath) { RuntimeDllPath = (const ep_char8_t *)"NULL"; }
    success &= write_buffer_uint16_t(ClrInstanceID, &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_uint16_t(Sku, &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_uint16_t(BclMajorVersion, &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_uint16_t(BclMinorVersion, &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_uint16_t(BclBuildNumber, &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_uint16_t(BclQfeNumber, &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_uint16_t(VMMajorVersion, &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_uint16_t(VMMinorVersion, &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_uint16_t(VMBuildNumber, &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_uint16_t(VMQfeNumber, &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_uint32_t(StartupFlags, &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_uint8_t(StartupMode, &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_string_utf8_to_utf16_t(CommandLine, strlen((const char *)CommandLine), &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_guid_t(ComObjectGuid, &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_string_utf8_to_utf16_t(RuntimeDllPath, strlen((const char *)RuntimeDllPath), &buffer, &offset, &size, &fixedBuffer);

    ep_raise_error_if_nok (success);

    ep_write_event (EventPipeEventRuntimeInformationDCStart, (uint8_t *)buffer, (uint32_t)offset, ActivityId, RelatedActivityId);

ep_on_exit:
    if (!fixedBuffer)
        ep_rt_byte_array_free (buffer);
    return success ? ERROR_SUCCESS : ERROR_WRITE_FAULT;

ep_on_error:
    EP_ASSERT (!success);
    ep_exit_error_handler ();
}

bool EventPipeEventEnabledExecutionCheckpointDCEnd(void)
{
    return ep_event_is_enabled(EventPipeEventExecutionCheckpointDCEnd);
}

uint32_t EventPipeWriteEventExecutionCheckpointDCEnd(
    const uint16_t ClrInstanceID,
    const ep_char8_t* Name,
    const int64_t Timestamp,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId)
{
    if (!EventPipeEventEnabledExecutionCheckpointDCEnd())
        return ERROR_SUCCESS;

    size_t size = 74;
    uint8_t stackBuffer[74];
    uint8_t *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    if (!Name) { Name = (const ep_char8_t *)"NULL"; }
    success &= write_buffer_uint16_t(ClrInstanceID, &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_string_utf8_to_utf16_t(Name, strlen((const char *)Name), &buffer, &offset, &size, &fixedBuffer);
    success &= write_buffer_int64_t(Timestamp, &buffer, &offset, &size, &fixedBuffer);

    ep_raise_error_if_nok (success);

    ep_write_event (EventPipeEventExecutionCheckpointDCEnd, (uint8_t *)buffer, (uint32_t)offset, ActivityId, RelatedActivityId);

ep_on_exit:
    if (!fixedBuffer)
        ep_rt_byte_array_free (buffer);
    return success ? ERROR_SUCCESS : ERROR_WRITE_FAULT;

ep_on_error:
    EP_ASSERT (!success);
    ep_exit_error_handler ();
}

void EP_CALLBACK_CALLTYPE EventPipeEtwCallbackDotNETRuntimeRundown(const uint8_t *, unsigned long, uint8_t, uint64_t, uint64_t, EventFilterDescriptor *, void *);

void InitDotNETRuntimeRundown(void);

void InitDotNETRuntimeRundown(void)
{
    EventPipeProviderDotNETRuntimeRundown = create_provider(SL(DotNETRuntimeRundownName), (EventPipeEtwCallbackDotNETRuntimeRundown));
    EventPipeEventMethodDCEnd_V1 = provider_add_event(EventPipeProviderDotNETRuntimeRundown,142,48,1,EP_EVENT_LEVEL_INFORMATIONAL,true);
    EventPipeEventMethodDCEndVerbose_V1 = provider_add_event(EventPipeProviderDotNETRuntimeRundown,144,48,1,EP_EVENT_LEVEL_INFORMATIONAL,true);
    EventPipeEventDCEndComplete_V1 = provider_add_event(EventPipeProviderDotNETRuntimeRundown,146,131128,1,EP_EVENT_LEVEL_INFORMATIONAL,true);
    EventPipeEventDCEndInit_V1 = provider_add_event(EventPipeProviderDotNETRuntimeRundown,148,131128,1,EP_EVENT_LEVEL_INFORMATIONAL,true);
    EventPipeEventMethodDCEndILToNativeMap = provider_add_event(EventPipeProviderDotNETRuntimeRundown,150,131072,0,EP_EVENT_LEVEL_VERBOSE,true);
    EventPipeEventDomainModuleDCEnd_V1 = provider_add_event(EventPipeProviderDotNETRuntimeRundown,152,8,1,EP_EVENT_LEVEL_INFORMATIONAL,true);
    EventPipeEventModuleDCEnd_V2 = provider_add_event(EventPipeProviderDotNETRuntimeRundown,154,536870920,2,EP_EVENT_LEVEL_INFORMATIONAL,true);
    EventPipeEventAssemblyDCEnd_V1 = provider_add_event(EventPipeProviderDotNETRuntimeRundown,156,8,1,EP_EVENT_LEVEL_INFORMATIONAL,true);
    EventPipeEventAppDomainDCEnd_V1 = provider_add_event(EventPipeProviderDotNETRuntimeRundown,158,8,1,EP_EVENT_LEVEL_INFORMATIONAL,true);
    EventPipeEventRuntimeInformationDCStart = provider_add_event(EventPipeProviderDotNETRuntimeRundown,187,0,0,EP_EVENT_LEVEL_INFORMATIONAL,true);
    EventPipeEventExecutionCheckpointDCEnd = provider_add_event(EventPipeProviderDotNETRuntimeRundown,300,0,0,EP_EVENT_LEVEL_INFORMATIONAL,true);
}
#endif
