
// Licensed to the .NET Foundation under one or more agreements.
// The .NET Foundation licenses this file to you under the MIT license.

/******************************************************************

DO NOT MODIFY. AUTOGENERATED FILE.
This file is generated using the logic from <root>/src/scripts/genEventing.py

******************************************************************/

#ifndef W
#define W(str) L##str
#endif
#ifndef SL
#define SL(str) str
#endif
#ifndef ERROR_SUCCESS
#define ERROR_SUCCESS 0L
#endif
#ifndef ERROR_WRITE_FAULT
#define ERROR_WRITE_FAULT 29L
#endif

#include "clreventpipewriteevents.h"

#if !defined(EVENTPIPE_TRACE_CONTEXT_DEF)
#define EVENTPIPE_TRACE_CONTEXT_DEF
typedef struct _EVENTPIPE_TRACE_CONTEXT
{
    const wchar_t * Name;
    uint8_t Level;
    bool IsEnabled;
    uint64_t EnabledKeywordsBitmask;
} EVENTPIPE_TRACE_CONTEXT, *PEVENTPIPE_TRACE_CONTEXT;
#endif // EVENTPIPE_TRACE_CONTEXT_DEF

static inline bool EventEnabledGCStart(void) {return EventPipeEventEnabledGCStart();}

static inline uint32_t FireEtwGCStart(
    const uint32_t  Count,
    const uint32_t  Reason,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCStart(Count,Reason,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCStart_V1(void) {return EventPipeEventEnabledGCStart_V1();}

static inline uint32_t FireEtwGCStart_V1(
    const uint32_t  Count,
    const uint32_t  Depth,
    const uint32_t  Reason,
    const uint32_t  Type,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCStart_V1(Count,Depth,Reason,Type,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCStart_V2(void) {return EventPipeEventEnabledGCStart_V2();}

static inline uint32_t FireEtwGCStart_V2(
    const uint32_t  Count,
    const uint32_t  Depth,
    const uint32_t  Reason,
    const uint32_t  Type,
    const uint16_t  ClrInstanceID,
    const uint64_t  ClientSequenceNumber,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCStart_V2(Count,Depth,Reason,Type,ClrInstanceID,ClientSequenceNumber,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCEnd(void) {return EventPipeEventEnabledGCEnd();}

static inline uint32_t FireEtwGCEnd(
    const uint32_t  Count,
    const uint16_t  Depth,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCEnd(Count,Depth,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCEnd_V1(void) {return EventPipeEventEnabledGCEnd_V1();}

static inline uint32_t FireEtwGCEnd_V1(
    const uint32_t  Count,
    const uint32_t  Depth,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCEnd_V1(Count,Depth,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCRestartEEEnd(void) {return EventPipeEventEnabledGCRestartEEEnd();}

static inline uint32_t FireEtwGCRestartEEEnd(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCRestartEEEnd(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCRestartEEEnd_V1(void) {return EventPipeEventEnabledGCRestartEEEnd_V1();}

static inline uint32_t FireEtwGCRestartEEEnd_V1(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCRestartEEEnd_V1(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCHeapStats(void) {return EventPipeEventEnabledGCHeapStats();}

static inline uint32_t FireEtwGCHeapStats(
    const uint64_t  GenerationSize0,
    const uint64_t  TotalPromotedSize0,
    const uint64_t  GenerationSize1,
    const uint64_t  TotalPromotedSize1,
    const uint64_t  GenerationSize2,
    const uint64_t  TotalPromotedSize2,
    const uint64_t  GenerationSize3,
    const uint64_t  TotalPromotedSize3,
    const uint64_t  FinalizationPromotedSize,
    const uint64_t  FinalizationPromotedCount,
    const uint32_t  PinnedObjectCount,
    const uint32_t  SinkBlockCount,
    const uint32_t  GCHandleCount,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCHeapStats(GenerationSize0,TotalPromotedSize0,GenerationSize1,TotalPromotedSize1,GenerationSize2,TotalPromotedSize2,GenerationSize3,TotalPromotedSize3,FinalizationPromotedSize,FinalizationPromotedCount,PinnedObjectCount,SinkBlockCount,GCHandleCount,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCHeapStats_V1(void) {return EventPipeEventEnabledGCHeapStats_V1();}

static inline uint32_t FireEtwGCHeapStats_V1(
    const uint64_t  GenerationSize0,
    const uint64_t  TotalPromotedSize0,
    const uint64_t  GenerationSize1,
    const uint64_t  TotalPromotedSize1,
    const uint64_t  GenerationSize2,
    const uint64_t  TotalPromotedSize2,
    const uint64_t  GenerationSize3,
    const uint64_t  TotalPromotedSize3,
    const uint64_t  FinalizationPromotedSize,
    const uint64_t  FinalizationPromotedCount,
    const uint32_t  PinnedObjectCount,
    const uint32_t  SinkBlockCount,
    const uint32_t  GCHandleCount,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCHeapStats_V1(GenerationSize0,TotalPromotedSize0,GenerationSize1,TotalPromotedSize1,GenerationSize2,TotalPromotedSize2,GenerationSize3,TotalPromotedSize3,FinalizationPromotedSize,FinalizationPromotedCount,PinnedObjectCount,SinkBlockCount,GCHandleCount,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCHeapStats_V2(void) {return EventPipeEventEnabledGCHeapStats_V2();}

static inline uint32_t FireEtwGCHeapStats_V2(
    const uint64_t  GenerationSize0,
    const uint64_t  TotalPromotedSize0,
    const uint64_t  GenerationSize1,
    const uint64_t  TotalPromotedSize1,
    const uint64_t  GenerationSize2,
    const uint64_t  TotalPromotedSize2,
    const uint64_t  GenerationSize3,
    const uint64_t  TotalPromotedSize3,
    const uint64_t  FinalizationPromotedSize,
    const uint64_t  FinalizationPromotedCount,
    const uint32_t  PinnedObjectCount,
    const uint32_t  SinkBlockCount,
    const uint32_t  GCHandleCount,
    const uint16_t  ClrInstanceID,
    const uint64_t  GenerationSize4,
    const uint64_t  TotalPromotedSize4,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCHeapStats_V2(GenerationSize0,TotalPromotedSize0,GenerationSize1,TotalPromotedSize1,GenerationSize2,TotalPromotedSize2,GenerationSize3,TotalPromotedSize3,FinalizationPromotedSize,FinalizationPromotedCount,PinnedObjectCount,SinkBlockCount,GCHandleCount,ClrInstanceID,GenerationSize4,TotalPromotedSize4,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCCreateSegment(void) {return EventPipeEventEnabledGCCreateSegment();}

static inline uint32_t FireEtwGCCreateSegment(
    const uint64_t  Address,
    const uint64_t  Size,
    const uint32_t  Type,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCCreateSegment(Address,Size,Type,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCCreateSegment_V1(void) {return EventPipeEventEnabledGCCreateSegment_V1();}

static inline uint32_t FireEtwGCCreateSegment_V1(
    const uint64_t  Address,
    const uint64_t  Size,
    const uint32_t  Type,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCCreateSegment_V1(Address,Size,Type,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCFreeSegment(void) {return EventPipeEventEnabledGCFreeSegment();}

static inline uint32_t FireEtwGCFreeSegment(
    const uint64_t  Address,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCFreeSegment(Address,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCFreeSegment_V1(void) {return EventPipeEventEnabledGCFreeSegment_V1();}

static inline uint32_t FireEtwGCFreeSegment_V1(
    const uint64_t  Address,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCFreeSegment_V1(Address,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCRestartEEBegin(void) {return EventPipeEventEnabledGCRestartEEBegin();}

static inline uint32_t FireEtwGCRestartEEBegin(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCRestartEEBegin(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCRestartEEBegin_V1(void) {return EventPipeEventEnabledGCRestartEEBegin_V1();}

static inline uint32_t FireEtwGCRestartEEBegin_V1(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCRestartEEBegin_V1(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCSuspendEEEnd(void) {return EventPipeEventEnabledGCSuspendEEEnd();}

static inline uint32_t FireEtwGCSuspendEEEnd(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCSuspendEEEnd(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCSuspendEEEnd_V1(void) {return EventPipeEventEnabledGCSuspendEEEnd_V1();}

static inline uint32_t FireEtwGCSuspendEEEnd_V1(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCSuspendEEEnd_V1(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCSuspendEEBegin(void) {return EventPipeEventEnabledGCSuspendEEBegin();}

static inline uint32_t FireEtwGCSuspendEEBegin(
    const uint16_t  Reason,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCSuspendEEBegin(Reason,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCSuspendEEBegin_V1(void) {return EventPipeEventEnabledGCSuspendEEBegin_V1();}

static inline uint32_t FireEtwGCSuspendEEBegin_V1(
    const uint32_t  Reason,
    const uint32_t  Count,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCSuspendEEBegin_V1(Reason,Count,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCAllocationTick(void) {return EventPipeEventEnabledGCAllocationTick();}

static inline uint32_t FireEtwGCAllocationTick(
    const uint32_t  AllocationAmount,
    const uint32_t  AllocationKind,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCAllocationTick(AllocationAmount,AllocationKind,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCAllocationTick_V1(void) {return EventPipeEventEnabledGCAllocationTick_V1();}

static inline uint32_t FireEtwGCAllocationTick_V1(
    const uint32_t  AllocationAmount,
    const uint32_t  AllocationKind,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCAllocationTick_V1(AllocationAmount,AllocationKind,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCAllocationTick_V2(void) {return EventPipeEventEnabledGCAllocationTick_V2();}

static inline uint32_t FireEtwGCAllocationTick_V2(
    const uint32_t  AllocationAmount,
    const uint32_t  AllocationKind,
    const uint16_t  ClrInstanceID,
    const uint64_t  AllocationAmount64,
    const void*  TypeID,
    const ep_char8_t*  TypeName,
    const uint32_t  HeapIndex,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCAllocationTick_V2(AllocationAmount,AllocationKind,ClrInstanceID,AllocationAmount64,TypeID,TypeName,HeapIndex,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCAllocationTick_V3(void) {return EventPipeEventEnabledGCAllocationTick_V3();}

static inline uint32_t FireEtwGCAllocationTick_V3(
    const uint32_t  AllocationAmount,
    const uint32_t  AllocationKind,
    const uint16_t  ClrInstanceID,
    const uint64_t  AllocationAmount64,
    const void*  TypeID,
    const ep_char8_t*  TypeName,
    const uint32_t  HeapIndex,
    const void*  Address,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCAllocationTick_V3(AllocationAmount,AllocationKind,ClrInstanceID,AllocationAmount64,TypeID,TypeName,HeapIndex,Address,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCAllocationTick_V4(void) {return EventPipeEventEnabledGCAllocationTick_V4();}

static inline uint32_t FireEtwGCAllocationTick_V4(
    const uint32_t  AllocationAmount,
    const uint32_t  AllocationKind,
    const uint16_t  ClrInstanceID,
    const uint64_t  AllocationAmount64,
    const void*  TypeID,
    const ep_char8_t*  TypeName,
    const uint32_t  HeapIndex,
    const void*  Address,
    const uint64_t  ObjectSize,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCAllocationTick_V4(AllocationAmount,AllocationKind,ClrInstanceID,AllocationAmount64,TypeID,TypeName,HeapIndex,Address,ObjectSize,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCCreateConcurrentThread(void) {return EventPipeEventEnabledGCCreateConcurrentThread();}

static inline uint32_t FireEtwGCCreateConcurrentThread(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCCreateConcurrentThread(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCCreateConcurrentThread_V1(void) {return EventPipeEventEnabledGCCreateConcurrentThread_V1();}

static inline uint32_t FireEtwGCCreateConcurrentThread_V1(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCCreateConcurrentThread_V1(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCTerminateConcurrentThread(void) {return EventPipeEventEnabledGCTerminateConcurrentThread();}

static inline uint32_t FireEtwGCTerminateConcurrentThread(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCTerminateConcurrentThread(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCTerminateConcurrentThread_V1(void) {return EventPipeEventEnabledGCTerminateConcurrentThread_V1();}

static inline uint32_t FireEtwGCTerminateConcurrentThread_V1(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCTerminateConcurrentThread_V1(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCFinalizersEnd(void) {return EventPipeEventEnabledGCFinalizersEnd();}

static inline uint32_t FireEtwGCFinalizersEnd(
    const uint32_t  Count,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCFinalizersEnd(Count,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCFinalizersEnd_V1(void) {return EventPipeEventEnabledGCFinalizersEnd_V1();}

static inline uint32_t FireEtwGCFinalizersEnd_V1(
    const uint32_t  Count,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCFinalizersEnd_V1(Count,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCFinalizersBegin(void) {return EventPipeEventEnabledGCFinalizersBegin();}

static inline uint32_t FireEtwGCFinalizersBegin(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCFinalizersBegin(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCFinalizersBegin_V1(void) {return EventPipeEventEnabledGCFinalizersBegin_V1();}

static inline uint32_t FireEtwGCFinalizersBegin_V1(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCFinalizersBegin_V1(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledBulkType(void) {return EventPipeEventEnabledBulkType();}

static inline uint32_t FireEtwBulkType(
    const uint32_t  Count,
    const uint16_t  ClrInstanceID,
    int Values_ElementSize,
    const void* Values,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventBulkType(Count,ClrInstanceID,Values_ElementSize, Values,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCBulkRootEdge(void) {return EventPipeEventEnabledGCBulkRootEdge();}

static inline uint32_t FireEtwGCBulkRootEdge(
    const uint32_t  Index,
    const uint32_t  Count,
    const uint16_t  ClrInstanceID,
    int Values_ElementSize,
    const void* Values,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCBulkRootEdge(Index,Count,ClrInstanceID,Values_ElementSize, Values,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCBulkRootConditionalWeakTableElementEdge(void) {return EventPipeEventEnabledGCBulkRootConditionalWeakTableElementEdge();}

static inline uint32_t FireEtwGCBulkRootConditionalWeakTableElementEdge(
    const uint32_t  Index,
    const uint32_t  Count,
    const uint16_t  ClrInstanceID,
    int Values_ElementSize,
    const void* Values,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCBulkRootConditionalWeakTableElementEdge(Index,Count,ClrInstanceID,Values_ElementSize, Values,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCBulkNode(void) {return EventPipeEventEnabledGCBulkNode();}

static inline uint32_t FireEtwGCBulkNode(
    const uint32_t  Index,
    const uint32_t  Count,
    const uint16_t  ClrInstanceID,
    int Values_ElementSize,
    const void* Values,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCBulkNode(Index,Count,ClrInstanceID,Values_ElementSize, Values,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCBulkEdge(void) {return EventPipeEventEnabledGCBulkEdge();}

static inline uint32_t FireEtwGCBulkEdge(
    const uint32_t  Index,
    const uint32_t  Count,
    const uint16_t  ClrInstanceID,
    int Values_ElementSize,
    const void* Values,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCBulkEdge(Index,Count,ClrInstanceID,Values_ElementSize, Values,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCSampledObjectAllocationHigh(void) {return EventPipeEventEnabledGCSampledObjectAllocationHigh();}

static inline uint32_t FireEtwGCSampledObjectAllocationHigh(
    const void*  Address,
    const void*  TypeID,
    const uint32_t  ObjectCountForTypeSample,
    const uint64_t  TotalSizeForTypeSample,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCSampledObjectAllocationHigh(Address,TypeID,ObjectCountForTypeSample,TotalSizeForTypeSample,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCBulkSurvivingObjectRanges(void) {return EventPipeEventEnabledGCBulkSurvivingObjectRanges();}

static inline uint32_t FireEtwGCBulkSurvivingObjectRanges(
    const uint32_t  Index,
    const uint32_t  Count,
    const uint16_t  ClrInstanceID,
    int Values_ElementSize,
    const void* Values,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCBulkSurvivingObjectRanges(Index,Count,ClrInstanceID,Values_ElementSize, Values,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCBulkMovedObjectRanges(void) {return EventPipeEventEnabledGCBulkMovedObjectRanges();}

static inline uint32_t FireEtwGCBulkMovedObjectRanges(
    const uint32_t  Index,
    const uint32_t  Count,
    const uint16_t  ClrInstanceID,
    int Values_ElementSize,
    const void* Values,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCBulkMovedObjectRanges(Index,Count,ClrInstanceID,Values_ElementSize, Values,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCGenerationRange(void) {return EventPipeEventEnabledGCGenerationRange();}

static inline uint32_t FireEtwGCGenerationRange(
    const uint8_t  Generation,
    const void*  RangeStart,
    const uint64_t  RangeUsedLength,
    const uint64_t  RangeReservedLength,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCGenerationRange(Generation,RangeStart,RangeUsedLength,RangeReservedLength,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCMarkStackRoots(void) {return EventPipeEventEnabledGCMarkStackRoots();}

static inline uint32_t FireEtwGCMarkStackRoots(
    const uint32_t  HeapNum,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCMarkStackRoots(HeapNum,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCMarkFinalizeQueueRoots(void) {return EventPipeEventEnabledGCMarkFinalizeQueueRoots();}

static inline uint32_t FireEtwGCMarkFinalizeQueueRoots(
    const uint32_t  HeapNum,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCMarkFinalizeQueueRoots(HeapNum,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCMarkHandles(void) {return EventPipeEventEnabledGCMarkHandles();}

static inline uint32_t FireEtwGCMarkHandles(
    const uint32_t  HeapNum,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCMarkHandles(HeapNum,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCMarkOlderGenerationRoots(void) {return EventPipeEventEnabledGCMarkOlderGenerationRoots();}

static inline uint32_t FireEtwGCMarkOlderGenerationRoots(
    const uint32_t  HeapNum,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCMarkOlderGenerationRoots(HeapNum,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledFinalizeObject(void) {return EventPipeEventEnabledFinalizeObject();}

static inline uint32_t FireEtwFinalizeObject(
    const void*  TypeID,
    const void*  ObjectID,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventFinalizeObject(TypeID,ObjectID,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledSetGCHandle(void) {return EventPipeEventEnabledSetGCHandle();}

static inline uint32_t FireEtwSetGCHandle(
    const void*  HandleID,
    const void*  ObjectID,
    const uint32_t  Kind,
    const uint32_t  Generation,
    const uint64_t  AppDomainID,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventSetGCHandle(HandleID,ObjectID,Kind,Generation,AppDomainID,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledDestroyGCHandle(void) {return EventPipeEventEnabledDestroyGCHandle();}

static inline uint32_t FireEtwDestroyGCHandle(
    const void*  HandleID,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventDestroyGCHandle(HandleID,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCSampledObjectAllocationLow(void) {return EventPipeEventEnabledGCSampledObjectAllocationLow();}

static inline uint32_t FireEtwGCSampledObjectAllocationLow(
    const void*  Address,
    const void*  TypeID,
    const uint32_t  ObjectCountForTypeSample,
    const uint64_t  TotalSizeForTypeSample,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCSampledObjectAllocationLow(Address,TypeID,ObjectCountForTypeSample,TotalSizeForTypeSample,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledPinObjectAtGCTime(void) {return EventPipeEventEnabledPinObjectAtGCTime();}

static inline uint32_t FireEtwPinObjectAtGCTime(
    const void*  HandleID,
    const void*  ObjectID,
    const uint64_t  ObjectSize,
    const ep_char8_t*  TypeName,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventPinObjectAtGCTime(HandleID,ObjectID,ObjectSize,TypeName,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCTriggered(void) {return EventPipeEventEnabledGCTriggered();}

static inline uint32_t FireEtwGCTriggered(
    const uint32_t  Reason,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCTriggered(Reason,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCBulkRootCCW(void) {return EventPipeEventEnabledGCBulkRootCCW();}

static inline uint32_t FireEtwGCBulkRootCCW(
    const uint32_t  Count,
    const uint16_t  ClrInstanceID,
    int Values_ElementSize,
    const void* Values,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCBulkRootCCW(Count,ClrInstanceID,Values_ElementSize, Values,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCBulkRCW(void) {return EventPipeEventEnabledGCBulkRCW();}

static inline uint32_t FireEtwGCBulkRCW(
    const uint32_t  Count,
    const uint16_t  ClrInstanceID,
    int Values_ElementSize,
    const void* Values,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCBulkRCW(Count,ClrInstanceID,Values_ElementSize, Values,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCBulkRootStaticVar(void) {return EventPipeEventEnabledGCBulkRootStaticVar();}

static inline uint32_t FireEtwGCBulkRootStaticVar(
    const uint32_t  Count,
    const uint64_t  AppDomainID,
    const uint16_t  ClrInstanceID,
    int Values_ElementSize,
    const void* Values,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCBulkRootStaticVar(Count,AppDomainID,ClrInstanceID,Values_ElementSize, Values,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCDynamicEvent(void) {return EventPipeEventEnabledGCDynamicEvent();}

static inline uint32_t FireEtwGCDynamicEvent(
    const ep_char8_t*  Name,
    const uint32_t  DataSize,
    const uint8_t* Data,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCDynamicEvent(Name,DataSize,Data,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledWorkerThreadCreate(void) {return EventPipeEventEnabledWorkerThreadCreate();}

static inline uint32_t FireEtwWorkerThreadCreate(
    const uint32_t  WorkerThreadCount,
    const uint32_t  RetiredWorkerThreads,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventWorkerThreadCreate(WorkerThreadCount,RetiredWorkerThreads,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledWorkerThreadTerminate(void) {return EventPipeEventEnabledWorkerThreadTerminate();}

static inline uint32_t FireEtwWorkerThreadTerminate(
    const uint32_t  WorkerThreadCount,
    const uint32_t  RetiredWorkerThreads,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventWorkerThreadTerminate(WorkerThreadCount,RetiredWorkerThreads,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledWorkerThreadRetire(void) {return EventPipeEventEnabledWorkerThreadRetire();}

static inline uint32_t FireEtwWorkerThreadRetire(
    const uint32_t  WorkerThreadCount,
    const uint32_t  RetiredWorkerThreads,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventWorkerThreadRetire(WorkerThreadCount,RetiredWorkerThreads,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledWorkerThreadUnretire(void) {return EventPipeEventEnabledWorkerThreadUnretire();}

static inline uint32_t FireEtwWorkerThreadUnretire(
    const uint32_t  WorkerThreadCount,
    const uint32_t  RetiredWorkerThreads,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventWorkerThreadUnretire(WorkerThreadCount,RetiredWorkerThreads,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledIOThreadCreate(void) {return EventPipeEventEnabledIOThreadCreate();}

static inline uint32_t FireEtwIOThreadCreate(
    const uint32_t  IOThreadCount,
    const uint32_t  RetiredIOThreads,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventIOThreadCreate(IOThreadCount,RetiredIOThreads,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledIOThreadCreate_V1(void) {return EventPipeEventEnabledIOThreadCreate_V1();}

static inline uint32_t FireEtwIOThreadCreate_V1(
    const uint32_t  IOThreadCount,
    const uint32_t  RetiredIOThreads,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventIOThreadCreate_V1(IOThreadCount,RetiredIOThreads,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledIOThreadTerminate(void) {return EventPipeEventEnabledIOThreadTerminate();}

static inline uint32_t FireEtwIOThreadTerminate(
    const uint32_t  IOThreadCount,
    const uint32_t  RetiredIOThreads,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventIOThreadTerminate(IOThreadCount,RetiredIOThreads,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledIOThreadTerminate_V1(void) {return EventPipeEventEnabledIOThreadTerminate_V1();}

static inline uint32_t FireEtwIOThreadTerminate_V1(
    const uint32_t  IOThreadCount,
    const uint32_t  RetiredIOThreads,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventIOThreadTerminate_V1(IOThreadCount,RetiredIOThreads,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledIOThreadRetire(void) {return EventPipeEventEnabledIOThreadRetire();}

static inline uint32_t FireEtwIOThreadRetire(
    const uint32_t  IOThreadCount,
    const uint32_t  RetiredIOThreads,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventIOThreadRetire(IOThreadCount,RetiredIOThreads,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledIOThreadRetire_V1(void) {return EventPipeEventEnabledIOThreadRetire_V1();}

static inline uint32_t FireEtwIOThreadRetire_V1(
    const uint32_t  IOThreadCount,
    const uint32_t  RetiredIOThreads,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventIOThreadRetire_V1(IOThreadCount,RetiredIOThreads,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledIOThreadUnretire(void) {return EventPipeEventEnabledIOThreadUnretire();}

static inline uint32_t FireEtwIOThreadUnretire(
    const uint32_t  IOThreadCount,
    const uint32_t  RetiredIOThreads,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventIOThreadUnretire(IOThreadCount,RetiredIOThreads,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledIOThreadUnretire_V1(void) {return EventPipeEventEnabledIOThreadUnretire_V1();}

static inline uint32_t FireEtwIOThreadUnretire_V1(
    const uint32_t  IOThreadCount,
    const uint32_t  RetiredIOThreads,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventIOThreadUnretire_V1(IOThreadCount,RetiredIOThreads,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledThreadpoolSuspensionSuspendThread(void) {return EventPipeEventEnabledThreadpoolSuspensionSuspendThread();}

static inline uint32_t FireEtwThreadpoolSuspensionSuspendThread(
    const uint32_t  ClrThreadID,
    const uint32_t  CpuUtilization,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventThreadpoolSuspensionSuspendThread(ClrThreadID,CpuUtilization,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledThreadpoolSuspensionResumeThread(void) {return EventPipeEventEnabledThreadpoolSuspensionResumeThread();}

static inline uint32_t FireEtwThreadpoolSuspensionResumeThread(
    const uint32_t  ClrThreadID,
    const uint32_t  CpuUtilization,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventThreadpoolSuspensionResumeThread(ClrThreadID,CpuUtilization,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledThreadPoolWorkerThreadStart(void) {return EventPipeEventEnabledThreadPoolWorkerThreadStart();}

static inline uint32_t FireEtwThreadPoolWorkerThreadStart(
    const uint32_t  ActiveWorkerThreadCount,
    const uint32_t  RetiredWorkerThreadCount,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventThreadPoolWorkerThreadStart(ActiveWorkerThreadCount,RetiredWorkerThreadCount,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledThreadPoolWorkerThreadStop(void) {return EventPipeEventEnabledThreadPoolWorkerThreadStop();}

static inline uint32_t FireEtwThreadPoolWorkerThreadStop(
    const uint32_t  ActiveWorkerThreadCount,
    const uint32_t  RetiredWorkerThreadCount,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventThreadPoolWorkerThreadStop(ActiveWorkerThreadCount,RetiredWorkerThreadCount,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledThreadPoolWorkerThreadRetirementStart(void) {return EventPipeEventEnabledThreadPoolWorkerThreadRetirementStart();}

static inline uint32_t FireEtwThreadPoolWorkerThreadRetirementStart(
    const uint32_t  ActiveWorkerThreadCount,
    const uint32_t  RetiredWorkerThreadCount,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventThreadPoolWorkerThreadRetirementStart(ActiveWorkerThreadCount,RetiredWorkerThreadCount,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledThreadPoolWorkerThreadRetirementStop(void) {return EventPipeEventEnabledThreadPoolWorkerThreadRetirementStop();}

static inline uint32_t FireEtwThreadPoolWorkerThreadRetirementStop(
    const uint32_t  ActiveWorkerThreadCount,
    const uint32_t  RetiredWorkerThreadCount,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventThreadPoolWorkerThreadRetirementStop(ActiveWorkerThreadCount,RetiredWorkerThreadCount,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledThreadPoolWorkerThreadAdjustmentSample(void) {return EventPipeEventEnabledThreadPoolWorkerThreadAdjustmentSample();}

static inline uint32_t FireEtwThreadPoolWorkerThreadAdjustmentSample(
    const double  Throughput,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventThreadPoolWorkerThreadAdjustmentSample(Throughput,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledThreadPoolWorkerThreadAdjustmentAdjustment(void) {return EventPipeEventEnabledThreadPoolWorkerThreadAdjustmentAdjustment();}

static inline uint32_t FireEtwThreadPoolWorkerThreadAdjustmentAdjustment(
    const double  AverageThroughput,
    const uint32_t  NewWorkerThreadCount,
    const uint32_t  Reason,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventThreadPoolWorkerThreadAdjustmentAdjustment(AverageThroughput,NewWorkerThreadCount,Reason,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledThreadPoolWorkerThreadAdjustmentStats(void) {return EventPipeEventEnabledThreadPoolWorkerThreadAdjustmentStats();}

static inline uint32_t FireEtwThreadPoolWorkerThreadAdjustmentStats(
    const double  Duration,
    const double  Throughput,
    const double  ThreadWave,
    const double  ThroughputWave,
    const double  ThroughputErrorEstimate,
    const double  AverageThroughputErrorEstimate,
    const double  ThroughputRatio,
    const double  Confidence,
    const double  NewControlSetting,
    const uint16_t  NewThreadWaveMagnitude,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventThreadPoolWorkerThreadAdjustmentStats(Duration,Throughput,ThreadWave,ThroughputWave,ThroughputErrorEstimate,AverageThroughputErrorEstimate,ThroughputRatio,Confidence,NewControlSetting,NewThreadWaveMagnitude,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledThreadPoolWorkerThreadWait(void) {return EventPipeEventEnabledThreadPoolWorkerThreadWait();}

static inline uint32_t FireEtwThreadPoolWorkerThreadWait(
    const uint32_t  ActiveWorkerThreadCount,
    const uint32_t  RetiredWorkerThreadCount,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventThreadPoolWorkerThreadWait(ActiveWorkerThreadCount,RetiredWorkerThreadCount,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledYieldProcessorMeasurement(void) {return EventPipeEventEnabledYieldProcessorMeasurement();}

static inline uint32_t FireEtwYieldProcessorMeasurement(
    const uint16_t  ClrInstanceID,
    const double  NsPerYield,
    const double  EstablishedNsPerYield,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventYieldProcessorMeasurement(ClrInstanceID,NsPerYield,EstablishedNsPerYield,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledThreadPoolMinMaxThreads(void) {return EventPipeEventEnabledThreadPoolMinMaxThreads();}

static inline uint32_t FireEtwThreadPoolMinMaxThreads(
    const uint16_t  MinWorkerThreads,
    const uint16_t  MaxWorkerThreads,
    const uint16_t  MinIOCompletionThreads,
    const uint16_t  MaxIOCompletionThreads,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventThreadPoolMinMaxThreads(MinWorkerThreads,MaxWorkerThreads,MinIOCompletionThreads,MaxIOCompletionThreads,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledThreadPoolWorkingThreadCount(void) {return EventPipeEventEnabledThreadPoolWorkingThreadCount();}

static inline uint32_t FireEtwThreadPoolWorkingThreadCount(
    const uint32_t  Count,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventThreadPoolWorkingThreadCount(Count,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledThreadPoolEnqueue(void) {return EventPipeEventEnabledThreadPoolEnqueue();}

static inline uint32_t FireEtwThreadPoolEnqueue(
    const void*  WorkID,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventThreadPoolEnqueue(WorkID,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledThreadPoolDequeue(void) {return EventPipeEventEnabledThreadPoolDequeue();}

static inline uint32_t FireEtwThreadPoolDequeue(
    const void*  WorkID,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventThreadPoolDequeue(WorkID,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledThreadPoolIOEnqueue(void) {return EventPipeEventEnabledThreadPoolIOEnqueue();}

static inline uint32_t FireEtwThreadPoolIOEnqueue(
    const void*  NativeOverlapped,
    const void*  Overlapped,
    const bool  MultiDequeues,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventThreadPoolIOEnqueue(NativeOverlapped,Overlapped,MultiDequeues,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledThreadPoolIODequeue(void) {return EventPipeEventEnabledThreadPoolIODequeue();}

static inline uint32_t FireEtwThreadPoolIODequeue(
    const void*  NativeOverlapped,
    const void*  Overlapped,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventThreadPoolIODequeue(NativeOverlapped,Overlapped,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledThreadPoolIOPack(void) {return EventPipeEventEnabledThreadPoolIOPack();}

static inline uint32_t FireEtwThreadPoolIOPack(
    const void*  NativeOverlapped,
    const void*  Overlapped,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventThreadPoolIOPack(NativeOverlapped,Overlapped,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledThreadCreating(void) {return EventPipeEventEnabledThreadCreating();}

static inline uint32_t FireEtwThreadCreating(
    const void*  ID,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventThreadCreating(ID,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledThreadRunning(void) {return EventPipeEventEnabledThreadRunning();}

static inline uint32_t FireEtwThreadRunning(
    const void*  ID,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventThreadRunning(ID,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMethodDetails(void) {return EventPipeEventEnabledMethodDetails();}

static inline uint32_t FireEtwMethodDetails(
    const uint64_t  MethodID,
    const uint64_t  TypeID,
    const uint32_t  MethodToken,
    const uint32_t  TypeParameterCount,
    const uint64_t  LoaderModuleID,
    const uint64_t* TypeParameters,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMethodDetails(MethodID,TypeID,MethodToken,TypeParameterCount,LoaderModuleID,TypeParameters,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledTypeLoadStart(void) {return EventPipeEventEnabledTypeLoadStart();}

static inline uint32_t FireEtwTypeLoadStart(
    const uint32_t  TypeLoadStartID,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventTypeLoadStart(TypeLoadStartID,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledTypeLoadStop(void) {return EventPipeEventEnabledTypeLoadStop();}

static inline uint32_t FireEtwTypeLoadStop(
    const uint32_t  TypeLoadStartID,
    const uint16_t  ClrInstanceID,
    const uint16_t  LoadLevel,
    const uint64_t  TypeID,
    const ep_char8_t*  TypeName,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventTypeLoadStop(TypeLoadStartID,ClrInstanceID,LoadLevel,TypeID,TypeName,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledExceptionThrown(void) {return EventPipeEventEnabledExceptionThrown();}

static inline uint32_t FireEtwExceptionThrown(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventExceptionThrown(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledExceptionThrown_V1(void) {return EventPipeEventEnabledExceptionThrown_V1();}

static inline uint32_t FireEtwExceptionThrown_V1(
    const ep_char8_t*  ExceptionType,
    const ep_char8_t*  ExceptionMessage,
    const void*  ExceptionEIP,
    const uint32_t  ExceptionHRESULT,
    const uint16_t  ExceptionFlags,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventExceptionThrown_V1(ExceptionType,ExceptionMessage,ExceptionEIP,ExceptionHRESULT,ExceptionFlags,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledExceptionCatchStart(void) {return EventPipeEventEnabledExceptionCatchStart();}

static inline uint32_t FireEtwExceptionCatchStart(
    const uint64_t  EntryEIP,
    const uint64_t  MethodID,
    const ep_char8_t*  MethodName,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventExceptionCatchStart(EntryEIP,MethodID,MethodName,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledExceptionCatchStop(void) {return EventPipeEventEnabledExceptionCatchStop();}

static inline uint32_t FireEtwExceptionCatchStop(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventExceptionCatchStop(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledExceptionFinallyStart(void) {return EventPipeEventEnabledExceptionFinallyStart();}

static inline uint32_t FireEtwExceptionFinallyStart(
    const uint64_t  EntryEIP,
    const uint64_t  MethodID,
    const ep_char8_t*  MethodName,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventExceptionFinallyStart(EntryEIP,MethodID,MethodName,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledExceptionFinallyStop(void) {return EventPipeEventEnabledExceptionFinallyStop();}

static inline uint32_t FireEtwExceptionFinallyStop(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventExceptionFinallyStop(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledExceptionFilterStart(void) {return EventPipeEventEnabledExceptionFilterStart();}

static inline uint32_t FireEtwExceptionFilterStart(
    const uint64_t  EntryEIP,
    const uint64_t  MethodID,
    const ep_char8_t*  MethodName,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventExceptionFilterStart(EntryEIP,MethodID,MethodName,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledExceptionFilterStop(void) {return EventPipeEventEnabledExceptionFilterStop();}

static inline uint32_t FireEtwExceptionFilterStop(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventExceptionFilterStop(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledExceptionThrownStop(void) {return EventPipeEventEnabledExceptionThrownStop();}

static inline uint32_t FireEtwExceptionThrownStop(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventExceptionThrownStop(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledContention(void) {return EventPipeEventEnabledContention();}

static inline uint32_t FireEtwContention(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventContention(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledContentionStart_V1(void) {return EventPipeEventEnabledContentionStart_V1();}

static inline uint32_t FireEtwContentionStart_V1(
    const uint8_t  ContentionFlags,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventContentionStart_V1(ContentionFlags,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledContentionStart_V2(void) {return EventPipeEventEnabledContentionStart_V2();}

static inline uint32_t FireEtwContentionStart_V2(
    const uint8_t  ContentionFlags,
    const uint16_t  ClrInstanceID,
    const void*  LockID,
    const void*  AssociatedObjectID,
    const uint64_t  LockOwnerThreadID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventContentionStart_V2(ContentionFlags,ClrInstanceID,LockID,AssociatedObjectID,LockOwnerThreadID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledContentionStop(void) {return EventPipeEventEnabledContentionStop();}

static inline uint32_t FireEtwContentionStop(
    const uint8_t  ContentionFlags,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventContentionStop(ContentionFlags,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledContentionStop_V1(void) {return EventPipeEventEnabledContentionStop_V1();}

static inline uint32_t FireEtwContentionStop_V1(
    const uint8_t  ContentionFlags,
    const uint16_t  ClrInstanceID,
    const double  DurationNs,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventContentionStop_V1(ContentionFlags,ClrInstanceID,DurationNs,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledContentionLockCreated(void) {return EventPipeEventEnabledContentionLockCreated();}

static inline uint32_t FireEtwContentionLockCreated(
    const void*  LockID,
    const void*  AssociatedObjectID,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventContentionLockCreated(LockID,AssociatedObjectID,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledCLRStackWalk(void) {return EventPipeEventEnabledCLRStackWalk();}

static inline uint32_t FireEtwCLRStackWalk(
    const uint16_t  ClrInstanceID,
    const uint8_t  Reserved1,
    const uint8_t  Reserved2,
    const uint32_t  FrameCount,
    const void** Stack,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventCLRStackWalk(ClrInstanceID,Reserved1,Reserved2,FrameCount,Stack,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledAppDomainMemAllocated(void) {return EventPipeEventEnabledAppDomainMemAllocated();}

static inline uint32_t FireEtwAppDomainMemAllocated(
    const uint64_t  AppDomainID,
    const uint64_t  Allocated,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventAppDomainMemAllocated(AppDomainID,Allocated,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledAppDomainMemSurvived(void) {return EventPipeEventEnabledAppDomainMemSurvived();}

static inline uint32_t FireEtwAppDomainMemSurvived(
    const uint64_t  AppDomainID,
    const uint64_t  Survived,
    const uint64_t  ProcessSurvived,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventAppDomainMemSurvived(AppDomainID,Survived,ProcessSurvived,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledThreadCreated(void) {return EventPipeEventEnabledThreadCreated();}

static inline uint32_t FireEtwThreadCreated(
    const uint64_t  ManagedThreadID,
    const uint64_t  AppDomainID,
    const uint32_t  Flags,
    const uint32_t  ManagedThreadIndex,
    const uint32_t  OSThreadID,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventThreadCreated(ManagedThreadID,AppDomainID,Flags,ManagedThreadIndex,OSThreadID,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledThreadTerminated(void) {return EventPipeEventEnabledThreadTerminated();}

static inline uint32_t FireEtwThreadTerminated(
    const uint64_t  ManagedThreadID,
    const uint64_t  AppDomainID,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventThreadTerminated(ManagedThreadID,AppDomainID,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledThreadDomainEnter(void) {return EventPipeEventEnabledThreadDomainEnter();}

static inline uint32_t FireEtwThreadDomainEnter(
    const uint64_t  ManagedThreadID,
    const uint64_t  AppDomainID,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventThreadDomainEnter(ManagedThreadID,AppDomainID,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledILStubGenerated(void) {return EventPipeEventEnabledILStubGenerated();}

static inline uint32_t FireEtwILStubGenerated(
    const uint16_t  ClrInstanceID,
    const uint64_t  ModuleID,
    const uint64_t  StubMethodID,
    const uint32_t  StubFlags,
    const uint32_t  ManagedInteropMethodToken,
    const ep_char8_t*  ManagedInteropMethodNamespace,
    const ep_char8_t*  ManagedInteropMethodName,
    const ep_char8_t*  ManagedInteropMethodSignature,
    const ep_char8_t*  NativeMethodSignature,
    const ep_char8_t*  StubMethodSignature,
    const ep_char8_t*  StubMethodILCode,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventILStubGenerated(ClrInstanceID,ModuleID,StubMethodID,StubFlags,ManagedInteropMethodToken,ManagedInteropMethodNamespace,ManagedInteropMethodName,ManagedInteropMethodSignature,NativeMethodSignature,StubMethodSignature,StubMethodILCode,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledILStubCacheHit(void) {return EventPipeEventEnabledILStubCacheHit();}

static inline uint32_t FireEtwILStubCacheHit(
    const uint16_t  ClrInstanceID,
    const uint64_t  ModuleID,
    const uint64_t  StubMethodID,
    const uint32_t  ManagedInteropMethodToken,
    const ep_char8_t*  ManagedInteropMethodNamespace,
    const ep_char8_t*  ManagedInteropMethodName,
    const ep_char8_t*  ManagedInteropMethodSignature,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventILStubCacheHit(ClrInstanceID,ModuleID,StubMethodID,ManagedInteropMethodToken,ManagedInteropMethodNamespace,ManagedInteropMethodName,ManagedInteropMethodSignature,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledDCStartCompleteV2(void) {return EventPipeEventEnabledDCStartCompleteV2();}

static inline uint32_t FireEtwDCStartCompleteV2(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventDCStartCompleteV2(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledDCEndCompleteV2(void) {return EventPipeEventEnabledDCEndCompleteV2();}

static inline uint32_t FireEtwDCEndCompleteV2(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventDCEndCompleteV2(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMethodDCStartV2(void) {return EventPipeEventEnabledMethodDCStartV2();}

static inline uint32_t FireEtwMethodDCStartV2(
    const uint64_t  MethodID,
    const uint64_t  ModuleID,
    const uint64_t  MethodStartAddress,
    const uint32_t  MethodSize,
    const uint32_t  MethodToken,
    const uint32_t  MethodFlags,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMethodDCStartV2(MethodID,ModuleID,MethodStartAddress,MethodSize,MethodToken,MethodFlags,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMethodDCEndV2(void) {return EventPipeEventEnabledMethodDCEndV2();}

static inline uint32_t FireEtwMethodDCEndV2(
    const uint64_t  MethodID,
    const uint64_t  ModuleID,
    const uint64_t  MethodStartAddress,
    const uint32_t  MethodSize,
    const uint32_t  MethodToken,
    const uint32_t  MethodFlags,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMethodDCEndV2(MethodID,ModuleID,MethodStartAddress,MethodSize,MethodToken,MethodFlags,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMethodDCStartVerboseV2(void) {return EventPipeEventEnabledMethodDCStartVerboseV2();}

static inline uint32_t FireEtwMethodDCStartVerboseV2(
    const uint64_t  MethodID,
    const uint64_t  ModuleID,
    const uint64_t  MethodStartAddress,
    const uint32_t  MethodSize,
    const uint32_t  MethodToken,
    const uint32_t  MethodFlags,
    const ep_char8_t*  MethodNamespace,
    const ep_char8_t*  MethodName,
    const ep_char8_t*  MethodSignature,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMethodDCStartVerboseV2(MethodID,ModuleID,MethodStartAddress,MethodSize,MethodToken,MethodFlags,MethodNamespace,MethodName,MethodSignature,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMethodDCEndVerboseV2(void) {return EventPipeEventEnabledMethodDCEndVerboseV2();}

static inline uint32_t FireEtwMethodDCEndVerboseV2(
    const uint64_t  MethodID,
    const uint64_t  ModuleID,
    const uint64_t  MethodStartAddress,
    const uint32_t  MethodSize,
    const uint32_t  MethodToken,
    const uint32_t  MethodFlags,
    const ep_char8_t*  MethodNamespace,
    const ep_char8_t*  MethodName,
    const ep_char8_t*  MethodSignature,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMethodDCEndVerboseV2(MethodID,ModuleID,MethodStartAddress,MethodSize,MethodToken,MethodFlags,MethodNamespace,MethodName,MethodSignature,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMethodLoad(void) {return EventPipeEventEnabledMethodLoad();}

static inline uint32_t FireEtwMethodLoad(
    const uint64_t  MethodID,
    const uint64_t  ModuleID,
    const uint64_t  MethodStartAddress,
    const uint32_t  MethodSize,
    const uint32_t  MethodToken,
    const uint32_t  MethodFlags,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMethodLoad(MethodID,ModuleID,MethodStartAddress,MethodSize,MethodToken,MethodFlags,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMethodLoad_V1(void) {return EventPipeEventEnabledMethodLoad_V1();}

static inline uint32_t FireEtwMethodLoad_V1(
    const uint64_t  MethodID,
    const uint64_t  ModuleID,
    const uint64_t  MethodStartAddress,
    const uint32_t  MethodSize,
    const uint32_t  MethodToken,
    const uint32_t  MethodFlags,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMethodLoad_V1(MethodID,ModuleID,MethodStartAddress,MethodSize,MethodToken,MethodFlags,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMethodLoad_V2(void) {return EventPipeEventEnabledMethodLoad_V2();}

static inline uint32_t FireEtwMethodLoad_V2(
    const uint64_t  MethodID,
    const uint64_t  ModuleID,
    const uint64_t  MethodStartAddress,
    const uint32_t  MethodSize,
    const uint32_t  MethodToken,
    const uint32_t  MethodFlags,
    const uint16_t  ClrInstanceID,
    const uint64_t  ReJITID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMethodLoad_V2(MethodID,ModuleID,MethodStartAddress,MethodSize,MethodToken,MethodFlags,ClrInstanceID,ReJITID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledR2RGetEntryPoint(void) {return EventPipeEventEnabledR2RGetEntryPoint();}

static inline uint32_t FireEtwR2RGetEntryPoint(
    const uint64_t  MethodID,
    const ep_char8_t*  MethodNamespace,
    const ep_char8_t*  MethodName,
    const ep_char8_t*  MethodSignature,
    const uint64_t  EntryPoint,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventR2RGetEntryPoint(MethodID,MethodNamespace,MethodName,MethodSignature,EntryPoint,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledR2RGetEntryPointStart(void) {return EventPipeEventEnabledR2RGetEntryPointStart();}

static inline uint32_t FireEtwR2RGetEntryPointStart(
    const uint64_t  MethodID,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventR2RGetEntryPointStart(MethodID,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMethodUnload(void) {return EventPipeEventEnabledMethodUnload();}

static inline uint32_t FireEtwMethodUnload(
    const uint64_t  MethodID,
    const uint64_t  ModuleID,
    const uint64_t  MethodStartAddress,
    const uint32_t  MethodSize,
    const uint32_t  MethodToken,
    const uint32_t  MethodFlags,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMethodUnload(MethodID,ModuleID,MethodStartAddress,MethodSize,MethodToken,MethodFlags,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMethodUnload_V1(void) {return EventPipeEventEnabledMethodUnload_V1();}

static inline uint32_t FireEtwMethodUnload_V1(
    const uint64_t  MethodID,
    const uint64_t  ModuleID,
    const uint64_t  MethodStartAddress,
    const uint32_t  MethodSize,
    const uint32_t  MethodToken,
    const uint32_t  MethodFlags,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMethodUnload_V1(MethodID,ModuleID,MethodStartAddress,MethodSize,MethodToken,MethodFlags,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMethodUnload_V2(void) {return EventPipeEventEnabledMethodUnload_V2();}

static inline uint32_t FireEtwMethodUnload_V2(
    const uint64_t  MethodID,
    const uint64_t  ModuleID,
    const uint64_t  MethodStartAddress,
    const uint32_t  MethodSize,
    const uint32_t  MethodToken,
    const uint32_t  MethodFlags,
    const uint16_t  ClrInstanceID,
    const uint64_t  ReJITID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMethodUnload_V2(MethodID,ModuleID,MethodStartAddress,MethodSize,MethodToken,MethodFlags,ClrInstanceID,ReJITID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMethodLoadVerbose(void) {return EventPipeEventEnabledMethodLoadVerbose();}

static inline uint32_t FireEtwMethodLoadVerbose(
    const uint64_t  MethodID,
    const uint64_t  ModuleID,
    const uint64_t  MethodStartAddress,
    const uint32_t  MethodSize,
    const uint32_t  MethodToken,
    const uint32_t  MethodFlags,
    const ep_char8_t*  MethodNamespace,
    const ep_char8_t*  MethodName,
    const ep_char8_t*  MethodSignature,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMethodLoadVerbose(MethodID,ModuleID,MethodStartAddress,MethodSize,MethodToken,MethodFlags,MethodNamespace,MethodName,MethodSignature,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMethodLoadVerbose_V1(void) {return EventPipeEventEnabledMethodLoadVerbose_V1();}

static inline uint32_t FireEtwMethodLoadVerbose_V1(
    const uint64_t  MethodID,
    const uint64_t  ModuleID,
    const uint64_t  MethodStartAddress,
    const uint32_t  MethodSize,
    const uint32_t  MethodToken,
    const uint32_t  MethodFlags,
    const ep_char8_t*  MethodNamespace,
    const ep_char8_t*  MethodName,
    const ep_char8_t*  MethodSignature,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMethodLoadVerbose_V1(MethodID,ModuleID,MethodStartAddress,MethodSize,MethodToken,MethodFlags,MethodNamespace,MethodName,MethodSignature,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMethodLoadVerbose_V2(void) {return EventPipeEventEnabledMethodLoadVerbose_V2();}

static inline uint32_t FireEtwMethodLoadVerbose_V2(
    const uint64_t  MethodID,
    const uint64_t  ModuleID,
    const uint64_t  MethodStartAddress,
    const uint32_t  MethodSize,
    const uint32_t  MethodToken,
    const uint32_t  MethodFlags,
    const ep_char8_t*  MethodNamespace,
    const ep_char8_t*  MethodName,
    const ep_char8_t*  MethodSignature,
    const uint16_t  ClrInstanceID,
    const uint64_t  ReJITID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMethodLoadVerbose_V2(MethodID,ModuleID,MethodStartAddress,MethodSize,MethodToken,MethodFlags,MethodNamespace,MethodName,MethodSignature,ClrInstanceID,ReJITID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMethodUnloadVerbose(void) {return EventPipeEventEnabledMethodUnloadVerbose();}

static inline uint32_t FireEtwMethodUnloadVerbose(
    const uint64_t  MethodID,
    const uint64_t  ModuleID,
    const uint64_t  MethodStartAddress,
    const uint32_t  MethodSize,
    const uint32_t  MethodToken,
    const uint32_t  MethodFlags,
    const ep_char8_t*  MethodNamespace,
    const ep_char8_t*  MethodName,
    const ep_char8_t*  MethodSignature,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMethodUnloadVerbose(MethodID,ModuleID,MethodStartAddress,MethodSize,MethodToken,MethodFlags,MethodNamespace,MethodName,MethodSignature,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMethodUnloadVerbose_V1(void) {return EventPipeEventEnabledMethodUnloadVerbose_V1();}

static inline uint32_t FireEtwMethodUnloadVerbose_V1(
    const uint64_t  MethodID,
    const uint64_t  ModuleID,
    const uint64_t  MethodStartAddress,
    const uint32_t  MethodSize,
    const uint32_t  MethodToken,
    const uint32_t  MethodFlags,
    const ep_char8_t*  MethodNamespace,
    const ep_char8_t*  MethodName,
    const ep_char8_t*  MethodSignature,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMethodUnloadVerbose_V1(MethodID,ModuleID,MethodStartAddress,MethodSize,MethodToken,MethodFlags,MethodNamespace,MethodName,MethodSignature,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMethodUnloadVerbose_V2(void) {return EventPipeEventEnabledMethodUnloadVerbose_V2();}

static inline uint32_t FireEtwMethodUnloadVerbose_V2(
    const uint64_t  MethodID,
    const uint64_t  ModuleID,
    const uint64_t  MethodStartAddress,
    const uint32_t  MethodSize,
    const uint32_t  MethodToken,
    const uint32_t  MethodFlags,
    const ep_char8_t*  MethodNamespace,
    const ep_char8_t*  MethodName,
    const ep_char8_t*  MethodSignature,
    const uint16_t  ClrInstanceID,
    const uint64_t  ReJITID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMethodUnloadVerbose_V2(MethodID,ModuleID,MethodStartAddress,MethodSize,MethodToken,MethodFlags,MethodNamespace,MethodName,MethodSignature,ClrInstanceID,ReJITID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMethodJittingStarted(void) {return EventPipeEventEnabledMethodJittingStarted();}

static inline uint32_t FireEtwMethodJittingStarted(
    const uint64_t  MethodID,
    const uint64_t  ModuleID,
    const uint32_t  MethodToken,
    const uint32_t  MethodILSize,
    const ep_char8_t*  MethodNamespace,
    const ep_char8_t*  MethodName,
    const ep_char8_t*  MethodSignature,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMethodJittingStarted(MethodID,ModuleID,MethodToken,MethodILSize,MethodNamespace,MethodName,MethodSignature,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMethodJittingStarted_V1(void) {return EventPipeEventEnabledMethodJittingStarted_V1();}

static inline uint32_t FireEtwMethodJittingStarted_V1(
    const uint64_t  MethodID,
    const uint64_t  ModuleID,
    const uint32_t  MethodToken,
    const uint32_t  MethodILSize,
    const ep_char8_t*  MethodNamespace,
    const ep_char8_t*  MethodName,
    const ep_char8_t*  MethodSignature,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMethodJittingStarted_V1(MethodID,ModuleID,MethodToken,MethodILSize,MethodNamespace,MethodName,MethodSignature,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMethodJitMemoryAllocatedForCode(void) {return EventPipeEventEnabledMethodJitMemoryAllocatedForCode();}

static inline uint32_t FireEtwMethodJitMemoryAllocatedForCode(
    const uint64_t  MethodID,
    const uint64_t  ModuleID,
    const uint64_t  JitHotCodeRequestSize,
    const uint64_t  JitRODataRequestSize,
    const uint64_t  AllocatedSizeForJitCode,
    const uint32_t  JitAllocFlag,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMethodJitMemoryAllocatedForCode(MethodID,ModuleID,JitHotCodeRequestSize,JitRODataRequestSize,AllocatedSizeForJitCode,JitAllocFlag,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMethodJitInliningSucceeded(void) {return EventPipeEventEnabledMethodJitInliningSucceeded();}

static inline uint32_t FireEtwMethodJitInliningSucceeded(
    const ep_char8_t*  MethodBeingCompiledNamespace,
    const ep_char8_t*  MethodBeingCompiledName,
    const ep_char8_t*  MethodBeingCompiledNameSignature,
    const ep_char8_t*  InlinerNamespace,
    const ep_char8_t*  InlinerName,
    const ep_char8_t*  InlinerNameSignature,
    const ep_char8_t*  InlineeNamespace,
    const ep_char8_t*  InlineeName,
    const ep_char8_t*  InlineeNameSignature,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMethodJitInliningSucceeded(MethodBeingCompiledNamespace,MethodBeingCompiledName,MethodBeingCompiledNameSignature,InlinerNamespace,InlinerName,InlinerNameSignature,InlineeNamespace,InlineeName,InlineeNameSignature,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMethodJitInliningFailedAnsi(void) {return EventPipeEventEnabledMethodJitInliningFailedAnsi();}

static inline uint32_t FireEtwMethodJitInliningFailedAnsi(
    const ep_char8_t*  MethodBeingCompiledNamespace,
    const ep_char8_t*  MethodBeingCompiledName,
    const ep_char8_t*  MethodBeingCompiledNameSignature,
    const ep_char8_t*  InlinerNamespace,
    const ep_char8_t*  InlinerName,
    const ep_char8_t*  InlinerNameSignature,
    const ep_char8_t*  InlineeNamespace,
    const ep_char8_t*  InlineeName,
    const ep_char8_t*  InlineeNameSignature,
    const bool  FailAlways,
    const char*  FailReason,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMethodJitInliningFailedAnsi(MethodBeingCompiledNamespace,MethodBeingCompiledName,MethodBeingCompiledNameSignature,InlinerNamespace,InlinerName,InlinerNameSignature,InlineeNamespace,InlineeName,InlineeNameSignature,FailAlways,FailReason,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMethodJitTailCallSucceeded(void) {return EventPipeEventEnabledMethodJitTailCallSucceeded();}

static inline uint32_t FireEtwMethodJitTailCallSucceeded(
    const ep_char8_t*  MethodBeingCompiledNamespace,
    const ep_char8_t*  MethodBeingCompiledName,
    const ep_char8_t*  MethodBeingCompiledNameSignature,
    const ep_char8_t*  CallerNamespace,
    const ep_char8_t*  CallerName,
    const ep_char8_t*  CallerNameSignature,
    const ep_char8_t*  CalleeNamespace,
    const ep_char8_t*  CalleeName,
    const ep_char8_t*  CalleeNameSignature,
    const bool  TailPrefix,
    const uint32_t  TailCallType,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMethodJitTailCallSucceeded(MethodBeingCompiledNamespace,MethodBeingCompiledName,MethodBeingCompiledNameSignature,CallerNamespace,CallerName,CallerNameSignature,CalleeNamespace,CalleeName,CalleeNameSignature,TailPrefix,TailCallType,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMethodJitTailCallFailedAnsi(void) {return EventPipeEventEnabledMethodJitTailCallFailedAnsi();}

static inline uint32_t FireEtwMethodJitTailCallFailedAnsi(
    const ep_char8_t*  MethodBeingCompiledNamespace,
    const ep_char8_t*  MethodBeingCompiledName,
    const ep_char8_t*  MethodBeingCompiledNameSignature,
    const ep_char8_t*  CallerNamespace,
    const ep_char8_t*  CallerName,
    const ep_char8_t*  CallerNameSignature,
    const ep_char8_t*  CalleeNamespace,
    const ep_char8_t*  CalleeName,
    const ep_char8_t*  CalleeNameSignature,
    const bool  TailPrefix,
    const char*  FailReason,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMethodJitTailCallFailedAnsi(MethodBeingCompiledNamespace,MethodBeingCompiledName,MethodBeingCompiledNameSignature,CallerNamespace,CallerName,CallerNameSignature,CalleeNamespace,CalleeName,CalleeNameSignature,TailPrefix,FailReason,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMethodILToNativeMap(void) {return EventPipeEventEnabledMethodILToNativeMap();}

static inline uint32_t FireEtwMethodILToNativeMap(
    const uint64_t  MethodID,
    const uint64_t  ReJITID,
    const uint8_t  MethodExtent,
    const uint16_t  CountOfMapEntries,
    const uint32_t* ILOffsets,
    const uint32_t* NativeOffsets,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMethodILToNativeMap(MethodID,ReJITID,MethodExtent,CountOfMapEntries,ILOffsets,NativeOffsets,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMethodILToNativeMap_V1(void) {return EventPipeEventEnabledMethodILToNativeMap_V1();}

static inline uint32_t FireEtwMethodILToNativeMap_V1(
    const uint64_t  MethodID,
    const uint64_t  ReJITID,
    const uint8_t  MethodExtent,
    const uint16_t  CountOfMapEntries,
    const uint32_t* ILOffsets,
    const uint32_t* NativeOffsets,
    const uint16_t  ClrInstanceID,
    const uint64_t  ILVersionID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMethodILToNativeMap_V1(MethodID,ReJITID,MethodExtent,CountOfMapEntries,ILOffsets,NativeOffsets,ClrInstanceID,ILVersionID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMethodJitTailCallFailed(void) {return EventPipeEventEnabledMethodJitTailCallFailed();}

static inline uint32_t FireEtwMethodJitTailCallFailed(
    const ep_char8_t*  MethodBeingCompiledNamespace,
    const ep_char8_t*  MethodBeingCompiledName,
    const ep_char8_t*  MethodBeingCompiledNameSignature,
    const ep_char8_t*  CallerNamespace,
    const ep_char8_t*  CallerName,
    const ep_char8_t*  CallerNameSignature,
    const ep_char8_t*  CalleeNamespace,
    const ep_char8_t*  CalleeName,
    const ep_char8_t*  CalleeNameSignature,
    const bool  TailPrefix,
    const ep_char8_t*  FailReason,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMethodJitTailCallFailed(MethodBeingCompiledNamespace,MethodBeingCompiledName,MethodBeingCompiledNameSignature,CallerNamespace,CallerName,CallerNameSignature,CalleeNamespace,CalleeName,CalleeNameSignature,TailPrefix,FailReason,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMethodJitInliningFailed(void) {return EventPipeEventEnabledMethodJitInliningFailed();}

static inline uint32_t FireEtwMethodJitInliningFailed(
    const ep_char8_t*  MethodBeingCompiledNamespace,
    const ep_char8_t*  MethodBeingCompiledName,
    const ep_char8_t*  MethodBeingCompiledNameSignature,
    const ep_char8_t*  InlinerNamespace,
    const ep_char8_t*  InlinerName,
    const ep_char8_t*  InlinerNameSignature,
    const ep_char8_t*  InlineeNamespace,
    const ep_char8_t*  InlineeName,
    const ep_char8_t*  InlineeNameSignature,
    const bool  FailAlways,
    const ep_char8_t*  FailReason,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMethodJitInliningFailed(MethodBeingCompiledNamespace,MethodBeingCompiledName,MethodBeingCompiledNameSignature,InlinerNamespace,InlinerName,InlinerNameSignature,InlineeNamespace,InlineeName,InlineeNameSignature,FailAlways,FailReason,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledModuleDCStartV2(void) {return EventPipeEventEnabledModuleDCStartV2();}

static inline uint32_t FireEtwModuleDCStartV2(
    const uint64_t  ModuleID,
    const uint64_t  AssemblyID,
    const uint32_t  ModuleFlags,
    const uint32_t  Reserved1,
    const ep_char8_t*  ModuleILPath,
    const ep_char8_t*  ModuleNativePath,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventModuleDCStartV2(ModuleID,AssemblyID,ModuleFlags,Reserved1,ModuleILPath,ModuleNativePath,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledModuleDCEndV2(void) {return EventPipeEventEnabledModuleDCEndV2();}

static inline uint32_t FireEtwModuleDCEndV2(
    const uint64_t  ModuleID,
    const uint64_t  AssemblyID,
    const uint32_t  ModuleFlags,
    const uint32_t  Reserved1,
    const ep_char8_t*  ModuleILPath,
    const ep_char8_t*  ModuleNativePath,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventModuleDCEndV2(ModuleID,AssemblyID,ModuleFlags,Reserved1,ModuleILPath,ModuleNativePath,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledDomainModuleLoad(void) {return EventPipeEventEnabledDomainModuleLoad();}

static inline uint32_t FireEtwDomainModuleLoad(
    const uint64_t  ModuleID,
    const uint64_t  AssemblyID,
    const uint64_t  AppDomainID,
    const uint32_t  ModuleFlags,
    const uint32_t  Reserved1,
    const ep_char8_t*  ModuleILPath,
    const ep_char8_t*  ModuleNativePath,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventDomainModuleLoad(ModuleID,AssemblyID,AppDomainID,ModuleFlags,Reserved1,ModuleILPath,ModuleNativePath,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledDomainModuleLoad_V1(void) {return EventPipeEventEnabledDomainModuleLoad_V1();}

static inline uint32_t FireEtwDomainModuleLoad_V1(
    const uint64_t  ModuleID,
    const uint64_t  AssemblyID,
    const uint64_t  AppDomainID,
    const uint32_t  ModuleFlags,
    const uint32_t  Reserved1,
    const ep_char8_t*  ModuleILPath,
    const ep_char8_t*  ModuleNativePath,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventDomainModuleLoad_V1(ModuleID,AssemblyID,AppDomainID,ModuleFlags,Reserved1,ModuleILPath,ModuleNativePath,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledModuleLoad(void) {return EventPipeEventEnabledModuleLoad();}

static inline uint32_t FireEtwModuleLoad(
    const uint64_t  ModuleID,
    const uint64_t  AssemblyID,
    const uint32_t  ModuleFlags,
    const uint32_t  Reserved1,
    const ep_char8_t*  ModuleILPath,
    const ep_char8_t*  ModuleNativePath,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventModuleLoad(ModuleID,AssemblyID,ModuleFlags,Reserved1,ModuleILPath,ModuleNativePath,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledModuleLoad_V1(void) {return EventPipeEventEnabledModuleLoad_V1();}

static inline uint32_t FireEtwModuleLoad_V1(
    const uint64_t  ModuleID,
    const uint64_t  AssemblyID,
    const uint32_t  ModuleFlags,
    const uint32_t  Reserved1,
    const ep_char8_t*  ModuleILPath,
    const ep_char8_t*  ModuleNativePath,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventModuleLoad_V1(ModuleID,AssemblyID,ModuleFlags,Reserved1,ModuleILPath,ModuleNativePath,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledModuleLoad_V2(void) {return EventPipeEventEnabledModuleLoad_V2();}

static inline uint32_t FireEtwModuleLoad_V2(
    const uint64_t  ModuleID,
    const uint64_t  AssemblyID,
    const uint32_t  ModuleFlags,
    const uint32_t  Reserved1,
    const ep_char8_t*  ModuleILPath,
    const ep_char8_t*  ModuleNativePath,
    const uint16_t  ClrInstanceID,
    const uint8_t* ManagedPdbSignature,
    const uint32_t  ManagedPdbAge,
    const ep_char8_t*  ManagedPdbBuildPath,
    const uint8_t* NativePdbSignature,
    const uint32_t  NativePdbAge,
    const ep_char8_t*  NativePdbBuildPath,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventModuleLoad_V2(ModuleID,AssemblyID,ModuleFlags,Reserved1,ModuleILPath,ModuleNativePath,ClrInstanceID,ManagedPdbSignature,ManagedPdbAge,ManagedPdbBuildPath,NativePdbSignature,NativePdbAge,NativePdbBuildPath,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledModuleUnload(void) {return EventPipeEventEnabledModuleUnload();}

static inline uint32_t FireEtwModuleUnload(
    const uint64_t  ModuleID,
    const uint64_t  AssemblyID,
    const uint32_t  ModuleFlags,
    const uint32_t  Reserved1,
    const ep_char8_t*  ModuleILPath,
    const ep_char8_t*  ModuleNativePath,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventModuleUnload(ModuleID,AssemblyID,ModuleFlags,Reserved1,ModuleILPath,ModuleNativePath,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledModuleUnload_V1(void) {return EventPipeEventEnabledModuleUnload_V1();}

static inline uint32_t FireEtwModuleUnload_V1(
    const uint64_t  ModuleID,
    const uint64_t  AssemblyID,
    const uint32_t  ModuleFlags,
    const uint32_t  Reserved1,
    const ep_char8_t*  ModuleILPath,
    const ep_char8_t*  ModuleNativePath,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventModuleUnload_V1(ModuleID,AssemblyID,ModuleFlags,Reserved1,ModuleILPath,ModuleNativePath,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledModuleUnload_V2(void) {return EventPipeEventEnabledModuleUnload_V2();}

static inline uint32_t FireEtwModuleUnload_V2(
    const uint64_t  ModuleID,
    const uint64_t  AssemblyID,
    const uint32_t  ModuleFlags,
    const uint32_t  Reserved1,
    const ep_char8_t*  ModuleILPath,
    const ep_char8_t*  ModuleNativePath,
    const uint16_t  ClrInstanceID,
    const uint8_t* ManagedPdbSignature,
    const uint32_t  ManagedPdbAge,
    const ep_char8_t*  ManagedPdbBuildPath,
    const uint8_t* NativePdbSignature,
    const uint32_t  NativePdbAge,
    const ep_char8_t*  NativePdbBuildPath,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventModuleUnload_V2(ModuleID,AssemblyID,ModuleFlags,Reserved1,ModuleILPath,ModuleNativePath,ClrInstanceID,ManagedPdbSignature,ManagedPdbAge,ManagedPdbBuildPath,NativePdbSignature,NativePdbAge,NativePdbBuildPath,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledAssemblyLoad(void) {return EventPipeEventEnabledAssemblyLoad();}

static inline uint32_t FireEtwAssemblyLoad(
    const uint64_t  AssemblyID,
    const uint64_t  AppDomainID,
    const uint32_t  AssemblyFlags,
    const ep_char8_t*  FullyQualifiedAssemblyName,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventAssemblyLoad(AssemblyID,AppDomainID,AssemblyFlags,FullyQualifiedAssemblyName,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledAssemblyLoad_V1(void) {return EventPipeEventEnabledAssemblyLoad_V1();}

static inline uint32_t FireEtwAssemblyLoad_V1(
    const uint64_t  AssemblyID,
    const uint64_t  AppDomainID,
    const uint64_t  BindingID,
    const uint32_t  AssemblyFlags,
    const ep_char8_t*  FullyQualifiedAssemblyName,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventAssemblyLoad_V1(AssemblyID,AppDomainID,BindingID,AssemblyFlags,FullyQualifiedAssemblyName,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledAssemblyUnload(void) {return EventPipeEventEnabledAssemblyUnload();}

static inline uint32_t FireEtwAssemblyUnload(
    const uint64_t  AssemblyID,
    const uint64_t  AppDomainID,
    const uint32_t  AssemblyFlags,
    const ep_char8_t*  FullyQualifiedAssemblyName,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventAssemblyUnload(AssemblyID,AppDomainID,AssemblyFlags,FullyQualifiedAssemblyName,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledAssemblyUnload_V1(void) {return EventPipeEventEnabledAssemblyUnload_V1();}

static inline uint32_t FireEtwAssemblyUnload_V1(
    const uint64_t  AssemblyID,
    const uint64_t  AppDomainID,
    const uint64_t  BindingID,
    const uint32_t  AssemblyFlags,
    const ep_char8_t*  FullyQualifiedAssemblyName,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventAssemblyUnload_V1(AssemblyID,AppDomainID,BindingID,AssemblyFlags,FullyQualifiedAssemblyName,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledAppDomainLoad(void) {return EventPipeEventEnabledAppDomainLoad();}

static inline uint32_t FireEtwAppDomainLoad(
    const uint64_t  AppDomainID,
    const uint32_t  AppDomainFlags,
    const ep_char8_t*  AppDomainName,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventAppDomainLoad(AppDomainID,AppDomainFlags,AppDomainName,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledAppDomainLoad_V1(void) {return EventPipeEventEnabledAppDomainLoad_V1();}

static inline uint32_t FireEtwAppDomainLoad_V1(
    const uint64_t  AppDomainID,
    const uint32_t  AppDomainFlags,
    const ep_char8_t*  AppDomainName,
    const uint32_t  AppDomainIndex,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventAppDomainLoad_V1(AppDomainID,AppDomainFlags,AppDomainName,AppDomainIndex,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledAppDomainUnload(void) {return EventPipeEventEnabledAppDomainUnload();}

static inline uint32_t FireEtwAppDomainUnload(
    const uint64_t  AppDomainID,
    const uint32_t  AppDomainFlags,
    const ep_char8_t*  AppDomainName,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventAppDomainUnload(AppDomainID,AppDomainFlags,AppDomainName,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledAppDomainUnload_V1(void) {return EventPipeEventEnabledAppDomainUnload_V1();}

static inline uint32_t FireEtwAppDomainUnload_V1(
    const uint64_t  AppDomainID,
    const uint32_t  AppDomainFlags,
    const ep_char8_t*  AppDomainName,
    const uint32_t  AppDomainIndex,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventAppDomainUnload_V1(AppDomainID,AppDomainFlags,AppDomainName,AppDomainIndex,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledModuleRangeLoad(void) {return EventPipeEventEnabledModuleRangeLoad();}

static inline uint32_t FireEtwModuleRangeLoad(
    const uint16_t  ClrInstanceID,
    const uint64_t  ModuleID,
    const uint32_t  RangeBegin,
    const uint32_t  RangeSize,
    const uint8_t  RangeType,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventModuleRangeLoad(ClrInstanceID,ModuleID,RangeBegin,RangeSize,RangeType,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledStrongNameVerificationStart(void) {return EventPipeEventEnabledStrongNameVerificationStart();}

static inline uint32_t FireEtwStrongNameVerificationStart(
    const uint32_t  VerificationFlags,
    const uint32_t  ErrorCode,
    const ep_char8_t*  FullyQualifiedAssemblyName,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventStrongNameVerificationStart(VerificationFlags,ErrorCode,FullyQualifiedAssemblyName,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledStrongNameVerificationStart_V1(void) {return EventPipeEventEnabledStrongNameVerificationStart_V1();}

static inline uint32_t FireEtwStrongNameVerificationStart_V1(
    const uint32_t  VerificationFlags,
    const uint32_t  ErrorCode,
    const ep_char8_t*  FullyQualifiedAssemblyName,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventStrongNameVerificationStart_V1(VerificationFlags,ErrorCode,FullyQualifiedAssemblyName,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledStrongNameVerificationStop(void) {return EventPipeEventEnabledStrongNameVerificationStop();}

static inline uint32_t FireEtwStrongNameVerificationStop(
    const uint32_t  VerificationFlags,
    const uint32_t  ErrorCode,
    const ep_char8_t*  FullyQualifiedAssemblyName,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventStrongNameVerificationStop(VerificationFlags,ErrorCode,FullyQualifiedAssemblyName,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledStrongNameVerificationStop_V1(void) {return EventPipeEventEnabledStrongNameVerificationStop_V1();}

static inline uint32_t FireEtwStrongNameVerificationStop_V1(
    const uint32_t  VerificationFlags,
    const uint32_t  ErrorCode,
    const ep_char8_t*  FullyQualifiedAssemblyName,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventStrongNameVerificationStop_V1(VerificationFlags,ErrorCode,FullyQualifiedAssemblyName,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledAuthenticodeVerificationStart(void) {return EventPipeEventEnabledAuthenticodeVerificationStart();}

static inline uint32_t FireEtwAuthenticodeVerificationStart(
    const uint32_t  VerificationFlags,
    const uint32_t  ErrorCode,
    const ep_char8_t*  ModulePath,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventAuthenticodeVerificationStart(VerificationFlags,ErrorCode,ModulePath,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledAuthenticodeVerificationStart_V1(void) {return EventPipeEventEnabledAuthenticodeVerificationStart_V1();}

static inline uint32_t FireEtwAuthenticodeVerificationStart_V1(
    const uint32_t  VerificationFlags,
    const uint32_t  ErrorCode,
    const ep_char8_t*  ModulePath,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventAuthenticodeVerificationStart_V1(VerificationFlags,ErrorCode,ModulePath,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledAuthenticodeVerificationStop(void) {return EventPipeEventEnabledAuthenticodeVerificationStop();}

static inline uint32_t FireEtwAuthenticodeVerificationStop(
    const uint32_t  VerificationFlags,
    const uint32_t  ErrorCode,
    const ep_char8_t*  ModulePath,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventAuthenticodeVerificationStop(VerificationFlags,ErrorCode,ModulePath,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledAuthenticodeVerificationStop_V1(void) {return EventPipeEventEnabledAuthenticodeVerificationStop_V1();}

static inline uint32_t FireEtwAuthenticodeVerificationStop_V1(
    const uint32_t  VerificationFlags,
    const uint32_t  ErrorCode,
    const ep_char8_t*  ModulePath,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventAuthenticodeVerificationStop_V1(VerificationFlags,ErrorCode,ModulePath,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledRuntimeInformationStart(void) {return EventPipeEventEnabledRuntimeInformationStart();}

static inline uint32_t FireEtwRuntimeInformationStart(
    const uint16_t  ClrInstanceID,
    const uint16_t  Sku,
    const uint16_t  BclMajorVersion,
    const uint16_t  BclMinorVersion,
    const uint16_t  BclBuildNumber,
    const uint16_t  BclQfeNumber,
    const uint16_t  VMMajorVersion,
    const uint16_t  VMMinorVersion,
    const uint16_t  VMBuildNumber,
    const uint16_t  VMQfeNumber,
    const uint32_t  StartupFlags,
    const uint8_t  StartupMode,
    const ep_char8_t*  CommandLine,
    const uint8_t* ComObjectGuid,
    const ep_char8_t*  RuntimeDllPath,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventRuntimeInformationStart(ClrInstanceID,Sku,BclMajorVersion,BclMinorVersion,BclBuildNumber,BclQfeNumber,VMMajorVersion,VMMinorVersion,VMBuildNumber,VMQfeNumber,StartupFlags,StartupMode,CommandLine,ComObjectGuid,RuntimeDllPath,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledIncreaseMemoryPressure(void) {return EventPipeEventEnabledIncreaseMemoryPressure();}

static inline uint32_t FireEtwIncreaseMemoryPressure(
    const uint64_t  BytesAllocated,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventIncreaseMemoryPressure(BytesAllocated,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledDecreaseMemoryPressure(void) {return EventPipeEventEnabledDecreaseMemoryPressure();}

static inline uint32_t FireEtwDecreaseMemoryPressure(
    const uint64_t  BytesFreed,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventDecreaseMemoryPressure(BytesFreed,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCMarkWithType(void) {return EventPipeEventEnabledGCMarkWithType();}

static inline uint32_t FireEtwGCMarkWithType(
    const uint32_t  HeapNum,
    const uint16_t  ClrInstanceID,
    const uint32_t  Type,
    const uint64_t  Bytes,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCMarkWithType(HeapNum,ClrInstanceID,Type,Bytes,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCJoin_V2(void) {return EventPipeEventEnabledGCJoin_V2();}

static inline uint32_t FireEtwGCJoin_V2(
    const uint32_t  Heap,
    const uint32_t  JoinTime,
    const uint32_t  JoinType,
    const uint16_t  ClrInstanceID,
    const uint32_t  JoinID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCJoin_V2(Heap,JoinTime,JoinType,ClrInstanceID,JoinID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCPerHeapHistory_V3(void) {return EventPipeEventEnabledGCPerHeapHistory_V3();}

static inline uint32_t FireEtwGCPerHeapHistory_V3(
    const uint16_t  ClrInstanceID,
    const void*  FreeListAllocated,
    const void*  FreeListRejected,
    const void*  EndOfSegAllocated,
    const void*  CondemnedAllocated,
    const void*  PinnedAllocated,
    const void*  PinnedAllocatedAdvance,
    const uint32_t  RunningFreeListEfficiency,
    const uint32_t  CondemnReasons0,
    const uint32_t  CondemnReasons1,
    const uint32_t  CompactMechanisms,
    const uint32_t  ExpandMechanisms,
    const uint32_t  HeapIndex,
    const void*  ExtraGen0Commit,
    const uint32_t  Count,
    int Values_ElementSize,
    const void* Values,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCPerHeapHistory_V3(ClrInstanceID,FreeListAllocated,FreeListRejected,EndOfSegAllocated,CondemnedAllocated,PinnedAllocated,PinnedAllocatedAdvance,RunningFreeListEfficiency,CondemnReasons0,CondemnReasons1,CompactMechanisms,ExpandMechanisms,HeapIndex,ExtraGen0Commit,Count,Values_ElementSize, Values,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCGlobalHeapHistory_V2(void) {return EventPipeEventEnabledGCGlobalHeapHistory_V2();}

static inline uint32_t FireEtwGCGlobalHeapHistory_V2(
    const uint64_t  FinalYoungestDesired,
    const int32_t  NumHeaps,
    const uint32_t  CondemnedGeneration,
    const uint32_t  Gen0ReductionCount,
    const uint32_t  Reason,
    const uint32_t  GlobalMechanisms,
    const uint16_t  ClrInstanceID,
    const uint32_t  PauseMode,
    const uint32_t  MemoryPressure,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCGlobalHeapHistory_V2(FinalYoungestDesired,NumHeaps,CondemnedGeneration,Gen0ReductionCount,Reason,GlobalMechanisms,ClrInstanceID,PauseMode,MemoryPressure,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCGlobalHeapHistory_V3(void) {return EventPipeEventEnabledGCGlobalHeapHistory_V3();}

static inline uint32_t FireEtwGCGlobalHeapHistory_V3(
    const uint64_t  FinalYoungestDesired,
    const int32_t  NumHeaps,
    const uint32_t  CondemnedGeneration,
    const uint32_t  Gen0ReductionCount,
    const uint32_t  Reason,
    const uint32_t  GlobalMechanisms,
    const uint16_t  ClrInstanceID,
    const uint32_t  PauseMode,
    const uint32_t  MemoryPressure,
    const uint32_t  CondemnReasons0,
    const uint32_t  CondemnReasons1,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCGlobalHeapHistory_V3(FinalYoungestDesired,NumHeaps,CondemnedGeneration,Gen0ReductionCount,Reason,GlobalMechanisms,ClrInstanceID,PauseMode,MemoryPressure,CondemnReasons0,CondemnReasons1,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCGlobalHeapHistory_V4(void) {return EventPipeEventEnabledGCGlobalHeapHistory_V4();}

static inline uint32_t FireEtwGCGlobalHeapHistory_V4(
    const uint64_t  FinalYoungestDesired,
    const int32_t  NumHeaps,
    const uint32_t  CondemnedGeneration,
    const uint32_t  Gen0ReductionCount,
    const uint32_t  Reason,
    const uint32_t  GlobalMechanisms,
    const uint16_t  ClrInstanceID,
    const uint32_t  PauseMode,
    const uint32_t  MemoryPressure,
    const uint32_t  CondemnReasons0,
    const uint32_t  CondemnReasons1,
    const uint32_t  Count,
    int Values_ElementSize,
    const void* Values,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCGlobalHeapHistory_V4(FinalYoungestDesired,NumHeaps,CondemnedGeneration,Gen0ReductionCount,Reason,GlobalMechanisms,ClrInstanceID,PauseMode,MemoryPressure,CondemnReasons0,CondemnReasons1,Count,Values_ElementSize, Values,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGenAwareBegin(void) {return EventPipeEventEnabledGenAwareBegin();}

static inline uint32_t FireEtwGenAwareBegin(
    const uint32_t  Count,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGenAwareBegin(Count,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGenAwareEnd(void) {return EventPipeEventEnabledGenAwareEnd();}

static inline uint32_t FireEtwGenAwareEnd(
    const uint32_t  Count,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGenAwareEnd(Count,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCLOHCompact(void) {return EventPipeEventEnabledGCLOHCompact();}

static inline uint32_t FireEtwGCLOHCompact(
    const uint16_t  ClrInstanceID,
    const uint16_t  Count,
    int Values_ElementSize,
    const void* Values,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCLOHCompact(ClrInstanceID,Count,Values_ElementSize, Values,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCFitBucketInfo(void) {return EventPipeEventEnabledGCFitBucketInfo();}

static inline uint32_t FireEtwGCFitBucketInfo(
    const uint16_t  ClrInstanceID,
    const uint16_t  BucketKind,
    const uint64_t  TotalSize,
    const uint16_t  Count,
    int Values_ElementSize,
    const void* Values,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCFitBucketInfo(ClrInstanceID,BucketKind,TotalSize,Count,Values_ElementSize, Values,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledDebugIPCEventStart(void) {return EventPipeEventEnabledDebugIPCEventStart();}

static inline uint32_t FireEtwDebugIPCEventStart(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventDebugIPCEventStart(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledDebugIPCEventEnd(void) {return EventPipeEventEnabledDebugIPCEventEnd();}

static inline uint32_t FireEtwDebugIPCEventEnd(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventDebugIPCEventEnd(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledDebugExceptionProcessingStart(void) {return EventPipeEventEnabledDebugExceptionProcessingStart();}

static inline uint32_t FireEtwDebugExceptionProcessingStart(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventDebugExceptionProcessingStart(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledDebugExceptionProcessingEnd(void) {return EventPipeEventEnabledDebugExceptionProcessingEnd();}

static inline uint32_t FireEtwDebugExceptionProcessingEnd(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventDebugExceptionProcessingEnd(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledCodeSymbols(void) {return EventPipeEventEnabledCodeSymbols();}

static inline uint32_t FireEtwCodeSymbols(
    const uint64_t  ModuleId,
    const uint16_t  TotalChunks,
    const uint16_t  ChunkNumber,
    const uint32_t  ChunkLength,
    const uint8_t* Chunk,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventCodeSymbols(ModuleId,TotalChunks,ChunkNumber,ChunkLength,Chunk,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledEventSource(void) {return EventPipeEventEnabledEventSource();}

static inline uint32_t FireEtwEventSource(
    const int32_t  EventID,
    const ep_char8_t*  EventName,
    const ep_char8_t*  EventSourceName,
    const ep_char8_t*  Payload,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventEventSource(EventID,EventName,EventSourceName,Payload,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledTieredCompilationSettings(void) {return EventPipeEventEnabledTieredCompilationSettings();}

static inline uint32_t FireEtwTieredCompilationSettings(
    const uint16_t  ClrInstanceID,
    const uint32_t  Flags,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventTieredCompilationSettings(ClrInstanceID,Flags,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledTieredCompilationPause(void) {return EventPipeEventEnabledTieredCompilationPause();}

static inline uint32_t FireEtwTieredCompilationPause(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventTieredCompilationPause(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledTieredCompilationResume(void) {return EventPipeEventEnabledTieredCompilationResume();}

static inline uint32_t FireEtwTieredCompilationResume(
    const uint16_t  ClrInstanceID,
    const uint32_t  NewMethodCount,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventTieredCompilationResume(ClrInstanceID,NewMethodCount,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledTieredCompilationBackgroundJitStart(void) {return EventPipeEventEnabledTieredCompilationBackgroundJitStart();}

static inline uint32_t FireEtwTieredCompilationBackgroundJitStart(
    const uint16_t  ClrInstanceID,
    const uint32_t  PendingMethodCount,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventTieredCompilationBackgroundJitStart(ClrInstanceID,PendingMethodCount,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledTieredCompilationBackgroundJitStop(void) {return EventPipeEventEnabledTieredCompilationBackgroundJitStop();}

static inline uint32_t FireEtwTieredCompilationBackgroundJitStop(
    const uint16_t  ClrInstanceID,
    const uint32_t  PendingMethodCount,
    const uint32_t  JittedMethodCount,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventTieredCompilationBackgroundJitStop(ClrInstanceID,PendingMethodCount,JittedMethodCount,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledAssemblyLoadStart(void) {return EventPipeEventEnabledAssemblyLoadStart();}

static inline uint32_t FireEtwAssemblyLoadStart(
    const uint16_t  ClrInstanceID,
    const ep_char8_t*  AssemblyName,
    const ep_char8_t*  AssemblyPath,
    const ep_char8_t*  RequestingAssembly,
    const ep_char8_t*  AssemblyLoadContext,
    const ep_char8_t*  RequestingAssemblyLoadContext,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventAssemblyLoadStart(ClrInstanceID,AssemblyName,AssemblyPath,RequestingAssembly,AssemblyLoadContext,RequestingAssemblyLoadContext,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledAssemblyLoadStop(void) {return EventPipeEventEnabledAssemblyLoadStop();}

static inline uint32_t FireEtwAssemblyLoadStop(
    const uint16_t  ClrInstanceID,
    const ep_char8_t*  AssemblyName,
    const ep_char8_t*  AssemblyPath,
    const ep_char8_t*  RequestingAssembly,
    const ep_char8_t*  AssemblyLoadContext,
    const ep_char8_t*  RequestingAssemblyLoadContext,
    const bool  Success,
    const ep_char8_t*  ResultAssemblyName,
    const ep_char8_t*  ResultAssemblyPath,
    const bool  Cached,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventAssemblyLoadStop(ClrInstanceID,AssemblyName,AssemblyPath,RequestingAssembly,AssemblyLoadContext,RequestingAssemblyLoadContext,Success,ResultAssemblyName,ResultAssemblyPath,Cached,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledResolutionAttempted(void) {return EventPipeEventEnabledResolutionAttempted();}

static inline uint32_t FireEtwResolutionAttempted(
    const uint16_t  ClrInstanceID,
    const ep_char8_t*  AssemblyName,
    const uint16_t  Stage,
    const ep_char8_t*  AssemblyLoadContext,
    const uint16_t  Result,
    const ep_char8_t*  ResultAssemblyName,
    const ep_char8_t*  ResultAssemblyPath,
    const ep_char8_t*  ErrorMessage,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventResolutionAttempted(ClrInstanceID,AssemblyName,Stage,AssemblyLoadContext,Result,ResultAssemblyName,ResultAssemblyPath,ErrorMessage,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledAssemblyLoadContextResolvingHandlerInvoked(void) {return EventPipeEventEnabledAssemblyLoadContextResolvingHandlerInvoked();}

static inline uint32_t FireEtwAssemblyLoadContextResolvingHandlerInvoked(
    const uint16_t  ClrInstanceID,
    const ep_char8_t*  AssemblyName,
    const ep_char8_t*  HandlerName,
    const ep_char8_t*  AssemblyLoadContext,
    const ep_char8_t*  ResultAssemblyName,
    const ep_char8_t*  ResultAssemblyPath,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventAssemblyLoadContextResolvingHandlerInvoked(ClrInstanceID,AssemblyName,HandlerName,AssemblyLoadContext,ResultAssemblyName,ResultAssemblyPath,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledAppDomainAssemblyResolveHandlerInvoked(void) {return EventPipeEventEnabledAppDomainAssemblyResolveHandlerInvoked();}

static inline uint32_t FireEtwAppDomainAssemblyResolveHandlerInvoked(
    const uint16_t  ClrInstanceID,
    const ep_char8_t*  AssemblyName,
    const ep_char8_t*  HandlerName,
    const ep_char8_t*  ResultAssemblyName,
    const ep_char8_t*  ResultAssemblyPath,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventAppDomainAssemblyResolveHandlerInvoked(ClrInstanceID,AssemblyName,HandlerName,ResultAssemblyName,ResultAssemblyPath,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledAssemblyLoadFromResolveHandlerInvoked(void) {return EventPipeEventEnabledAssemblyLoadFromResolveHandlerInvoked();}

static inline uint32_t FireEtwAssemblyLoadFromResolveHandlerInvoked(
    const uint16_t  ClrInstanceID,
    const ep_char8_t*  AssemblyName,
    const bool  IsTrackedLoad,
    const ep_char8_t*  RequestingAssemblyPath,
    const ep_char8_t*  ComputedRequestedAssemblyPath,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventAssemblyLoadFromResolveHandlerInvoked(ClrInstanceID,AssemblyName,IsTrackedLoad,RequestingAssemblyPath,ComputedRequestedAssemblyPath,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledKnownPathProbed(void) {return EventPipeEventEnabledKnownPathProbed();}

static inline uint32_t FireEtwKnownPathProbed(
    const uint16_t  ClrInstanceID,
    const ep_char8_t*  FilePath,
    const uint16_t  Source,
    const int32_t  Result,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventKnownPathProbed(ClrInstanceID,FilePath,Source,Result,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledJitInstrumentationData(void) {return EventPipeEventEnabledJitInstrumentationData();}

static inline uint32_t FireEtwJitInstrumentationData(
    const uint16_t  ClrInstanceID,
    const uint32_t  MethodFlags,
    const uint32_t  DataSize,
    const uint64_t  MethodID,
    const uint8_t* Data,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventJitInstrumentationData(ClrInstanceID,MethodFlags,DataSize,MethodID,Data,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledJitInstrumentationDataVerbose(void) {return EventPipeEventEnabledJitInstrumentationDataVerbose();}

static inline uint32_t FireEtwJitInstrumentationDataVerbose(
    const uint16_t  ClrInstanceID,
    const uint32_t  MethodFlags,
    const uint32_t  DataSize,
    const uint64_t  MethodID,
    const uint64_t  ModuleID,
    const uint32_t  MethodToken,
    const ep_char8_t*  MethodNamespace,
    const ep_char8_t*  MethodName,
    const ep_char8_t*  MethodSignature,
    const uint8_t* Data,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventJitInstrumentationDataVerbose(ClrInstanceID,MethodFlags,DataSize,MethodID,ModuleID,MethodToken,MethodNamespace,MethodName,MethodSignature,Data,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledProfilerMessage(void) {return EventPipeEventEnabledProfilerMessage();}

static inline uint32_t FireEtwProfilerMessage(
    const uint16_t  ClrInstanceID,
    const ep_char8_t*  Message,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventProfilerMessage(ClrInstanceID,Message,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledExecutionCheckpoint(void) {return EventPipeEventEnabledExecutionCheckpoint();}

static inline uint32_t FireEtwExecutionCheckpoint(
    const uint16_t  ClrInstanceID,
    const ep_char8_t*  Name,
    const int64_t  Timestamp,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventExecutionCheckpoint(ClrInstanceID,Name,Timestamp,ActivityId,RelatedActivityId);
    return status;
}

__attribute__((weak)) EVENTPIPE_TRACE_CONTEXT MICROSOFT_WINDOWS_DOTNETRUNTIME_PROVIDER_EVENTPIPE_Context = { W("Microsoft-Windows-DotNETRuntime"), 0, false, 0 };
static inline bool EventEnabledCLRStackWalkDCStart(void) {return EventPipeEventEnabledCLRStackWalkDCStart();}

static inline uint32_t FireEtwCLRStackWalkDCStart(
    const uint16_t  ClrInstanceID,
    const uint8_t  Reserved1,
    const uint8_t  Reserved2,
    const uint32_t  FrameCount,
    const void** Stack,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventCLRStackWalkDCStart(ClrInstanceID,Reserved1,Reserved2,FrameCount,Stack,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCSettingsRundown(void) {return EventPipeEventEnabledGCSettingsRundown();}

static inline uint32_t FireEtwGCSettingsRundown(
    const uint64_t  HardLimit,
    const uint64_t  LOHThreshold,
    const uint64_t  PhysicalMemoryConfig,
    const uint64_t  Gen0MinBudgetConfig,
    const uint64_t  Gen0MaxBudgetConfig,
    const uint32_t  HighMemPercentConfig,
    const uint32_t  BitSettings,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCSettingsRundown(HardLimit,LOHThreshold,PhysicalMemoryConfig,Gen0MinBudgetConfig,Gen0MaxBudgetConfig,HighMemPercentConfig,BitSettings,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMethodDCStart(void) {return EventPipeEventEnabledMethodDCStart();}

static inline uint32_t FireEtwMethodDCStart(
    const uint64_t  MethodID,
    const uint64_t  ModuleID,
    const uint64_t  MethodStartAddress,
    const uint32_t  MethodSize,
    const uint32_t  MethodToken,
    const uint32_t  MethodFlags,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMethodDCStart(MethodID,ModuleID,MethodStartAddress,MethodSize,MethodToken,MethodFlags,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMethodDCStart_V1(void) {return EventPipeEventEnabledMethodDCStart_V1();}

static inline uint32_t FireEtwMethodDCStart_V1(
    const uint64_t  MethodID,
    const uint64_t  ModuleID,
    const uint64_t  MethodStartAddress,
    const uint32_t  MethodSize,
    const uint32_t  MethodToken,
    const uint32_t  MethodFlags,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMethodDCStart_V1(MethodID,ModuleID,MethodStartAddress,MethodSize,MethodToken,MethodFlags,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMethodDCStart_V2(void) {return EventPipeEventEnabledMethodDCStart_V2();}

static inline uint32_t FireEtwMethodDCStart_V2(
    const uint64_t  MethodID,
    const uint64_t  ModuleID,
    const uint64_t  MethodStartAddress,
    const uint32_t  MethodSize,
    const uint32_t  MethodToken,
    const uint32_t  MethodFlags,
    const uint16_t  ClrInstanceID,
    const uint64_t  ReJITID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMethodDCStart_V2(MethodID,ModuleID,MethodStartAddress,MethodSize,MethodToken,MethodFlags,ClrInstanceID,ReJITID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMethodDCEnd(void) {return EventPipeEventEnabledMethodDCEnd();}

static inline uint32_t FireEtwMethodDCEnd(
    const uint64_t  MethodID,
    const uint64_t  ModuleID,
    const uint64_t  MethodStartAddress,
    const uint32_t  MethodSize,
    const uint32_t  MethodToken,
    const uint32_t  MethodFlags,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMethodDCEnd(MethodID,ModuleID,MethodStartAddress,MethodSize,MethodToken,MethodFlags,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMethodDCEnd_V1(void) {return EventPipeEventEnabledMethodDCEnd_V1();}

static inline uint32_t FireEtwMethodDCEnd_V1(
    const uint64_t  MethodID,
    const uint64_t  ModuleID,
    const uint64_t  MethodStartAddress,
    const uint32_t  MethodSize,
    const uint32_t  MethodToken,
    const uint32_t  MethodFlags,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMethodDCEnd_V1(MethodID,ModuleID,MethodStartAddress,MethodSize,MethodToken,MethodFlags,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMethodDCEnd_V2(void) {return EventPipeEventEnabledMethodDCEnd_V2();}

static inline uint32_t FireEtwMethodDCEnd_V2(
    const uint64_t  MethodID,
    const uint64_t  ModuleID,
    const uint64_t  MethodStartAddress,
    const uint32_t  MethodSize,
    const uint32_t  MethodToken,
    const uint32_t  MethodFlags,
    const uint16_t  ClrInstanceID,
    const uint64_t  ReJITID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMethodDCEnd_V2(MethodID,ModuleID,MethodStartAddress,MethodSize,MethodToken,MethodFlags,ClrInstanceID,ReJITID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMethodDCStartVerbose(void) {return EventPipeEventEnabledMethodDCStartVerbose();}

static inline uint32_t FireEtwMethodDCStartVerbose(
    const uint64_t  MethodID,
    const uint64_t  ModuleID,
    const uint64_t  MethodStartAddress,
    const uint32_t  MethodSize,
    const uint32_t  MethodToken,
    const uint32_t  MethodFlags,
    const ep_char8_t*  MethodNamespace,
    const ep_char8_t*  MethodName,
    const ep_char8_t*  MethodSignature,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMethodDCStartVerbose(MethodID,ModuleID,MethodStartAddress,MethodSize,MethodToken,MethodFlags,MethodNamespace,MethodName,MethodSignature,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMethodDCStartVerbose_V1(void) {return EventPipeEventEnabledMethodDCStartVerbose_V1();}

static inline uint32_t FireEtwMethodDCStartVerbose_V1(
    const uint64_t  MethodID,
    const uint64_t  ModuleID,
    const uint64_t  MethodStartAddress,
    const uint32_t  MethodSize,
    const uint32_t  MethodToken,
    const uint32_t  MethodFlags,
    const ep_char8_t*  MethodNamespace,
    const ep_char8_t*  MethodName,
    const ep_char8_t*  MethodSignature,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMethodDCStartVerbose_V1(MethodID,ModuleID,MethodStartAddress,MethodSize,MethodToken,MethodFlags,MethodNamespace,MethodName,MethodSignature,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMethodDCStartVerbose_V2(void) {return EventPipeEventEnabledMethodDCStartVerbose_V2();}

static inline uint32_t FireEtwMethodDCStartVerbose_V2(
    const uint64_t  MethodID,
    const uint64_t  ModuleID,
    const uint64_t  MethodStartAddress,
    const uint32_t  MethodSize,
    const uint32_t  MethodToken,
    const uint32_t  MethodFlags,
    const ep_char8_t*  MethodNamespace,
    const ep_char8_t*  MethodName,
    const ep_char8_t*  MethodSignature,
    const uint16_t  ClrInstanceID,
    const uint64_t  ReJITID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMethodDCStartVerbose_V2(MethodID,ModuleID,MethodStartAddress,MethodSize,MethodToken,MethodFlags,MethodNamespace,MethodName,MethodSignature,ClrInstanceID,ReJITID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMethodDCEndVerbose(void) {return EventPipeEventEnabledMethodDCEndVerbose();}

static inline uint32_t FireEtwMethodDCEndVerbose(
    const uint64_t  MethodID,
    const uint64_t  ModuleID,
    const uint64_t  MethodStartAddress,
    const uint32_t  MethodSize,
    const uint32_t  MethodToken,
    const uint32_t  MethodFlags,
    const ep_char8_t*  MethodNamespace,
    const ep_char8_t*  MethodName,
    const ep_char8_t*  MethodSignature,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMethodDCEndVerbose(MethodID,ModuleID,MethodStartAddress,MethodSize,MethodToken,MethodFlags,MethodNamespace,MethodName,MethodSignature,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMethodDCEndVerbose_V1(void) {return EventPipeEventEnabledMethodDCEndVerbose_V1();}

static inline uint32_t FireEtwMethodDCEndVerbose_V1(
    const uint64_t  MethodID,
    const uint64_t  ModuleID,
    const uint64_t  MethodStartAddress,
    const uint32_t  MethodSize,
    const uint32_t  MethodToken,
    const uint32_t  MethodFlags,
    const ep_char8_t*  MethodNamespace,
    const ep_char8_t*  MethodName,
    const ep_char8_t*  MethodSignature,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMethodDCEndVerbose_V1(MethodID,ModuleID,MethodStartAddress,MethodSize,MethodToken,MethodFlags,MethodNamespace,MethodName,MethodSignature,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMethodDCEndVerbose_V2(void) {return EventPipeEventEnabledMethodDCEndVerbose_V2();}

static inline uint32_t FireEtwMethodDCEndVerbose_V2(
    const uint64_t  MethodID,
    const uint64_t  ModuleID,
    const uint64_t  MethodStartAddress,
    const uint32_t  MethodSize,
    const uint32_t  MethodToken,
    const uint32_t  MethodFlags,
    const ep_char8_t*  MethodNamespace,
    const ep_char8_t*  MethodName,
    const ep_char8_t*  MethodSignature,
    const uint16_t  ClrInstanceID,
    const uint64_t  ReJITID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMethodDCEndVerbose_V2(MethodID,ModuleID,MethodStartAddress,MethodSize,MethodToken,MethodFlags,MethodNamespace,MethodName,MethodSignature,ClrInstanceID,ReJITID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledDCStartComplete(void) {return EventPipeEventEnabledDCStartComplete();}

static inline uint32_t FireEtwDCStartComplete(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventDCStartComplete(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledDCStartComplete_V1(void) {return EventPipeEventEnabledDCStartComplete_V1();}

static inline uint32_t FireEtwDCStartComplete_V1(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventDCStartComplete_V1(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledDCEndComplete(void) {return EventPipeEventEnabledDCEndComplete();}

static inline uint32_t FireEtwDCEndComplete(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventDCEndComplete(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledDCEndComplete_V1(void) {return EventPipeEventEnabledDCEndComplete_V1();}

static inline uint32_t FireEtwDCEndComplete_V1(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventDCEndComplete_V1(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledDCStartInit(void) {return EventPipeEventEnabledDCStartInit();}

static inline uint32_t FireEtwDCStartInit(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventDCStartInit(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledDCStartInit_V1(void) {return EventPipeEventEnabledDCStartInit_V1();}

static inline uint32_t FireEtwDCStartInit_V1(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventDCStartInit_V1(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledDCEndInit(void) {return EventPipeEventEnabledDCEndInit();}

static inline uint32_t FireEtwDCEndInit(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventDCEndInit(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledDCEndInit_V1(void) {return EventPipeEventEnabledDCEndInit_V1();}

static inline uint32_t FireEtwDCEndInit_V1(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventDCEndInit_V1(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMethodDCStartILToNativeMap(void) {return EventPipeEventEnabledMethodDCStartILToNativeMap();}

static inline uint32_t FireEtwMethodDCStartILToNativeMap(
    const uint64_t  MethodID,
    const uint64_t  ReJITID,
    const uint8_t  MethodExtent,
    const uint16_t  CountOfMapEntries,
    const uint32_t* ILOffsets,
    const uint32_t* NativeOffsets,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMethodDCStartILToNativeMap(MethodID,ReJITID,MethodExtent,CountOfMapEntries,ILOffsets,NativeOffsets,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMethodDCStartILToNativeMap_V1(void) {return EventPipeEventEnabledMethodDCStartILToNativeMap_V1();}

static inline uint32_t FireEtwMethodDCStartILToNativeMap_V1(
    const uint64_t  MethodID,
    const uint64_t  ReJITID,
    const uint8_t  MethodExtent,
    const uint16_t  CountOfMapEntries,
    const uint32_t* ILOffsets,
    const uint32_t* NativeOffsets,
    const uint16_t  ClrInstanceID,
    const uint64_t  ILVersionID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMethodDCStartILToNativeMap_V1(MethodID,ReJITID,MethodExtent,CountOfMapEntries,ILOffsets,NativeOffsets,ClrInstanceID,ILVersionID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMethodDCEndILToNativeMap(void) {return EventPipeEventEnabledMethodDCEndILToNativeMap();}

static inline uint32_t FireEtwMethodDCEndILToNativeMap(
    const uint64_t  MethodID,
    const uint64_t  ReJITID,
    const uint8_t  MethodExtent,
    const uint16_t  CountOfMapEntries,
    const uint32_t* ILOffsets,
    const uint32_t* NativeOffsets,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMethodDCEndILToNativeMap(MethodID,ReJITID,MethodExtent,CountOfMapEntries,ILOffsets,NativeOffsets,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMethodDCEndILToNativeMap_V1(void) {return EventPipeEventEnabledMethodDCEndILToNativeMap_V1();}

static inline uint32_t FireEtwMethodDCEndILToNativeMap_V1(
    const uint64_t  MethodID,
    const uint64_t  ReJITID,
    const uint8_t  MethodExtent,
    const uint16_t  CountOfMapEntries,
    const uint32_t* ILOffsets,
    const uint32_t* NativeOffsets,
    const uint16_t  ClrInstanceID,
    const uint64_t  ILVersionID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMethodDCEndILToNativeMap_V1(MethodID,ReJITID,MethodExtent,CountOfMapEntries,ILOffsets,NativeOffsets,ClrInstanceID,ILVersionID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledDomainModuleDCStart(void) {return EventPipeEventEnabledDomainModuleDCStart();}

static inline uint32_t FireEtwDomainModuleDCStart(
    const uint64_t  ModuleID,
    const uint64_t  AssemblyID,
    const uint64_t  AppDomainID,
    const uint32_t  ModuleFlags,
    const uint32_t  Reserved1,
    const ep_char8_t*  ModuleILPath,
    const ep_char8_t*  ModuleNativePath,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventDomainModuleDCStart(ModuleID,AssemblyID,AppDomainID,ModuleFlags,Reserved1,ModuleILPath,ModuleNativePath,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledDomainModuleDCStart_V1(void) {return EventPipeEventEnabledDomainModuleDCStart_V1();}

static inline uint32_t FireEtwDomainModuleDCStart_V1(
    const uint64_t  ModuleID,
    const uint64_t  AssemblyID,
    const uint64_t  AppDomainID,
    const uint32_t  ModuleFlags,
    const uint32_t  Reserved1,
    const ep_char8_t*  ModuleILPath,
    const ep_char8_t*  ModuleNativePath,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventDomainModuleDCStart_V1(ModuleID,AssemblyID,AppDomainID,ModuleFlags,Reserved1,ModuleILPath,ModuleNativePath,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledDomainModuleDCEnd(void) {return EventPipeEventEnabledDomainModuleDCEnd();}

static inline uint32_t FireEtwDomainModuleDCEnd(
    const uint64_t  ModuleID,
    const uint64_t  AssemblyID,
    const uint64_t  AppDomainID,
    const uint32_t  ModuleFlags,
    const uint32_t  Reserved1,
    const ep_char8_t*  ModuleILPath,
    const ep_char8_t*  ModuleNativePath,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventDomainModuleDCEnd(ModuleID,AssemblyID,AppDomainID,ModuleFlags,Reserved1,ModuleILPath,ModuleNativePath,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledDomainModuleDCEnd_V1(void) {return EventPipeEventEnabledDomainModuleDCEnd_V1();}

static inline uint32_t FireEtwDomainModuleDCEnd_V1(
    const uint64_t  ModuleID,
    const uint64_t  AssemblyID,
    const uint64_t  AppDomainID,
    const uint32_t  ModuleFlags,
    const uint32_t  Reserved1,
    const ep_char8_t*  ModuleILPath,
    const ep_char8_t*  ModuleNativePath,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventDomainModuleDCEnd_V1(ModuleID,AssemblyID,AppDomainID,ModuleFlags,Reserved1,ModuleILPath,ModuleNativePath,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledModuleDCStart(void) {return EventPipeEventEnabledModuleDCStart();}

static inline uint32_t FireEtwModuleDCStart(
    const uint64_t  ModuleID,
    const uint64_t  AssemblyID,
    const uint32_t  ModuleFlags,
    const uint32_t  Reserved1,
    const ep_char8_t*  ModuleILPath,
    const ep_char8_t*  ModuleNativePath,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventModuleDCStart(ModuleID,AssemblyID,ModuleFlags,Reserved1,ModuleILPath,ModuleNativePath,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledModuleDCStart_V1(void) {return EventPipeEventEnabledModuleDCStart_V1();}

static inline uint32_t FireEtwModuleDCStart_V1(
    const uint64_t  ModuleID,
    const uint64_t  AssemblyID,
    const uint32_t  ModuleFlags,
    const uint32_t  Reserved1,
    const ep_char8_t*  ModuleILPath,
    const ep_char8_t*  ModuleNativePath,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventModuleDCStart_V1(ModuleID,AssemblyID,ModuleFlags,Reserved1,ModuleILPath,ModuleNativePath,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledModuleDCStart_V2(void) {return EventPipeEventEnabledModuleDCStart_V2();}

static inline uint32_t FireEtwModuleDCStart_V2(
    const uint64_t  ModuleID,
    const uint64_t  AssemblyID,
    const uint32_t  ModuleFlags,
    const uint32_t  Reserved1,
    const ep_char8_t*  ModuleILPath,
    const ep_char8_t*  ModuleNativePath,
    const uint16_t  ClrInstanceID,
    const uint8_t* ManagedPdbSignature,
    const uint32_t  ManagedPdbAge,
    const ep_char8_t*  ManagedPdbBuildPath,
    const uint8_t* NativePdbSignature,
    const uint32_t  NativePdbAge,
    const ep_char8_t*  NativePdbBuildPath,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventModuleDCStart_V2(ModuleID,AssemblyID,ModuleFlags,Reserved1,ModuleILPath,ModuleNativePath,ClrInstanceID,ManagedPdbSignature,ManagedPdbAge,ManagedPdbBuildPath,NativePdbSignature,NativePdbAge,NativePdbBuildPath,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledModuleDCEnd(void) {return EventPipeEventEnabledModuleDCEnd();}

static inline uint32_t FireEtwModuleDCEnd(
    const uint64_t  ModuleID,
    const uint64_t  AssemblyID,
    const uint32_t  ModuleFlags,
    const uint32_t  Reserved1,
    const ep_char8_t*  ModuleILPath,
    const ep_char8_t*  ModuleNativePath,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventModuleDCEnd(ModuleID,AssemblyID,ModuleFlags,Reserved1,ModuleILPath,ModuleNativePath,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledModuleDCEnd_V1(void) {return EventPipeEventEnabledModuleDCEnd_V1();}

static inline uint32_t FireEtwModuleDCEnd_V1(
    const uint64_t  ModuleID,
    const uint64_t  AssemblyID,
    const uint32_t  ModuleFlags,
    const uint32_t  Reserved1,
    const ep_char8_t*  ModuleILPath,
    const ep_char8_t*  ModuleNativePath,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventModuleDCEnd_V1(ModuleID,AssemblyID,ModuleFlags,Reserved1,ModuleILPath,ModuleNativePath,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledModuleDCEnd_V2(void) {return EventPipeEventEnabledModuleDCEnd_V2();}

static inline uint32_t FireEtwModuleDCEnd_V2(
    const uint64_t  ModuleID,
    const uint64_t  AssemblyID,
    const uint32_t  ModuleFlags,
    const uint32_t  Reserved1,
    const ep_char8_t*  ModuleILPath,
    const ep_char8_t*  ModuleNativePath,
    const uint16_t  ClrInstanceID,
    const uint8_t* ManagedPdbSignature,
    const uint32_t  ManagedPdbAge,
    const ep_char8_t*  ManagedPdbBuildPath,
    const uint8_t* NativePdbSignature,
    const uint32_t  NativePdbAge,
    const ep_char8_t*  NativePdbBuildPath,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventModuleDCEnd_V2(ModuleID,AssemblyID,ModuleFlags,Reserved1,ModuleILPath,ModuleNativePath,ClrInstanceID,ManagedPdbSignature,ManagedPdbAge,ManagedPdbBuildPath,NativePdbSignature,NativePdbAge,NativePdbBuildPath,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledAssemblyDCStart(void) {return EventPipeEventEnabledAssemblyDCStart();}

static inline uint32_t FireEtwAssemblyDCStart(
    const uint64_t  AssemblyID,
    const uint64_t  AppDomainID,
    const uint32_t  AssemblyFlags,
    const ep_char8_t*  FullyQualifiedAssemblyName,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventAssemblyDCStart(AssemblyID,AppDomainID,AssemblyFlags,FullyQualifiedAssemblyName,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledAssemblyDCStart_V1(void) {return EventPipeEventEnabledAssemblyDCStart_V1();}

static inline uint32_t FireEtwAssemblyDCStart_V1(
    const uint64_t  AssemblyID,
    const uint64_t  AppDomainID,
    const uint64_t  BindingID,
    const uint32_t  AssemblyFlags,
    const ep_char8_t*  FullyQualifiedAssemblyName,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventAssemblyDCStart_V1(AssemblyID,AppDomainID,BindingID,AssemblyFlags,FullyQualifiedAssemblyName,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledAssemblyDCEnd(void) {return EventPipeEventEnabledAssemblyDCEnd();}

static inline uint32_t FireEtwAssemblyDCEnd(
    const uint64_t  AssemblyID,
    const uint64_t  AppDomainID,
    const uint32_t  AssemblyFlags,
    const ep_char8_t*  FullyQualifiedAssemblyName,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventAssemblyDCEnd(AssemblyID,AppDomainID,AssemblyFlags,FullyQualifiedAssemblyName,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledAssemblyDCEnd_V1(void) {return EventPipeEventEnabledAssemblyDCEnd_V1();}

static inline uint32_t FireEtwAssemblyDCEnd_V1(
    const uint64_t  AssemblyID,
    const uint64_t  AppDomainID,
    const uint64_t  BindingID,
    const uint32_t  AssemblyFlags,
    const ep_char8_t*  FullyQualifiedAssemblyName,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventAssemblyDCEnd_V1(AssemblyID,AppDomainID,BindingID,AssemblyFlags,FullyQualifiedAssemblyName,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledAppDomainDCStart(void) {return EventPipeEventEnabledAppDomainDCStart();}

static inline uint32_t FireEtwAppDomainDCStart(
    const uint64_t  AppDomainID,
    const uint32_t  AppDomainFlags,
    const ep_char8_t*  AppDomainName,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventAppDomainDCStart(AppDomainID,AppDomainFlags,AppDomainName,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledAppDomainDCStart_V1(void) {return EventPipeEventEnabledAppDomainDCStart_V1();}

static inline uint32_t FireEtwAppDomainDCStart_V1(
    const uint64_t  AppDomainID,
    const uint32_t  AppDomainFlags,
    const ep_char8_t*  AppDomainName,
    const uint32_t  AppDomainIndex,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventAppDomainDCStart_V1(AppDomainID,AppDomainFlags,AppDomainName,AppDomainIndex,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledAppDomainDCEnd(void) {return EventPipeEventEnabledAppDomainDCEnd();}

static inline uint32_t FireEtwAppDomainDCEnd(
    const uint64_t  AppDomainID,
    const uint32_t  AppDomainFlags,
    const ep_char8_t*  AppDomainName,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventAppDomainDCEnd(AppDomainID,AppDomainFlags,AppDomainName,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledAppDomainDCEnd_V1(void) {return EventPipeEventEnabledAppDomainDCEnd_V1();}

static inline uint32_t FireEtwAppDomainDCEnd_V1(
    const uint64_t  AppDomainID,
    const uint32_t  AppDomainFlags,
    const ep_char8_t*  AppDomainName,
    const uint32_t  AppDomainIndex,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventAppDomainDCEnd_V1(AppDomainID,AppDomainFlags,AppDomainName,AppDomainIndex,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledThreadDC(void) {return EventPipeEventEnabledThreadDC();}

static inline uint32_t FireEtwThreadDC(
    const uint64_t  ManagedThreadID,
    const uint64_t  AppDomainID,
    const uint32_t  Flags,
    const uint32_t  ManagedThreadIndex,
    const uint32_t  OSThreadID,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventThreadDC(ManagedThreadID,AppDomainID,Flags,ManagedThreadIndex,OSThreadID,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledModuleRangeDCStart(void) {return EventPipeEventEnabledModuleRangeDCStart();}

static inline uint32_t FireEtwModuleRangeDCStart(
    const uint16_t  ClrInstanceID,
    const uint64_t  ModuleID,
    const uint32_t  RangeBegin,
    const uint32_t  RangeSize,
    const uint8_t  RangeType,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventModuleRangeDCStart(ClrInstanceID,ModuleID,RangeBegin,RangeSize,RangeType,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledModuleRangeDCEnd(void) {return EventPipeEventEnabledModuleRangeDCEnd();}

static inline uint32_t FireEtwModuleRangeDCEnd(
    const uint16_t  ClrInstanceID,
    const uint64_t  ModuleID,
    const uint32_t  RangeBegin,
    const uint32_t  RangeSize,
    const uint8_t  RangeType,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventModuleRangeDCEnd(ClrInstanceID,ModuleID,RangeBegin,RangeSize,RangeType,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledRuntimeInformationDCStart(void) {return EventPipeEventEnabledRuntimeInformationDCStart();}

static inline uint32_t FireEtwRuntimeInformationDCStart(
    const uint16_t  ClrInstanceID,
    const uint16_t  Sku,
    const uint16_t  BclMajorVersion,
    const uint16_t  BclMinorVersion,
    const uint16_t  BclBuildNumber,
    const uint16_t  BclQfeNumber,
    const uint16_t  VMMajorVersion,
    const uint16_t  VMMinorVersion,
    const uint16_t  VMBuildNumber,
    const uint16_t  VMQfeNumber,
    const uint32_t  StartupFlags,
    const uint8_t  StartupMode,
    const ep_char8_t*  CommandLine,
    const uint8_t* ComObjectGuid,
    const ep_char8_t*  RuntimeDllPath,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventRuntimeInformationDCStart(ClrInstanceID,Sku,BclMajorVersion,BclMinorVersion,BclBuildNumber,BclQfeNumber,VMMajorVersion,VMMinorVersion,VMBuildNumber,VMQfeNumber,StartupFlags,StartupMode,CommandLine,ComObjectGuid,RuntimeDllPath,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledTieredCompilationSettingsDCStart(void) {return EventPipeEventEnabledTieredCompilationSettingsDCStart();}

static inline uint32_t FireEtwTieredCompilationSettingsDCStart(
    const uint16_t  ClrInstanceID,
    const uint32_t  Flags,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventTieredCompilationSettingsDCStart(ClrInstanceID,Flags,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledExecutionCheckpointDCEnd(void) {return EventPipeEventEnabledExecutionCheckpointDCEnd();}

static inline uint32_t FireEtwExecutionCheckpointDCEnd(
    const uint16_t  ClrInstanceID,
    const ep_char8_t*  Name,
    const int64_t  Timestamp,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventExecutionCheckpointDCEnd(ClrInstanceID,Name,Timestamp,ActivityId,RelatedActivityId);
    return status;
}

__attribute__((weak)) EVENTPIPE_TRACE_CONTEXT MICROSOFT_WINDOWS_DOTNETRUNTIME_RUNDOWN_PROVIDER_EVENTPIPE_Context = { W("Microsoft-Windows-DotNETRuntimeRundown"), 0, false, 0 };
static inline bool EventEnabledStressLogEvent(void) {return EventPipeEventEnabledStressLogEvent();}

static inline uint32_t FireEtwStressLogEvent(
    const uint32_t  Facility,
    const uint8_t  LogLevel,
    const char*  Message,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventStressLogEvent(Facility,LogLevel,Message,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledStressLogEvent_V1(void) {return EventPipeEventEnabledStressLogEvent_V1();}

static inline uint32_t FireEtwStressLogEvent_V1(
    const uint32_t  Facility,
    const uint8_t  LogLevel,
    const char*  Message,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventStressLogEvent_V1(Facility,LogLevel,Message,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledCLRStackWalkStress(void) {return EventPipeEventEnabledCLRStackWalkStress();}

static inline uint32_t FireEtwCLRStackWalkStress(
    const uint16_t  ClrInstanceID,
    const uint8_t  Reserved1,
    const uint8_t  Reserved2,
    const uint32_t  FrameCount,
    const void** Stack,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventCLRStackWalkStress(ClrInstanceID,Reserved1,Reserved2,FrameCount,Stack,ActivityId,RelatedActivityId);
    return status;
}

__attribute__((weak)) EVENTPIPE_TRACE_CONTEXT MICROSOFT_WINDOWS_DOTNETRUNTIME_STRESS_PROVIDER_EVENTPIPE_Context = { W("Microsoft-Windows-DotNETRuntimeStress"), 0, false, 0 };
static inline bool EventEnabledGCDecision(void) {return EventPipeEventEnabledGCDecision();}

static inline uint32_t FireEtwGCDecision(
    const bool  DoCompact,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCDecision(DoCompact,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCDecision_V1(void) {return EventPipeEventEnabledGCDecision_V1();}

static inline uint32_t FireEtwGCDecision_V1(
    const bool  DoCompact,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCDecision_V1(DoCompact,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCSettings(void) {return EventPipeEventEnabledGCSettings();}

static inline uint32_t FireEtwGCSettings(
    const uint64_t  SegmentSize,
    const uint64_t  LargeObjectSegmentSize,
    const bool  ServerGC,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCSettings(SegmentSize,LargeObjectSegmentSize,ServerGC,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCSettings_V1(void) {return EventPipeEventEnabledGCSettings_V1();}

static inline uint32_t FireEtwGCSettings_V1(
    const uint64_t  SegmentSize,
    const uint64_t  LargeObjectSegmentSize,
    const bool  ServerGC,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCSettings_V1(SegmentSize,LargeObjectSegmentSize,ServerGC,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCOptimized(void) {return EventPipeEventEnabledGCOptimized();}

static inline uint32_t FireEtwGCOptimized(
    const uint64_t  DesiredAllocation,
    const uint64_t  NewAllocation,
    const uint32_t  GenerationNumber,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCOptimized(DesiredAllocation,NewAllocation,GenerationNumber,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCOptimized_V1(void) {return EventPipeEventEnabledGCOptimized_V1();}

static inline uint32_t FireEtwGCOptimized_V1(
    const uint64_t  DesiredAllocation,
    const uint64_t  NewAllocation,
    const uint32_t  GenerationNumber,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCOptimized_V1(DesiredAllocation,NewAllocation,GenerationNumber,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCPerHeapHistory(void) {return EventPipeEventEnabledGCPerHeapHistory();}

static inline uint32_t FireEtwGCPerHeapHistory(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCPerHeapHistory(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCPerHeapHistory_V1(void) {return EventPipeEventEnabledGCPerHeapHistory_V1();}

static inline uint32_t FireEtwGCPerHeapHistory_V1(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCPerHeapHistory_V1(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCGlobalHeapHistory(void) {return EventPipeEventEnabledGCGlobalHeapHistory();}

static inline uint32_t FireEtwGCGlobalHeapHistory(
    const uint64_t  FinalYoungestDesired,
    const int32_t  NumHeaps,
    const uint32_t  CondemnedGeneration,
    const uint32_t  Gen0ReductionCount,
    const uint32_t  Reason,
    const uint32_t  GlobalMechanisms,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCGlobalHeapHistory(FinalYoungestDesired,NumHeaps,CondemnedGeneration,Gen0ReductionCount,Reason,GlobalMechanisms,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCGlobalHeapHistory_V1(void) {return EventPipeEventEnabledGCGlobalHeapHistory_V1();}

static inline uint32_t FireEtwGCGlobalHeapHistory_V1(
    const uint64_t  FinalYoungestDesired,
    const int32_t  NumHeaps,
    const uint32_t  CondemnedGeneration,
    const uint32_t  Gen0ReductionCount,
    const uint32_t  Reason,
    const uint32_t  GlobalMechanisms,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCGlobalHeapHistory_V1(FinalYoungestDesired,NumHeaps,CondemnedGeneration,Gen0ReductionCount,Reason,GlobalMechanisms,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCJoin(void) {return EventPipeEventEnabledGCJoin();}

static inline uint32_t FireEtwGCJoin(
    const uint32_t  Heap,
    const uint32_t  JoinTime,
    const uint32_t  JoinType,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCJoin(Heap,JoinTime,JoinType,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCJoin_V1(void) {return EventPipeEventEnabledGCJoin_V1();}

static inline uint32_t FireEtwGCJoin_V1(
    const uint32_t  Heap,
    const uint32_t  JoinTime,
    const uint32_t  JoinType,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCJoin_V1(Heap,JoinTime,JoinType,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledPrvGCMarkStackRoots(void) {return EventPipeEventEnabledPrvGCMarkStackRoots();}

static inline uint32_t FireEtwPrvGCMarkStackRoots(
    const uint32_t  HeapNum,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventPrvGCMarkStackRoots(HeapNum,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledPrvGCMarkStackRoots_V1(void) {return EventPipeEventEnabledPrvGCMarkStackRoots_V1();}

static inline uint32_t FireEtwPrvGCMarkStackRoots_V1(
    const uint32_t  HeapNum,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventPrvGCMarkStackRoots_V1(HeapNum,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledPrvGCMarkFinalizeQueueRoots(void) {return EventPipeEventEnabledPrvGCMarkFinalizeQueueRoots();}

static inline uint32_t FireEtwPrvGCMarkFinalizeQueueRoots(
    const uint32_t  HeapNum,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventPrvGCMarkFinalizeQueueRoots(HeapNum,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledPrvGCMarkFinalizeQueueRoots_V1(void) {return EventPipeEventEnabledPrvGCMarkFinalizeQueueRoots_V1();}

static inline uint32_t FireEtwPrvGCMarkFinalizeQueueRoots_V1(
    const uint32_t  HeapNum,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventPrvGCMarkFinalizeQueueRoots_V1(HeapNum,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledPrvGCMarkHandles(void) {return EventPipeEventEnabledPrvGCMarkHandles();}

static inline uint32_t FireEtwPrvGCMarkHandles(
    const uint32_t  HeapNum,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventPrvGCMarkHandles(HeapNum,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledPrvGCMarkHandles_V1(void) {return EventPipeEventEnabledPrvGCMarkHandles_V1();}

static inline uint32_t FireEtwPrvGCMarkHandles_V1(
    const uint32_t  HeapNum,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventPrvGCMarkHandles_V1(HeapNum,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledPrvGCMarkCards(void) {return EventPipeEventEnabledPrvGCMarkCards();}

static inline uint32_t FireEtwPrvGCMarkCards(
    const uint32_t  HeapNum,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventPrvGCMarkCards(HeapNum,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledPrvGCMarkCards_V1(void) {return EventPipeEventEnabledPrvGCMarkCards_V1();}

static inline uint32_t FireEtwPrvGCMarkCards_V1(
    const uint32_t  HeapNum,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventPrvGCMarkCards_V1(HeapNum,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledBGCBegin(void) {return EventPipeEventEnabledBGCBegin();}

static inline uint32_t FireEtwBGCBegin(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventBGCBegin(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledBGC1stNonConEnd(void) {return EventPipeEventEnabledBGC1stNonConEnd();}

static inline uint32_t FireEtwBGC1stNonConEnd(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventBGC1stNonConEnd(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledBGC1stConEnd(void) {return EventPipeEventEnabledBGC1stConEnd();}

static inline uint32_t FireEtwBGC1stConEnd(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventBGC1stConEnd(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledBGC2ndNonConBegin(void) {return EventPipeEventEnabledBGC2ndNonConBegin();}

static inline uint32_t FireEtwBGC2ndNonConBegin(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventBGC2ndNonConBegin(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledBGC2ndNonConEnd(void) {return EventPipeEventEnabledBGC2ndNonConEnd();}

static inline uint32_t FireEtwBGC2ndNonConEnd(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventBGC2ndNonConEnd(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledBGC2ndConBegin(void) {return EventPipeEventEnabledBGC2ndConBegin();}

static inline uint32_t FireEtwBGC2ndConBegin(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventBGC2ndConBegin(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledBGC2ndConEnd(void) {return EventPipeEventEnabledBGC2ndConEnd();}

static inline uint32_t FireEtwBGC2ndConEnd(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventBGC2ndConEnd(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledBGCPlanEnd(void) {return EventPipeEventEnabledBGCPlanEnd();}

static inline uint32_t FireEtwBGCPlanEnd(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventBGCPlanEnd(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledBGCSweepEnd(void) {return EventPipeEventEnabledBGCSweepEnd();}

static inline uint32_t FireEtwBGCSweepEnd(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventBGCSweepEnd(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledBGCDrainMark(void) {return EventPipeEventEnabledBGCDrainMark();}

static inline uint32_t FireEtwBGCDrainMark(
    const uint64_t  Objects,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventBGCDrainMark(Objects,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledBGCRevisit(void) {return EventPipeEventEnabledBGCRevisit();}

static inline uint32_t FireEtwBGCRevisit(
    const uint64_t  Pages,
    const uint64_t  Objects,
    const uint32_t  IsLarge,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventBGCRevisit(Pages,Objects,IsLarge,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledBGCOverflow(void) {return EventPipeEventEnabledBGCOverflow();}

static inline uint32_t FireEtwBGCOverflow(
    const uint64_t  Min,
    const uint64_t  Max,
    const uint64_t  Objects,
    const uint32_t  IsLarge,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventBGCOverflow(Min,Max,Objects,IsLarge,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledBGCOverflow_V1(void) {return EventPipeEventEnabledBGCOverflow_V1();}

static inline uint32_t FireEtwBGCOverflow_V1(
    const uint64_t  Min,
    const uint64_t  Max,
    const uint64_t  Objects,
    const uint32_t  IsLarge,
    const uint16_t  ClrInstanceID,
    const uint32_t  GenNumber,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventBGCOverflow_V1(Min,Max,Objects,IsLarge,ClrInstanceID,GenNumber,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledBGCAllocWaitBegin(void) {return EventPipeEventEnabledBGCAllocWaitBegin();}

static inline uint32_t FireEtwBGCAllocWaitBegin(
    const uint32_t  Reason,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventBGCAllocWaitBegin(Reason,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledBGCAllocWaitEnd(void) {return EventPipeEventEnabledBGCAllocWaitEnd();}

static inline uint32_t FireEtwBGCAllocWaitEnd(
    const uint32_t  Reason,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventBGCAllocWaitEnd(Reason,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCFullNotify(void) {return EventPipeEventEnabledGCFullNotify();}

static inline uint32_t FireEtwGCFullNotify(
    const uint32_t  GenNumber,
    const uint32_t  IsAlloc,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCFullNotify(GenNumber,IsAlloc,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCFullNotify_V1(void) {return EventPipeEventEnabledGCFullNotify_V1();}

static inline uint32_t FireEtwGCFullNotify_V1(
    const uint32_t  GenNumber,
    const uint32_t  IsAlloc,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCFullNotify_V1(GenNumber,IsAlloc,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledBGC1stSweepEnd(void) {return EventPipeEventEnabledBGC1stSweepEnd();}

static inline uint32_t FireEtwBGC1stSweepEnd(
    const uint32_t  GenNumber,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventBGC1stSweepEnd(GenNumber,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledEEStartupStart(void) {return EventPipeEventEnabledEEStartupStart();}

static inline uint32_t FireEtwEEStartupStart(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventEEStartupStart(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledEEStartupStart_V1(void) {return EventPipeEventEnabledEEStartupStart_V1();}

static inline uint32_t FireEtwEEStartupStart_V1(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventEEStartupStart_V1(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledEEStartupEnd(void) {return EventPipeEventEnabledEEStartupEnd();}

static inline uint32_t FireEtwEEStartupEnd(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventEEStartupEnd(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledEEStartupEnd_V1(void) {return EventPipeEventEnabledEEStartupEnd_V1();}

static inline uint32_t FireEtwEEStartupEnd_V1(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventEEStartupEnd_V1(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledEEConfigSetup(void) {return EventPipeEventEnabledEEConfigSetup();}

static inline uint32_t FireEtwEEConfigSetup(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventEEConfigSetup(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledEEConfigSetup_V1(void) {return EventPipeEventEnabledEEConfigSetup_V1();}

static inline uint32_t FireEtwEEConfigSetup_V1(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventEEConfigSetup_V1(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledEEConfigSetupEnd(void) {return EventPipeEventEnabledEEConfigSetupEnd();}

static inline uint32_t FireEtwEEConfigSetupEnd(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventEEConfigSetupEnd(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledEEConfigSetupEnd_V1(void) {return EventPipeEventEnabledEEConfigSetupEnd_V1();}

static inline uint32_t FireEtwEEConfigSetupEnd_V1(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventEEConfigSetupEnd_V1(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledLdSysBases(void) {return EventPipeEventEnabledLdSysBases();}

static inline uint32_t FireEtwLdSysBases(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventLdSysBases(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledLdSysBases_V1(void) {return EventPipeEventEnabledLdSysBases_V1();}

static inline uint32_t FireEtwLdSysBases_V1(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventLdSysBases_V1(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledLdSysBasesEnd(void) {return EventPipeEventEnabledLdSysBasesEnd();}

static inline uint32_t FireEtwLdSysBasesEnd(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventLdSysBasesEnd(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledLdSysBasesEnd_V1(void) {return EventPipeEventEnabledLdSysBasesEnd_V1();}

static inline uint32_t FireEtwLdSysBasesEnd_V1(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventLdSysBasesEnd_V1(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledExecExe(void) {return EventPipeEventEnabledExecExe();}

static inline uint32_t FireEtwExecExe(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventExecExe(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledExecExe_V1(void) {return EventPipeEventEnabledExecExe_V1();}

static inline uint32_t FireEtwExecExe_V1(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventExecExe_V1(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledExecExeEnd(void) {return EventPipeEventEnabledExecExeEnd();}

static inline uint32_t FireEtwExecExeEnd(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventExecExeEnd(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledExecExeEnd_V1(void) {return EventPipeEventEnabledExecExeEnd_V1();}

static inline uint32_t FireEtwExecExeEnd_V1(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventExecExeEnd_V1(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMain(void) {return EventPipeEventEnabledMain();}

static inline uint32_t FireEtwMain(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMain(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMain_V1(void) {return EventPipeEventEnabledMain_V1();}

static inline uint32_t FireEtwMain_V1(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMain_V1(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMainEnd(void) {return EventPipeEventEnabledMainEnd();}

static inline uint32_t FireEtwMainEnd(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMainEnd(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMainEnd_V1(void) {return EventPipeEventEnabledMainEnd_V1();}

static inline uint32_t FireEtwMainEnd_V1(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMainEnd_V1(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledApplyPolicyStart(void) {return EventPipeEventEnabledApplyPolicyStart();}

static inline uint32_t FireEtwApplyPolicyStart(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventApplyPolicyStart(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledApplyPolicyStart_V1(void) {return EventPipeEventEnabledApplyPolicyStart_V1();}

static inline uint32_t FireEtwApplyPolicyStart_V1(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventApplyPolicyStart_V1(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledApplyPolicyEnd(void) {return EventPipeEventEnabledApplyPolicyEnd();}

static inline uint32_t FireEtwApplyPolicyEnd(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventApplyPolicyEnd(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledApplyPolicyEnd_V1(void) {return EventPipeEventEnabledApplyPolicyEnd_V1();}

static inline uint32_t FireEtwApplyPolicyEnd_V1(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventApplyPolicyEnd_V1(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledLdLibShFolder(void) {return EventPipeEventEnabledLdLibShFolder();}

static inline uint32_t FireEtwLdLibShFolder(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventLdLibShFolder(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledLdLibShFolder_V1(void) {return EventPipeEventEnabledLdLibShFolder_V1();}

static inline uint32_t FireEtwLdLibShFolder_V1(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventLdLibShFolder_V1(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledLdLibShFolderEnd(void) {return EventPipeEventEnabledLdLibShFolderEnd();}

static inline uint32_t FireEtwLdLibShFolderEnd(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventLdLibShFolderEnd(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledLdLibShFolderEnd_V1(void) {return EventPipeEventEnabledLdLibShFolderEnd_V1();}

static inline uint32_t FireEtwLdLibShFolderEnd_V1(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventLdLibShFolderEnd_V1(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledPrestubWorker(void) {return EventPipeEventEnabledPrestubWorker();}

static inline uint32_t FireEtwPrestubWorker(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventPrestubWorker(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledPrestubWorker_V1(void) {return EventPipeEventEnabledPrestubWorker_V1();}

static inline uint32_t FireEtwPrestubWorker_V1(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventPrestubWorker_V1(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledPrestubWorkerEnd(void) {return EventPipeEventEnabledPrestubWorkerEnd();}

static inline uint32_t FireEtwPrestubWorkerEnd(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventPrestubWorkerEnd(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledPrestubWorkerEnd_V1(void) {return EventPipeEventEnabledPrestubWorkerEnd_V1();}

static inline uint32_t FireEtwPrestubWorkerEnd_V1(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventPrestubWorkerEnd_V1(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGetInstallationStart(void) {return EventPipeEventEnabledGetInstallationStart();}

static inline uint32_t FireEtwGetInstallationStart(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGetInstallationStart(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGetInstallationStart_V1(void) {return EventPipeEventEnabledGetInstallationStart_V1();}

static inline uint32_t FireEtwGetInstallationStart_V1(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGetInstallationStart_V1(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGetInstallationEnd(void) {return EventPipeEventEnabledGetInstallationEnd();}

static inline uint32_t FireEtwGetInstallationEnd(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGetInstallationEnd(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGetInstallationEnd_V1(void) {return EventPipeEventEnabledGetInstallationEnd_V1();}

static inline uint32_t FireEtwGetInstallationEnd_V1(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGetInstallationEnd_V1(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledOpenHModule(void) {return EventPipeEventEnabledOpenHModule();}

static inline uint32_t FireEtwOpenHModule(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventOpenHModule(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledOpenHModule_V1(void) {return EventPipeEventEnabledOpenHModule_V1();}

static inline uint32_t FireEtwOpenHModule_V1(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventOpenHModule_V1(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledOpenHModuleEnd(void) {return EventPipeEventEnabledOpenHModuleEnd();}

static inline uint32_t FireEtwOpenHModuleEnd(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventOpenHModuleEnd(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledOpenHModuleEnd_V1(void) {return EventPipeEventEnabledOpenHModuleEnd_V1();}

static inline uint32_t FireEtwOpenHModuleEnd_V1(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventOpenHModuleEnd_V1(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledExplicitBindStart(void) {return EventPipeEventEnabledExplicitBindStart();}

static inline uint32_t FireEtwExplicitBindStart(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventExplicitBindStart(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledExplicitBindStart_V1(void) {return EventPipeEventEnabledExplicitBindStart_V1();}

static inline uint32_t FireEtwExplicitBindStart_V1(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventExplicitBindStart_V1(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledExplicitBindEnd(void) {return EventPipeEventEnabledExplicitBindEnd();}

static inline uint32_t FireEtwExplicitBindEnd(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventExplicitBindEnd(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledExplicitBindEnd_V1(void) {return EventPipeEventEnabledExplicitBindEnd_V1();}

static inline uint32_t FireEtwExplicitBindEnd_V1(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventExplicitBindEnd_V1(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledParseXml(void) {return EventPipeEventEnabledParseXml();}

static inline uint32_t FireEtwParseXml(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventParseXml(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledParseXml_V1(void) {return EventPipeEventEnabledParseXml_V1();}

static inline uint32_t FireEtwParseXml_V1(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventParseXml_V1(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledParseXmlEnd(void) {return EventPipeEventEnabledParseXmlEnd();}

static inline uint32_t FireEtwParseXmlEnd(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventParseXmlEnd(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledParseXmlEnd_V1(void) {return EventPipeEventEnabledParseXmlEnd_V1();}

static inline uint32_t FireEtwParseXmlEnd_V1(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventParseXmlEnd_V1(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledInitDefaultDomain(void) {return EventPipeEventEnabledInitDefaultDomain();}

static inline uint32_t FireEtwInitDefaultDomain(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventInitDefaultDomain(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledInitDefaultDomain_V1(void) {return EventPipeEventEnabledInitDefaultDomain_V1();}

static inline uint32_t FireEtwInitDefaultDomain_V1(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventInitDefaultDomain_V1(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledInitDefaultDomainEnd(void) {return EventPipeEventEnabledInitDefaultDomainEnd();}

static inline uint32_t FireEtwInitDefaultDomainEnd(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventInitDefaultDomainEnd(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledInitDefaultDomainEnd_V1(void) {return EventPipeEventEnabledInitDefaultDomainEnd_V1();}

static inline uint32_t FireEtwInitDefaultDomainEnd_V1(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventInitDefaultDomainEnd_V1(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledInitSecurity(void) {return EventPipeEventEnabledInitSecurity();}

static inline uint32_t FireEtwInitSecurity(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventInitSecurity(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledInitSecurity_V1(void) {return EventPipeEventEnabledInitSecurity_V1();}

static inline uint32_t FireEtwInitSecurity_V1(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventInitSecurity_V1(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledInitSecurityEnd(void) {return EventPipeEventEnabledInitSecurityEnd();}

static inline uint32_t FireEtwInitSecurityEnd(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventInitSecurityEnd(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledInitSecurityEnd_V1(void) {return EventPipeEventEnabledInitSecurityEnd_V1();}

static inline uint32_t FireEtwInitSecurityEnd_V1(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventInitSecurityEnd_V1(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledAllowBindingRedirs(void) {return EventPipeEventEnabledAllowBindingRedirs();}

static inline uint32_t FireEtwAllowBindingRedirs(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventAllowBindingRedirs(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledAllowBindingRedirs_V1(void) {return EventPipeEventEnabledAllowBindingRedirs_V1();}

static inline uint32_t FireEtwAllowBindingRedirs_V1(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventAllowBindingRedirs_V1(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledAllowBindingRedirsEnd(void) {return EventPipeEventEnabledAllowBindingRedirsEnd();}

static inline uint32_t FireEtwAllowBindingRedirsEnd(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventAllowBindingRedirsEnd(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledAllowBindingRedirsEnd_V1(void) {return EventPipeEventEnabledAllowBindingRedirsEnd_V1();}

static inline uint32_t FireEtwAllowBindingRedirsEnd_V1(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventAllowBindingRedirsEnd_V1(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledEEConfigSync(void) {return EventPipeEventEnabledEEConfigSync();}

static inline uint32_t FireEtwEEConfigSync(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventEEConfigSync(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledEEConfigSync_V1(void) {return EventPipeEventEnabledEEConfigSync_V1();}

static inline uint32_t FireEtwEEConfigSync_V1(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventEEConfigSync_V1(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledEEConfigSyncEnd(void) {return EventPipeEventEnabledEEConfigSyncEnd();}

static inline uint32_t FireEtwEEConfigSyncEnd(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventEEConfigSyncEnd(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledEEConfigSyncEnd_V1(void) {return EventPipeEventEnabledEEConfigSyncEnd_V1();}

static inline uint32_t FireEtwEEConfigSyncEnd_V1(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventEEConfigSyncEnd_V1(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledFusionBinding(void) {return EventPipeEventEnabledFusionBinding();}

static inline uint32_t FireEtwFusionBinding(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventFusionBinding(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledFusionBinding_V1(void) {return EventPipeEventEnabledFusionBinding_V1();}

static inline uint32_t FireEtwFusionBinding_V1(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventFusionBinding_V1(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledFusionBindingEnd(void) {return EventPipeEventEnabledFusionBindingEnd();}

static inline uint32_t FireEtwFusionBindingEnd(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventFusionBindingEnd(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledFusionBindingEnd_V1(void) {return EventPipeEventEnabledFusionBindingEnd_V1();}

static inline uint32_t FireEtwFusionBindingEnd_V1(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventFusionBindingEnd_V1(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledLoaderCatchCall(void) {return EventPipeEventEnabledLoaderCatchCall();}

static inline uint32_t FireEtwLoaderCatchCall(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventLoaderCatchCall(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledLoaderCatchCall_V1(void) {return EventPipeEventEnabledLoaderCatchCall_V1();}

static inline uint32_t FireEtwLoaderCatchCall_V1(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventLoaderCatchCall_V1(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledLoaderCatchCallEnd(void) {return EventPipeEventEnabledLoaderCatchCallEnd();}

static inline uint32_t FireEtwLoaderCatchCallEnd(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventLoaderCatchCallEnd(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledLoaderCatchCallEnd_V1(void) {return EventPipeEventEnabledLoaderCatchCallEnd_V1();}

static inline uint32_t FireEtwLoaderCatchCallEnd_V1(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventLoaderCatchCallEnd_V1(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledFusionInit(void) {return EventPipeEventEnabledFusionInit();}

static inline uint32_t FireEtwFusionInit(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventFusionInit(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledFusionInit_V1(void) {return EventPipeEventEnabledFusionInit_V1();}

static inline uint32_t FireEtwFusionInit_V1(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventFusionInit_V1(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledFusionInitEnd(void) {return EventPipeEventEnabledFusionInitEnd();}

static inline uint32_t FireEtwFusionInitEnd(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventFusionInitEnd(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledFusionInitEnd_V1(void) {return EventPipeEventEnabledFusionInitEnd_V1();}

static inline uint32_t FireEtwFusionInitEnd_V1(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventFusionInitEnd_V1(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledFusionAppCtx(void) {return EventPipeEventEnabledFusionAppCtx();}

static inline uint32_t FireEtwFusionAppCtx(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventFusionAppCtx(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledFusionAppCtx_V1(void) {return EventPipeEventEnabledFusionAppCtx_V1();}

static inline uint32_t FireEtwFusionAppCtx_V1(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventFusionAppCtx_V1(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledFusionAppCtxEnd(void) {return EventPipeEventEnabledFusionAppCtxEnd();}

static inline uint32_t FireEtwFusionAppCtxEnd(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventFusionAppCtxEnd(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledFusionAppCtxEnd_V1(void) {return EventPipeEventEnabledFusionAppCtxEnd_V1();}

static inline uint32_t FireEtwFusionAppCtxEnd_V1(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventFusionAppCtxEnd_V1(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledFusion2EE(void) {return EventPipeEventEnabledFusion2EE();}

static inline uint32_t FireEtwFusion2EE(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventFusion2EE(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledFusion2EE_V1(void) {return EventPipeEventEnabledFusion2EE_V1();}

static inline uint32_t FireEtwFusion2EE_V1(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventFusion2EE_V1(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledFusion2EEEnd(void) {return EventPipeEventEnabledFusion2EEEnd();}

static inline uint32_t FireEtwFusion2EEEnd(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventFusion2EEEnd(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledFusion2EEEnd_V1(void) {return EventPipeEventEnabledFusion2EEEnd_V1();}

static inline uint32_t FireEtwFusion2EEEnd_V1(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventFusion2EEEnd_V1(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledSecurityCatchCall(void) {return EventPipeEventEnabledSecurityCatchCall();}

static inline uint32_t FireEtwSecurityCatchCall(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventSecurityCatchCall(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledSecurityCatchCall_V1(void) {return EventPipeEventEnabledSecurityCatchCall_V1();}

static inline uint32_t FireEtwSecurityCatchCall_V1(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventSecurityCatchCall_V1(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledSecurityCatchCallEnd(void) {return EventPipeEventEnabledSecurityCatchCallEnd();}

static inline uint32_t FireEtwSecurityCatchCallEnd(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventSecurityCatchCallEnd(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledSecurityCatchCallEnd_V1(void) {return EventPipeEventEnabledSecurityCatchCallEnd_V1();}

static inline uint32_t FireEtwSecurityCatchCallEnd_V1(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventSecurityCatchCallEnd_V1(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledCLRStackWalkPrivate(void) {return EventPipeEventEnabledCLRStackWalkPrivate();}

static inline uint32_t FireEtwCLRStackWalkPrivate(
    const uint16_t  ClrInstanceID,
    const uint8_t  Reserved1,
    const uint8_t  Reserved2,
    const uint32_t  FrameCount,
    const void** Stack,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventCLRStackWalkPrivate(ClrInstanceID,Reserved1,Reserved2,FrameCount,Stack,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledModuleRangeLoadPrivate(void) {return EventPipeEventEnabledModuleRangeLoadPrivate();}

static inline uint32_t FireEtwModuleRangeLoadPrivate(
    const uint16_t  ClrInstanceID,
    const uint64_t  ModuleID,
    const uint32_t  RangeBegin,
    const uint32_t  RangeSize,
    const uint8_t  RangeType,
    const uint8_t  IBCType,
    const uint16_t  SectionType,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventModuleRangeLoadPrivate(ClrInstanceID,ModuleID,RangeBegin,RangeSize,RangeType,IBCType,SectionType,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledBindingPolicyPhaseStart(void) {return EventPipeEventEnabledBindingPolicyPhaseStart();}

static inline uint32_t FireEtwBindingPolicyPhaseStart(
    const uint32_t  AppDomainID,
    const uint32_t  LoadContextID,
    const uint32_t  FromLoaderCache,
    const uint32_t  DynamicLoad,
    const ep_char8_t*  AssemblyCodebase,
    const ep_char8_t*  AssemblyName,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventBindingPolicyPhaseStart(AppDomainID,LoadContextID,FromLoaderCache,DynamicLoad,AssemblyCodebase,AssemblyName,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledBindingPolicyPhaseEnd(void) {return EventPipeEventEnabledBindingPolicyPhaseEnd();}

static inline uint32_t FireEtwBindingPolicyPhaseEnd(
    const uint32_t  AppDomainID,
    const uint32_t  LoadContextID,
    const uint32_t  FromLoaderCache,
    const uint32_t  DynamicLoad,
    const ep_char8_t*  AssemblyCodebase,
    const ep_char8_t*  AssemblyName,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventBindingPolicyPhaseEnd(AppDomainID,LoadContextID,FromLoaderCache,DynamicLoad,AssemblyCodebase,AssemblyName,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledBindingNgenPhaseStart(void) {return EventPipeEventEnabledBindingNgenPhaseStart();}

static inline uint32_t FireEtwBindingNgenPhaseStart(
    const uint32_t  AppDomainID,
    const uint32_t  LoadContextID,
    const uint32_t  FromLoaderCache,
    const uint32_t  DynamicLoad,
    const ep_char8_t*  AssemblyCodebase,
    const ep_char8_t*  AssemblyName,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventBindingNgenPhaseStart(AppDomainID,LoadContextID,FromLoaderCache,DynamicLoad,AssemblyCodebase,AssemblyName,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledBindingNgenPhaseEnd(void) {return EventPipeEventEnabledBindingNgenPhaseEnd();}

static inline uint32_t FireEtwBindingNgenPhaseEnd(
    const uint32_t  AppDomainID,
    const uint32_t  LoadContextID,
    const uint32_t  FromLoaderCache,
    const uint32_t  DynamicLoad,
    const ep_char8_t*  AssemblyCodebase,
    const ep_char8_t*  AssemblyName,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventBindingNgenPhaseEnd(AppDomainID,LoadContextID,FromLoaderCache,DynamicLoad,AssemblyCodebase,AssemblyName,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledBindingLookupAndProbingPhaseStart(void) {return EventPipeEventEnabledBindingLookupAndProbingPhaseStart();}

static inline uint32_t FireEtwBindingLookupAndProbingPhaseStart(
    const uint32_t  AppDomainID,
    const uint32_t  LoadContextID,
    const uint32_t  FromLoaderCache,
    const uint32_t  DynamicLoad,
    const ep_char8_t*  AssemblyCodebase,
    const ep_char8_t*  AssemblyName,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventBindingLookupAndProbingPhaseStart(AppDomainID,LoadContextID,FromLoaderCache,DynamicLoad,AssemblyCodebase,AssemblyName,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledBindingLookupAndProbingPhaseEnd(void) {return EventPipeEventEnabledBindingLookupAndProbingPhaseEnd();}

static inline uint32_t FireEtwBindingLookupAndProbingPhaseEnd(
    const uint32_t  AppDomainID,
    const uint32_t  LoadContextID,
    const uint32_t  FromLoaderCache,
    const uint32_t  DynamicLoad,
    const ep_char8_t*  AssemblyCodebase,
    const ep_char8_t*  AssemblyName,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventBindingLookupAndProbingPhaseEnd(AppDomainID,LoadContextID,FromLoaderCache,DynamicLoad,AssemblyCodebase,AssemblyName,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledLoaderPhaseStart(void) {return EventPipeEventEnabledLoaderPhaseStart();}

static inline uint32_t FireEtwLoaderPhaseStart(
    const uint32_t  AppDomainID,
    const uint32_t  LoadContextID,
    const uint32_t  FromLoaderCache,
    const uint32_t  DynamicLoad,
    const ep_char8_t*  AssemblyCodebase,
    const ep_char8_t*  AssemblyName,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventLoaderPhaseStart(AppDomainID,LoadContextID,FromLoaderCache,DynamicLoad,AssemblyCodebase,AssemblyName,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledLoaderPhaseEnd(void) {return EventPipeEventEnabledLoaderPhaseEnd();}

static inline uint32_t FireEtwLoaderPhaseEnd(
    const uint32_t  AppDomainID,
    const uint32_t  LoadContextID,
    const uint32_t  FromLoaderCache,
    const uint32_t  DynamicLoad,
    const ep_char8_t*  AssemblyCodebase,
    const ep_char8_t*  AssemblyName,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventLoaderPhaseEnd(AppDomainID,LoadContextID,FromLoaderCache,DynamicLoad,AssemblyCodebase,AssemblyName,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledBindingPhaseStart(void) {return EventPipeEventEnabledBindingPhaseStart();}

static inline uint32_t FireEtwBindingPhaseStart(
    const uint32_t  AppDomainID,
    const uint32_t  LoadContextID,
    const uint32_t  FromLoaderCache,
    const uint32_t  DynamicLoad,
    const ep_char8_t*  AssemblyCodebase,
    const ep_char8_t*  AssemblyName,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventBindingPhaseStart(AppDomainID,LoadContextID,FromLoaderCache,DynamicLoad,AssemblyCodebase,AssemblyName,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledBindingPhaseEnd(void) {return EventPipeEventEnabledBindingPhaseEnd();}

static inline uint32_t FireEtwBindingPhaseEnd(
    const uint32_t  AppDomainID,
    const uint32_t  LoadContextID,
    const uint32_t  FromLoaderCache,
    const uint32_t  DynamicLoad,
    const ep_char8_t*  AssemblyCodebase,
    const ep_char8_t*  AssemblyName,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventBindingPhaseEnd(AppDomainID,LoadContextID,FromLoaderCache,DynamicLoad,AssemblyCodebase,AssemblyName,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledBindingDownloadPhaseStart(void) {return EventPipeEventEnabledBindingDownloadPhaseStart();}

static inline uint32_t FireEtwBindingDownloadPhaseStart(
    const uint32_t  AppDomainID,
    const uint32_t  LoadContextID,
    const uint32_t  FromLoaderCache,
    const uint32_t  DynamicLoad,
    const ep_char8_t*  AssemblyCodebase,
    const ep_char8_t*  AssemblyName,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventBindingDownloadPhaseStart(AppDomainID,LoadContextID,FromLoaderCache,DynamicLoad,AssemblyCodebase,AssemblyName,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledBindingDownloadPhaseEnd(void) {return EventPipeEventEnabledBindingDownloadPhaseEnd();}

static inline uint32_t FireEtwBindingDownloadPhaseEnd(
    const uint32_t  AppDomainID,
    const uint32_t  LoadContextID,
    const uint32_t  FromLoaderCache,
    const uint32_t  DynamicLoad,
    const ep_char8_t*  AssemblyCodebase,
    const ep_char8_t*  AssemblyName,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventBindingDownloadPhaseEnd(AppDomainID,LoadContextID,FromLoaderCache,DynamicLoad,AssemblyCodebase,AssemblyName,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledLoaderAssemblyInitPhaseStart(void) {return EventPipeEventEnabledLoaderAssemblyInitPhaseStart();}

static inline uint32_t FireEtwLoaderAssemblyInitPhaseStart(
    const uint32_t  AppDomainID,
    const uint32_t  LoadContextID,
    const uint32_t  FromLoaderCache,
    const uint32_t  DynamicLoad,
    const ep_char8_t*  AssemblyCodebase,
    const ep_char8_t*  AssemblyName,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventLoaderAssemblyInitPhaseStart(AppDomainID,LoadContextID,FromLoaderCache,DynamicLoad,AssemblyCodebase,AssemblyName,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledLoaderAssemblyInitPhaseEnd(void) {return EventPipeEventEnabledLoaderAssemblyInitPhaseEnd();}

static inline uint32_t FireEtwLoaderAssemblyInitPhaseEnd(
    const uint32_t  AppDomainID,
    const uint32_t  LoadContextID,
    const uint32_t  FromLoaderCache,
    const uint32_t  DynamicLoad,
    const ep_char8_t*  AssemblyCodebase,
    const ep_char8_t*  AssemblyName,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventLoaderAssemblyInitPhaseEnd(AppDomainID,LoadContextID,FromLoaderCache,DynamicLoad,AssemblyCodebase,AssemblyName,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledLoaderMappingPhaseStart(void) {return EventPipeEventEnabledLoaderMappingPhaseStart();}

static inline uint32_t FireEtwLoaderMappingPhaseStart(
    const uint32_t  AppDomainID,
    const uint32_t  LoadContextID,
    const uint32_t  FromLoaderCache,
    const uint32_t  DynamicLoad,
    const ep_char8_t*  AssemblyCodebase,
    const ep_char8_t*  AssemblyName,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventLoaderMappingPhaseStart(AppDomainID,LoadContextID,FromLoaderCache,DynamicLoad,AssemblyCodebase,AssemblyName,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledLoaderMappingPhaseEnd(void) {return EventPipeEventEnabledLoaderMappingPhaseEnd();}

static inline uint32_t FireEtwLoaderMappingPhaseEnd(
    const uint32_t  AppDomainID,
    const uint32_t  LoadContextID,
    const uint32_t  FromLoaderCache,
    const uint32_t  DynamicLoad,
    const ep_char8_t*  AssemblyCodebase,
    const ep_char8_t*  AssemblyName,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventLoaderMappingPhaseEnd(AppDomainID,LoadContextID,FromLoaderCache,DynamicLoad,AssemblyCodebase,AssemblyName,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledLoaderDeliverEventsPhaseStart(void) {return EventPipeEventEnabledLoaderDeliverEventsPhaseStart();}

static inline uint32_t FireEtwLoaderDeliverEventsPhaseStart(
    const uint32_t  AppDomainID,
    const uint32_t  LoadContextID,
    const uint32_t  FromLoaderCache,
    const uint32_t  DynamicLoad,
    const ep_char8_t*  AssemblyCodebase,
    const ep_char8_t*  AssemblyName,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventLoaderDeliverEventsPhaseStart(AppDomainID,LoadContextID,FromLoaderCache,DynamicLoad,AssemblyCodebase,AssemblyName,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledLoaderDeliverEventsPhaseEnd(void) {return EventPipeEventEnabledLoaderDeliverEventsPhaseEnd();}

static inline uint32_t FireEtwLoaderDeliverEventsPhaseEnd(
    const uint32_t  AppDomainID,
    const uint32_t  LoadContextID,
    const uint32_t  FromLoaderCache,
    const uint32_t  DynamicLoad,
    const ep_char8_t*  AssemblyCodebase,
    const ep_char8_t*  AssemblyName,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventLoaderDeliverEventsPhaseEnd(AppDomainID,LoadContextID,FromLoaderCache,DynamicLoad,AssemblyCodebase,AssemblyName,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledEvidenceGenerated(void) {return EventPipeEventEnabledEvidenceGenerated();}

static inline uint32_t FireEtwEvidenceGenerated(
    const uint32_t  Type,
    const uint32_t  AppDomain,
    const ep_char8_t*  ILImage,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventEvidenceGenerated(Type,AppDomain,ILImage,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledModuleTransparencyComputationStart(void) {return EventPipeEventEnabledModuleTransparencyComputationStart();}

static inline uint32_t FireEtwModuleTransparencyComputationStart(
    const ep_char8_t*  Module,
    const uint32_t  AppDomainID,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventModuleTransparencyComputationStart(Module,AppDomainID,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledModuleTransparencyComputationEnd(void) {return EventPipeEventEnabledModuleTransparencyComputationEnd();}

static inline uint32_t FireEtwModuleTransparencyComputationEnd(
    const ep_char8_t*  Module,
    const uint32_t  AppDomainID,
    const bool  IsAllCritical,
    const bool  IsAllTransparent,
    const bool  IsTreatAsSafe,
    const bool  IsOpportunisticallyCritical,
    const uint32_t  SecurityRuleSet,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventModuleTransparencyComputationEnd(Module,AppDomainID,IsAllCritical,IsAllTransparent,IsTreatAsSafe,IsOpportunisticallyCritical,SecurityRuleSet,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledTypeTransparencyComputationStart(void) {return EventPipeEventEnabledTypeTransparencyComputationStart();}

static inline uint32_t FireEtwTypeTransparencyComputationStart(
    const ep_char8_t*  Type,
    const ep_char8_t*  Module,
    const uint32_t  AppDomainID,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventTypeTransparencyComputationStart(Type,Module,AppDomainID,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledTypeTransparencyComputationEnd(void) {return EventPipeEventEnabledTypeTransparencyComputationEnd();}

static inline uint32_t FireEtwTypeTransparencyComputationEnd(
    const ep_char8_t*  Type,
    const ep_char8_t*  Module,
    const uint32_t  AppDomainID,
    const bool  IsAllCritical,
    const bool  IsAllTransparent,
    const bool  IsCritical,
    const bool  IsTreatAsSafe,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventTypeTransparencyComputationEnd(Type,Module,AppDomainID,IsAllCritical,IsAllTransparent,IsCritical,IsTreatAsSafe,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMethodTransparencyComputationStart(void) {return EventPipeEventEnabledMethodTransparencyComputationStart();}

static inline uint32_t FireEtwMethodTransparencyComputationStart(
    const ep_char8_t*  Method,
    const ep_char8_t*  Module,
    const uint32_t  AppDomainID,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMethodTransparencyComputationStart(Method,Module,AppDomainID,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMethodTransparencyComputationEnd(void) {return EventPipeEventEnabledMethodTransparencyComputationEnd();}

static inline uint32_t FireEtwMethodTransparencyComputationEnd(
    const ep_char8_t*  Method,
    const ep_char8_t*  Module,
    const uint32_t  AppDomainID,
    const bool  IsCritical,
    const bool  IsTreatAsSafe,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMethodTransparencyComputationEnd(Method,Module,AppDomainID,IsCritical,IsTreatAsSafe,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledFieldTransparencyComputationStart(void) {return EventPipeEventEnabledFieldTransparencyComputationStart();}

static inline uint32_t FireEtwFieldTransparencyComputationStart(
    const ep_char8_t*  Field,
    const ep_char8_t*  Module,
    const uint32_t  AppDomainID,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventFieldTransparencyComputationStart(Field,Module,AppDomainID,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledFieldTransparencyComputationEnd(void) {return EventPipeEventEnabledFieldTransparencyComputationEnd();}

static inline uint32_t FireEtwFieldTransparencyComputationEnd(
    const ep_char8_t*  Field,
    const ep_char8_t*  Module,
    const uint32_t  AppDomainID,
    const bool  IsCritical,
    const bool  IsTreatAsSafe,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventFieldTransparencyComputationEnd(Field,Module,AppDomainID,IsCritical,IsTreatAsSafe,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledTokenTransparencyComputationStart(void) {return EventPipeEventEnabledTokenTransparencyComputationStart();}

static inline uint32_t FireEtwTokenTransparencyComputationStart(
    const uint32_t  Token,
    const ep_char8_t*  Module,
    const uint32_t  AppDomainID,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventTokenTransparencyComputationStart(Token,Module,AppDomainID,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledTokenTransparencyComputationEnd(void) {return EventPipeEventEnabledTokenTransparencyComputationEnd();}

static inline uint32_t FireEtwTokenTransparencyComputationEnd(
    const uint32_t  Token,
    const ep_char8_t*  Module,
    const uint32_t  AppDomainID,
    const bool  IsCritical,
    const bool  IsTreatAsSafe,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventTokenTransparencyComputationEnd(Token,Module,AppDomainID,IsCritical,IsTreatAsSafe,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledNgenBindEvent(void) {return EventPipeEventEnabledNgenBindEvent();}

static inline uint32_t FireEtwNgenBindEvent(
    const uint16_t  ClrInstanceID,
    const uint64_t  BindingID,
    const uint32_t  ReasonCode,
    const ep_char8_t*  AssemblyName,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventNgenBindEvent(ClrInstanceID,BindingID,ReasonCode,AssemblyName,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledJittedMethodRichDebugInfo(void) {return EventPipeEventEnabledJittedMethodRichDebugInfo();}

static inline uint32_t FireEtwJittedMethodRichDebugInfo(
    const uint16_t  ClrInstanceID,
    const uint64_t  MethodID,
    const uint64_t  ReJITID,
    const uint64_t  ILVersionID,
    const uint32_t  ChunkIndex,
    const uint32_t  DataSize,
    const uint8_t* Data,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventJittedMethodRichDebugInfo(ClrInstanceID,MethodID,ReJITID,ILVersionID,ChunkIndex,DataSize,Data,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledFailFast(void) {return EventPipeEventEnabledFailFast();}

static inline uint32_t FireEtwFailFast(
    const ep_char8_t*  FailFastUserMessage,
    const void*  FailedEIP,
    const uint32_t  OSExitCode,
    const uint32_t  ClrExitCode,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventFailFast(FailFastUserMessage,FailedEIP,OSExitCode,ClrExitCode,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledPrvFinalizeObject(void) {return EventPipeEventEnabledPrvFinalizeObject();}

static inline uint32_t FireEtwPrvFinalizeObject(
    const void*  TypeID,
    const void*  ObjectID,
    const uint16_t  ClrInstanceID,
    const ep_char8_t*  TypeName,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventPrvFinalizeObject(TypeID,ObjectID,ClrInstanceID,TypeName,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledCCWRefCountChangeAnsi(void) {return EventPipeEventEnabledCCWRefCountChangeAnsi();}

static inline uint32_t FireEtwCCWRefCountChangeAnsi(
    const void*  HandleID,
    const void*  ObjectID,
    const void*  COMInterfacePointer,
    const uint32_t  NewRefCount,
    const uint64_t  AppDomainID,
    const char*  ClassName,
    const char*  NameSpace,
    const ep_char8_t*  Operation,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventCCWRefCountChangeAnsi(HandleID,ObjectID,COMInterfacePointer,NewRefCount,AppDomainID,ClassName,NameSpace,Operation,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledPrvSetGCHandle(void) {return EventPipeEventEnabledPrvSetGCHandle();}

static inline uint32_t FireEtwPrvSetGCHandle(
    const void*  HandleID,
    const void*  ObjectID,
    const uint32_t  Kind,
    const uint32_t  Generation,
    const uint64_t  AppDomainID,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventPrvSetGCHandle(HandleID,ObjectID,Kind,Generation,AppDomainID,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledPrvDestroyGCHandle(void) {return EventPipeEventEnabledPrvDestroyGCHandle();}

static inline uint32_t FireEtwPrvDestroyGCHandle(
    const void*  HandleID,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventPrvDestroyGCHandle(HandleID,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledFusionMessageEvent(void) {return EventPipeEventEnabledFusionMessageEvent();}

static inline uint32_t FireEtwFusionMessageEvent(
    const uint16_t  ClrInstanceID,
    const bool  Prepend,
    const ep_char8_t*  Message,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventFusionMessageEvent(ClrInstanceID,Prepend,Message,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledFusionErrorCodeEvent(void) {return EventPipeEventEnabledFusionErrorCodeEvent();}

static inline uint32_t FireEtwFusionErrorCodeEvent(
    const uint16_t  ClrInstanceID,
    const uint32_t  Category,
    const uint32_t  ErrorCode,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventFusionErrorCodeEvent(ClrInstanceID,Category,ErrorCode,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledPinPlugAtGCTime(void) {return EventPipeEventEnabledPinPlugAtGCTime();}

static inline uint32_t FireEtwPinPlugAtGCTime(
    const void*  PlugStart,
    const void*  PlugEnd,
    const void*  GapBeforeSize,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventPinPlugAtGCTime(PlugStart,PlugEnd,GapBeforeSize,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledCCWRefCountChange(void) {return EventPipeEventEnabledCCWRefCountChange();}

static inline uint32_t FireEtwCCWRefCountChange(
    const void*  HandleID,
    const void*  ObjectID,
    const void*  COMInterfacePointer,
    const uint32_t  NewRefCount,
    const uint64_t  AppDomainID,
    const ep_char8_t*  ClassName,
    const ep_char8_t*  NameSpace,
    const ep_char8_t*  Operation,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventCCWRefCountChange(HandleID,ObjectID,COMInterfacePointer,NewRefCount,AppDomainID,ClassName,NameSpace,Operation,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledAllocRequest(void) {return EventPipeEventEnabledAllocRequest();}

static inline uint32_t FireEtwAllocRequest(
    const void*  LoaderHeapPtr,
    const void*  MemoryAddress,
    const uint32_t  RequestSize,
    const uint32_t  Unused1,
    const uint64_t  Unused2,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventAllocRequest(LoaderHeapPtr,MemoryAddress,RequestSize,Unused1,Unused2,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMulticoreJit(void) {return EventPipeEventEnabledMulticoreJit();}

static inline uint32_t FireEtwMulticoreJit(
    const uint16_t  ClrInstanceID,
    const ep_char8_t*  String1,
    const ep_char8_t*  String2,
    const int32_t  Int1,
    const int32_t  Int2,
    const int32_t  Int3,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMulticoreJit(ClrInstanceID,String1,String2,Int1,Int2,Int3,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMulticoreJitMethodCodeReturned(void) {return EventPipeEventEnabledMulticoreJitMethodCodeReturned();}

static inline uint32_t FireEtwMulticoreJitMethodCodeReturned(
    const uint16_t  ClrInstanceID,
    const uint64_t  ModuleID,
    const uint64_t  MethodID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMulticoreJitMethodCodeReturned(ClrInstanceID,ModuleID,MethodID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledIInspectableRuntimeClassName(void) {return EventPipeEventEnabledIInspectableRuntimeClassName();}

static inline uint32_t FireEtwIInspectableRuntimeClassName(
    const ep_char8_t*  TypeName,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventIInspectableRuntimeClassName(TypeName,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledWinRTUnbox(void) {return EventPipeEventEnabledWinRTUnbox();}

static inline uint32_t FireEtwWinRTUnbox(
    const ep_char8_t*  TypeName,
    const ep_char8_t*  SecondTypeName,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventWinRTUnbox(TypeName,SecondTypeName,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledCreateRCW(void) {return EventPipeEventEnabledCreateRCW();}

static inline uint32_t FireEtwCreateRCW(
    const ep_char8_t*  TypeName,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventCreateRCW(TypeName,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledRCWVariance(void) {return EventPipeEventEnabledRCWVariance();}

static inline uint32_t FireEtwRCWVariance(
    const ep_char8_t*  TypeName,
    const ep_char8_t*  InterfaceTypeName,
    const ep_char8_t*  VariantInterfaceTypeName,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventRCWVariance(TypeName,InterfaceTypeName,VariantInterfaceTypeName,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledRCWIEnumerableCasting(void) {return EventPipeEventEnabledRCWIEnumerableCasting();}

static inline uint32_t FireEtwRCWIEnumerableCasting(
    const ep_char8_t*  TypeName,
    const ep_char8_t*  SecondTypeName,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventRCWIEnumerableCasting(TypeName,SecondTypeName,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledCreateCCW(void) {return EventPipeEventEnabledCreateCCW();}

static inline uint32_t FireEtwCreateCCW(
    const ep_char8_t*  TypeName,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventCreateCCW(TypeName,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledCCWVariance(void) {return EventPipeEventEnabledCCWVariance();}

static inline uint32_t FireEtwCCWVariance(
    const ep_char8_t*  TypeName,
    const ep_char8_t*  InterfaceTypeName,
    const ep_char8_t*  VariantInterfaceTypeName,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventCCWVariance(TypeName,InterfaceTypeName,VariantInterfaceTypeName,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledObjectVariantMarshallingToNative(void) {return EventPipeEventEnabledObjectVariantMarshallingToNative();}

static inline uint32_t FireEtwObjectVariantMarshallingToNative(
    const ep_char8_t*  TypeName,
    const int32_t  Int1,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventObjectVariantMarshallingToNative(TypeName,Int1,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGetTypeFromGUID(void) {return EventPipeEventEnabledGetTypeFromGUID();}

static inline uint32_t FireEtwGetTypeFromGUID(
    const ep_char8_t*  TypeName,
    const ep_char8_t*  SecondTypeName,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGetTypeFromGUID(TypeName,SecondTypeName,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGetTypeFromProgID(void) {return EventPipeEventEnabledGetTypeFromProgID();}

static inline uint32_t FireEtwGetTypeFromProgID(
    const ep_char8_t*  TypeName,
    const ep_char8_t*  SecondTypeName,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGetTypeFromProgID(TypeName,SecondTypeName,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledConvertToCallbackEtw(void) {return EventPipeEventEnabledConvertToCallbackEtw();}

static inline uint32_t FireEtwConvertToCallbackEtw(
    const ep_char8_t*  TypeName,
    const ep_char8_t*  SecondTypeName,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventConvertToCallbackEtw(TypeName,SecondTypeName,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledBeginCreateManagedReference(void) {return EventPipeEventEnabledBeginCreateManagedReference();}

static inline uint32_t FireEtwBeginCreateManagedReference(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventBeginCreateManagedReference(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledEndCreateManagedReference(void) {return EventPipeEventEnabledEndCreateManagedReference();}

static inline uint32_t FireEtwEndCreateManagedReference(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventEndCreateManagedReference(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledObjectVariantMarshallingToManaged(void) {return EventPipeEventEnabledObjectVariantMarshallingToManaged();}

static inline uint32_t FireEtwObjectVariantMarshallingToManaged(
    const ep_char8_t*  TypeName,
    const int32_t  Int1,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventObjectVariantMarshallingToManaged(TypeName,Int1,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

__attribute__((weak)) EVENTPIPE_TRACE_CONTEXT MICROSOFT_WINDOWS_DOTNETRUNTIME_PRIVATE_PROVIDER_EVENTPIPE_Context = { W("Microsoft-Windows-DotNETRuntimePrivate"), 0, false, 0 };
static inline bool EventEnabledMonoProfilerContextLoaded(void) {return EventPipeEventEnabledMonoProfilerContextLoaded();}

static inline uint32_t FireEtwMonoProfilerContextLoaded(
    const void*  ObjectID,
    const uint64_t  AppDomainID,
    const uint64_t  ContextID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerContextLoaded(ObjectID,AppDomainID,ContextID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerContextUnloaded(void) {return EventPipeEventEnabledMonoProfilerContextUnloaded();}

static inline uint32_t FireEtwMonoProfilerContextUnloaded(
    const void*  ObjectID,
    const uint64_t  AppDomainID,
    const uint64_t  ContextID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerContextUnloaded(ObjectID,AppDomainID,ContextID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerAppDomainLoading(void) {return EventPipeEventEnabledMonoProfilerAppDomainLoading();}

static inline uint32_t FireEtwMonoProfilerAppDomainLoading(
    const uint64_t  AppDomainID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerAppDomainLoading(AppDomainID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerAppDomainLoaded(void) {return EventPipeEventEnabledMonoProfilerAppDomainLoaded();}

static inline uint32_t FireEtwMonoProfilerAppDomainLoaded(
    const uint64_t  AppDomainID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerAppDomainLoaded(AppDomainID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerAppDomainUnloading(void) {return EventPipeEventEnabledMonoProfilerAppDomainUnloading();}

static inline uint32_t FireEtwMonoProfilerAppDomainUnloading(
    const uint64_t  AppDomainID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerAppDomainUnloading(AppDomainID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerAppDomainUnloaded(void) {return EventPipeEventEnabledMonoProfilerAppDomainUnloaded();}

static inline uint32_t FireEtwMonoProfilerAppDomainUnloaded(
    const uint64_t  AppDomainID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerAppDomainUnloaded(AppDomainID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerAppDomainName(void) {return EventPipeEventEnabledMonoProfilerAppDomainName();}

static inline uint32_t FireEtwMonoProfilerAppDomainName(
    const uint64_t  AppDomainID,
    const ep_char8_t*  AppDomainName,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerAppDomainName(AppDomainID,AppDomainName,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerJitBegin(void) {return EventPipeEventEnabledMonoProfilerJitBegin();}

static inline uint32_t FireEtwMonoProfilerJitBegin(
    const uint64_t  MethodID,
    const uint64_t  ModuleID,
    const uint32_t  MethodToken,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerJitBegin(MethodID,ModuleID,MethodToken,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerJitFailed(void) {return EventPipeEventEnabledMonoProfilerJitFailed();}

static inline uint32_t FireEtwMonoProfilerJitFailed(
    const uint64_t  MethodID,
    const uint64_t  ModuleID,
    const uint32_t  MethodToken,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerJitFailed(MethodID,ModuleID,MethodToken,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerJitDone(void) {return EventPipeEventEnabledMonoProfilerJitDone();}

static inline uint32_t FireEtwMonoProfilerJitDone(
    const uint64_t  MethodID,
    const uint64_t  ModuleID,
    const uint32_t  MethodToken,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerJitDone(MethodID,ModuleID,MethodToken,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerJitDone_V1(void) {return EventPipeEventEnabledMonoProfilerJitDone_V1();}

static inline uint32_t FireEtwMonoProfilerJitDone_V1(
    const uint64_t  MethodID,
    const uint64_t  ModuleID,
    const uint32_t  MethodToken,
    const uint32_t  Count,
    int Values_ElementSize,
    const void* Values,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerJitDone_V1(MethodID,ModuleID,MethodToken,Count,Values_ElementSize, Values,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerJitChunkCreated(void) {return EventPipeEventEnabledMonoProfilerJitChunkCreated();}

static inline uint32_t FireEtwMonoProfilerJitChunkCreated(
    const void*  ChunkID,
    const uint64_t  ChunkSize,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerJitChunkCreated(ChunkID,ChunkSize,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerJitChunkDestroyed(void) {return EventPipeEventEnabledMonoProfilerJitChunkDestroyed();}

static inline uint32_t FireEtwMonoProfilerJitChunkDestroyed(
    const void*  ChunkID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerJitChunkDestroyed(ChunkID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerJitCodeBuffer(void) {return EventPipeEventEnabledMonoProfilerJitCodeBuffer();}

static inline uint32_t FireEtwMonoProfilerJitCodeBuffer(
    const void*  BufferID,
    const uint64_t  BufferSize,
    const uint8_t  BufferType,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerJitCodeBuffer(BufferID,BufferSize,BufferType,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerClassLoading(void) {return EventPipeEventEnabledMonoProfilerClassLoading();}

static inline uint32_t FireEtwMonoProfilerClassLoading(
    const uint64_t  ClassID,
    const uint64_t  ModuleID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerClassLoading(ClassID,ModuleID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerClassFailed(void) {return EventPipeEventEnabledMonoProfilerClassFailed();}

static inline uint32_t FireEtwMonoProfilerClassFailed(
    const uint64_t  ClassID,
    const uint64_t  ModuleID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerClassFailed(ClassID,ModuleID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerClassLoaded(void) {return EventPipeEventEnabledMonoProfilerClassLoaded();}

static inline uint32_t FireEtwMonoProfilerClassLoaded(
    const uint64_t  ClassID,
    const uint64_t  ModuleID,
    const ep_char8_t*  ClassName,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerClassLoaded(ClassID,ModuleID,ClassName,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerClassLoaded_V1(void) {return EventPipeEventEnabledMonoProfilerClassLoaded_V1();}

static inline uint32_t FireEtwMonoProfilerClassLoaded_V1(
    const uint64_t  ClassID,
    const uint64_t  ModuleID,
    const ep_char8_t*  ClassName,
    const uint32_t  Count,
    int Values_ElementSize,
    const void* Values,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerClassLoaded_V1(ClassID,ModuleID,ClassName,Count,Values_ElementSize, Values,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerVTableLoading(void) {return EventPipeEventEnabledMonoProfilerVTableLoading();}

static inline uint32_t FireEtwMonoProfilerVTableLoading(
    const uint64_t  VTableID,
    const uint64_t  ClassID,
    const uint64_t  AppDomainID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerVTableLoading(VTableID,ClassID,AppDomainID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerVTableFailed(void) {return EventPipeEventEnabledMonoProfilerVTableFailed();}

static inline uint32_t FireEtwMonoProfilerVTableFailed(
    const uint64_t  VTableID,
    const uint64_t  ClassID,
    const uint64_t  AppDomainID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerVTableFailed(VTableID,ClassID,AppDomainID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerVTableLoaded(void) {return EventPipeEventEnabledMonoProfilerVTableLoaded();}

static inline uint32_t FireEtwMonoProfilerVTableLoaded(
    const uint64_t  VTableID,
    const uint64_t  ClassID,
    const uint64_t  AppDomainID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerVTableLoaded(VTableID,ClassID,AppDomainID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerModuleLoading(void) {return EventPipeEventEnabledMonoProfilerModuleLoading();}

static inline uint32_t FireEtwMonoProfilerModuleLoading(
    const uint64_t  ModuleID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerModuleLoading(ModuleID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerModuleFailed(void) {return EventPipeEventEnabledMonoProfilerModuleFailed();}

static inline uint32_t FireEtwMonoProfilerModuleFailed(
    const uint64_t  ModuleID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerModuleFailed(ModuleID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerModuleLoaded(void) {return EventPipeEventEnabledMonoProfilerModuleLoaded();}

static inline uint32_t FireEtwMonoProfilerModuleLoaded(
    const uint64_t  ModuleID,
    const ep_char8_t*  ModuleName,
    const ep_char8_t*  ModuleSignature,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerModuleLoaded(ModuleID,ModuleName,ModuleSignature,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerModuleUnloading(void) {return EventPipeEventEnabledMonoProfilerModuleUnloading();}

static inline uint32_t FireEtwMonoProfilerModuleUnloading(
    const uint64_t  ModuleID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerModuleUnloading(ModuleID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerModuleUnloaded(void) {return EventPipeEventEnabledMonoProfilerModuleUnloaded();}

static inline uint32_t FireEtwMonoProfilerModuleUnloaded(
    const uint64_t  ModuleID,
    const ep_char8_t*  ModuleName,
    const ep_char8_t*  ModuleSignature,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerModuleUnloaded(ModuleID,ModuleName,ModuleSignature,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerAssemblyLoading(void) {return EventPipeEventEnabledMonoProfilerAssemblyLoading();}

static inline uint32_t FireEtwMonoProfilerAssemblyLoading(
    const uint64_t  AssemblyID,
    const uint64_t  ModuleID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerAssemblyLoading(AssemblyID,ModuleID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerAssemblyLoaded(void) {return EventPipeEventEnabledMonoProfilerAssemblyLoaded();}

static inline uint32_t FireEtwMonoProfilerAssemblyLoaded(
    const uint64_t  AssemblyID,
    const uint64_t  ModuleID,
    const ep_char8_t*  AssemblyName,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerAssemblyLoaded(AssemblyID,ModuleID,AssemblyName,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerAssemblyUnloading(void) {return EventPipeEventEnabledMonoProfilerAssemblyUnloading();}

static inline uint32_t FireEtwMonoProfilerAssemblyUnloading(
    const uint64_t  AssemblyID,
    const uint64_t  ModuleID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerAssemblyUnloading(AssemblyID,ModuleID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerAssemblyUnloaded(void) {return EventPipeEventEnabledMonoProfilerAssemblyUnloaded();}

static inline uint32_t FireEtwMonoProfilerAssemblyUnloaded(
    const uint64_t  AssemblyID,
    const uint64_t  ModuleID,
    const ep_char8_t*  AssemblyName,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerAssemblyUnloaded(AssemblyID,ModuleID,AssemblyName,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerMethodEnter(void) {return EventPipeEventEnabledMonoProfilerMethodEnter();}

static inline uint32_t FireEtwMonoProfilerMethodEnter(
    const uint64_t  MethodID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerMethodEnter(MethodID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerMethodLeave(void) {return EventPipeEventEnabledMonoProfilerMethodLeave();}

static inline uint32_t FireEtwMonoProfilerMethodLeave(
    const uint64_t  MethodID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerMethodLeave(MethodID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerMethodTailCall(void) {return EventPipeEventEnabledMonoProfilerMethodTailCall();}

static inline uint32_t FireEtwMonoProfilerMethodTailCall(
    const uint64_t  MethodID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerMethodTailCall(MethodID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerMethodExceptionLeave(void) {return EventPipeEventEnabledMonoProfilerMethodExceptionLeave();}

static inline uint32_t FireEtwMonoProfilerMethodExceptionLeave(
    const uint64_t  MethodID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerMethodExceptionLeave(MethodID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerMethodFree(void) {return EventPipeEventEnabledMonoProfilerMethodFree();}

static inline uint32_t FireEtwMonoProfilerMethodFree(
    const uint64_t  MethodID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerMethodFree(MethodID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerMethodBeginInvoke(void) {return EventPipeEventEnabledMonoProfilerMethodBeginInvoke();}

static inline uint32_t FireEtwMonoProfilerMethodBeginInvoke(
    const uint64_t  MethodID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerMethodBeginInvoke(MethodID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerMethodEndInvoke(void) {return EventPipeEventEnabledMonoProfilerMethodEndInvoke();}

static inline uint32_t FireEtwMonoProfilerMethodEndInvoke(
    const uint64_t  MethodID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerMethodEndInvoke(MethodID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerExceptionThrow(void) {return EventPipeEventEnabledMonoProfilerExceptionThrow();}

static inline uint32_t FireEtwMonoProfilerExceptionThrow(
    const uint64_t  TypeID,
    const void*  ObjectID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerExceptionThrow(TypeID,ObjectID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerExceptionClause(void) {return EventPipeEventEnabledMonoProfilerExceptionClause();}

static inline uint32_t FireEtwMonoProfilerExceptionClause(
    const uint8_t  ClauseType,
    const uint32_t  ClauseIdx,
    const uint64_t  MethodID,
    const uint64_t  TypeID,
    const void*  ObjectID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerExceptionClause(ClauseType,ClauseIdx,MethodID,TypeID,ObjectID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerGCEvent(void) {return EventPipeEventEnabledMonoProfilerGCEvent();}

static inline uint32_t FireEtwMonoProfilerGCEvent(
    const uint8_t  GCEventType,
    const uint32_t  GCGeneration,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerGCEvent(GCEventType,GCGeneration,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerGCAllocation(void) {return EventPipeEventEnabledMonoProfilerGCAllocation();}

static inline uint32_t FireEtwMonoProfilerGCAllocation(
    const uint64_t  VTableID,
    const void*  ObjectID,
    const uint64_t  ObjectSize,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerGCAllocation(VTableID,ObjectID,ObjectSize,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerGCMoves(void) {return EventPipeEventEnabledMonoProfilerGCMoves();}

static inline uint32_t FireEtwMonoProfilerGCMoves(
    const uint32_t  Count,
    int Values_ElementSize,
    const void* Values,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerGCMoves(Count,Values_ElementSize, Values,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerGCResize(void) {return EventPipeEventEnabledMonoProfilerGCResize();}

static inline uint32_t FireEtwMonoProfilerGCResize(
    const uint64_t  NewSize,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerGCResize(NewSize,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerGCHandleCreated(void) {return EventPipeEventEnabledMonoProfilerGCHandleCreated();}

static inline uint32_t FireEtwMonoProfilerGCHandleCreated(
    const uint64_t  HandleID,
    const uint8_t  HandleType,
    const void*  ObjectID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerGCHandleCreated(HandleID,HandleType,ObjectID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerGCHandleDeleted(void) {return EventPipeEventEnabledMonoProfilerGCHandleDeleted();}

static inline uint32_t FireEtwMonoProfilerGCHandleDeleted(
    const uint64_t  HandleID,
    const uint8_t  HandleType,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerGCHandleDeleted(HandleID,HandleType,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerGCFinalizing(void) {return EventPipeEventEnabledMonoProfilerGCFinalizing();}

static inline uint32_t FireEtwMonoProfilerGCFinalizing(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerGCFinalizing(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerGCFinalized(void) {return EventPipeEventEnabledMonoProfilerGCFinalized();}

static inline uint32_t FireEtwMonoProfilerGCFinalized(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerGCFinalized(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerGCFinalizingObject(void) {return EventPipeEventEnabledMonoProfilerGCFinalizingObject();}

static inline uint32_t FireEtwMonoProfilerGCFinalizingObject(
    const void*  ObjectID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerGCFinalizingObject(ObjectID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerGCFinalizedObject(void) {return EventPipeEventEnabledMonoProfilerGCFinalizedObject();}

static inline uint32_t FireEtwMonoProfilerGCFinalizedObject(
    const void*  ObjectID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerGCFinalizedObject(ObjectID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerGCRootRegister(void) {return EventPipeEventEnabledMonoProfilerGCRootRegister();}

static inline uint32_t FireEtwMonoProfilerGCRootRegister(
    const void*  RootID,
    const uint64_t  RootSize,
    const uint8_t  RootType,
    const uint64_t  RootKeyID,
    const ep_char8_t*  RootKeyName,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerGCRootRegister(RootID,RootSize,RootType,RootKeyID,RootKeyName,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerGCRootUnregister(void) {return EventPipeEventEnabledMonoProfilerGCRootUnregister();}

static inline uint32_t FireEtwMonoProfilerGCRootUnregister(
    const void*  RootID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerGCRootUnregister(RootID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerGCRoots(void) {return EventPipeEventEnabledMonoProfilerGCRoots();}

static inline uint32_t FireEtwMonoProfilerGCRoots(
    const uint32_t  Count,
    int Values_ElementSize,
    const void* Values,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerGCRoots(Count,Values_ElementSize, Values,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerGCHeapDumpStart(void) {return EventPipeEventEnabledMonoProfilerGCHeapDumpStart();}

static inline uint32_t FireEtwMonoProfilerGCHeapDumpStart(
    const ep_char8_t*  HeapCollectParam,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerGCHeapDumpStart(HeapCollectParam,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerGCHeapDumpStop(void) {return EventPipeEventEnabledMonoProfilerGCHeapDumpStop();}

static inline uint32_t FireEtwMonoProfilerGCHeapDumpStop(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerGCHeapDumpStop(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerGCHeapDumpObjectReference(void) {return EventPipeEventEnabledMonoProfilerGCHeapDumpObjectReference();}

static inline uint32_t FireEtwMonoProfilerGCHeapDumpObjectReference(
    const void*  ObjectID,
    const uint64_t  VTableID,
    const uint64_t  ObjectSize,
    const uint8_t  ObjectGeneration,
    const uint32_t  Count,
    int Values_ElementSize,
    const void* Values,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerGCHeapDumpObjectReference(ObjectID,VTableID,ObjectSize,ObjectGeneration,Count,Values_ElementSize, Values,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerMonitorContention(void) {return EventPipeEventEnabledMonoProfilerMonitorContention();}

static inline uint32_t FireEtwMonoProfilerMonitorContention(
    const void*  ObjectID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerMonitorContention(ObjectID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerMonitorFailed(void) {return EventPipeEventEnabledMonoProfilerMonitorFailed();}

static inline uint32_t FireEtwMonoProfilerMonitorFailed(
    const void*  ObjectID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerMonitorFailed(ObjectID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerMonitorAcquired(void) {return EventPipeEventEnabledMonoProfilerMonitorAcquired();}

static inline uint32_t FireEtwMonoProfilerMonitorAcquired(
    const void*  ObjectID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerMonitorAcquired(ObjectID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerThreadStarted(void) {return EventPipeEventEnabledMonoProfilerThreadStarted();}

static inline uint32_t FireEtwMonoProfilerThreadStarted(
    const uint64_t  ThreadID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerThreadStarted(ThreadID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerThreadStopping(void) {return EventPipeEventEnabledMonoProfilerThreadStopping();}

static inline uint32_t FireEtwMonoProfilerThreadStopping(
    const uint64_t  ThreadID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerThreadStopping(ThreadID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerThreadStopped(void) {return EventPipeEventEnabledMonoProfilerThreadStopped();}

static inline uint32_t FireEtwMonoProfilerThreadStopped(
    const uint64_t  ThreadID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerThreadStopped(ThreadID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerThreadExited(void) {return EventPipeEventEnabledMonoProfilerThreadExited();}

static inline uint32_t FireEtwMonoProfilerThreadExited(
    const uint64_t  ThreadID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerThreadExited(ThreadID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerThreadName(void) {return EventPipeEventEnabledMonoProfilerThreadName();}

static inline uint32_t FireEtwMonoProfilerThreadName(
    const uint64_t  ThreadID,
    const ep_char8_t*  ThreadName,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerThreadName(ThreadID,ThreadName,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerJitDoneVerbose(void) {return EventPipeEventEnabledMonoProfilerJitDoneVerbose();}

static inline uint32_t FireEtwMonoProfilerJitDoneVerbose(
    const uint64_t  MethodID,
    const ep_char8_t*  MethodNamespace,
    const ep_char8_t*  MethodName,
    const ep_char8_t*  MethodSignature,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerJitDoneVerbose(MethodID,MethodNamespace,MethodName,MethodSignature,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerGCHeapDumpVTableClassReference(void) {return EventPipeEventEnabledMonoProfilerGCHeapDumpVTableClassReference();}

static inline uint32_t FireEtwMonoProfilerGCHeapDumpVTableClassReference(
    const uint64_t  VTableID,
    const uint64_t  ClassID,
    const uint64_t  ModuleID,
    const ep_char8_t*  ClassName,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerGCHeapDumpVTableClassReference(VTableID,ClassID,ModuleID,ClassName,ActivityId,RelatedActivityId);
    return status;
}

__attribute__((weak)) EVENTPIPE_TRACE_CONTEXT MICROSOFT_DOTNETRUNTIME_MONO_PROFILER_PROVIDER_EVENTPIPE_Context = { W("Microsoft-DotNETRuntimeMonoProfiler"), 0, false, 0 };
